// (C) Copyright 2011 Hewlett-Packard Development Company, L.P.
/**
 * This provides login and logout functions with dummy session details.
 * Set and retrieval functions for GlobalSettings provided here.
 */
define(['hp/model/Session', 'hp/view/DialogView', 'hp/core/Localizer','hp/services/Log', 'text!hpsumpages/common/logoff_shutdown.html', 'jquery'], function(session, DialogView, localizer, Log, logoffhtml) {

	var SHUTDOWN = '#hpsum-shutdown';
	var SHUTDOWN_LIST = '#hp-schedule-nodes-list';
	var OK = '#hpsum-action-ok';
	var closeHandler;
	function logOffSession(handlers) {

		var value = $('input[name=hpsum-logoff-value]:checked').val();
		var logoffdialogcontents = $(logoffhtml);
		var closeHandlers = { 
				success:function(data)
						{
							if(data.hapi.hcode == 4002)
							{
								var nodes = [], table;
								nodes = data.hapi.nodes.node;
								var contents = $(logoffhtml);
								localizer.localizeDom(contents);
								table = "<p style='font-size:14px;color:red'> Shutdown cannot be done because one or more nodes are currently doing operations that cannot be aborted. Manually abort those nodes, then proceed for "+ value +" .</p>";
								table +="<table><thead><tr><th><b>Node</b></th><th><b>Status</b></th><th><b>Username</b></th></tr> ";
								for (var idx = 0; idx < nodes.length; idx++) 
									{
										table += "<tr><td>" + '<a id="hpsum-shutdown-node-click" href="#/node' + '/show/r/Session/' + nodes[idx].node_session + '/node/' + nodes[idx].user_name + '/getdata">' + nodes[idx].node_name + '</a>'
										table += "<td>" + nodes[idx].node_state + "</td>";
										table += "<td>" + nodes[idx].user_name + "</td></tr>";
									}
									
									table += "</table>";
									$(OK).hide();
									$(SHUTDOWN_LIST).html(table);
							}
							else {
								session.eraseAll();
								if (handlers && handlers.success) {
									handlers.success({});
								}
								window.location.hash = '#/login';
								window.location.reload(true);
								if(value =='shutdown'){
									window.document.write("HPSUM Engine is Shutdown. Please restart the engine to Login.");
								}
							}
						},
			    error:function(){
			         Log.error("Error shutting down the engine");
			      }
		};
		
		new DialogView({
				contents : logoffdialogcontents,
				cancel : function() {
					return;
				}
				
			});
		
		if (value == 'logoff') {
			//close hpsum session
			session.closeSession(closeHandlers);
		} else {
			var data = { hapi: {
						force: 'false'
						}};
			session.shutDown(data,closeHandlers);
			Log.info("initiated shutdown");
		}
		
		
	}
	
	//TODO convert to module pattern
	return {
		login : function(username, password, provider, handlers) {

			session.createSession(username, password, handlers);
		},
        logout : function (authToken, handlers) {
        	
			var logoffdialogcontents = $(logoffhtml);
			localizer.localizeDom(logoffdialogcontents);
			closeHandler = {
															
						success : function(data) {
							var nodes = [], table, sched_flag = "no";
							nodes = data.hapi.output_data.nodes.node;
							if(nodes)
							{
								var contents = $(logoffhtml);
								localizer.localizeDom(contents);
								table = "<p>The following nodes are scheduled for deployment. The deployments for these nodes will occur at the scheduled time even if HP SUM engine is shutdown:</p>";
								table +="<table><thead><tr><th><b>Node Name</b></th><th><b>Schedule DateTime</b></th></tr> ";
								for (var idx = 0; idx < nodes.length; idx++) 
								{
									if (nodes[idx].node_phase.match(/Scheduled/i) && nodes[idx].node_state.match(/SCHEDULED/i))
									{   
										var schedule_date_time_old = nodes[idx].schedule_date_time.split(' ');
										var schedule_time_format = schedule_date_time_old[2];
										var schedule_time = schedule_date_time_old[1];
										var schedule_time_hrs_mins = schedule_time.split(':');
										var schedule_time_hrs = schedule_time_hrs_mins[0];
										var schedule_date_time_new;
										if(schedule_time_format == 'PM')
										{
											if (schedule_time_hrs < 12)
											{
												schedule_time_hrs = parseInt(schedule_time_hrs) + 12;
												schedule_date_time_new = schedule_date_time_old[0] + ' ' + schedule_time_hrs + ':' + schedule_time_hrs_mins[1];
											}
											if (schedule_time_hrs == 12)
											{
												schedule_time_hrs = parseInt(schedule_time_hrs) + 0;
												schedule_date_time_new = schedule_date_time_old[0] + ' ' + schedule_time_hrs + ':' + schedule_time_hrs_mins[1];
											}
										}
										if(schedule_time_format == 'AM')
										{
											if (schedule_time_hrs < 12)
											{
												schedule_time_hrs = parseInt(schedule_time_hrs) + 0;
												if(schedule_time_hrs < 10)
													schedule_date_time_new = schedule_date_time_old[0] + ' ' + '0' +schedule_time_hrs + ':' + schedule_time_hrs_mins[1];
												else
													schedule_date_time_new = schedule_date_time_old[0] + ' ' +schedule_time_hrs + ':' + schedule_time_hrs_mins[1];
											}
											if (schedule_time_hrs == 12)
											{
												schedule_time_hrs = parseInt(schedule_time_hrs) - 12;
												schedule_date_time_new = schedule_date_time_old[0] + ' ' + '0'+ schedule_time_hrs + ':' + schedule_time_hrs_mins[1];
											}
										}
										table += "<tr><td>" + nodes[idx].node_name + "</td>";
										table += "<td>" + schedule_date_time_new + "</td></tr>";
										sched_flag = "yes";
									}
								}
								table += "</table>";
								if(sched_flag == "yes")
									$(SHUTDOWN_LIST).html(table);
							}
							else
							{
							}
						},
						error : function() {
						}
					};
			$(SHUTDOWN,logoffdialogcontents).on("click" ,function() 
			{
			
							$.ajax({	url : "/session/" + authToken + "/node/index",
										type : 'GET',
										contentType : "application/json",
										dataType : "json",
										success : closeHandler.success,
										error : closeHandler.error,
										headers : {
											"Accept-language" : '',
											"Session-ID" : authToken,
											"Session-KeepAlive": true
										}
									});
					 
			});
			new DialogView({
				contents : logoffdialogcontents,
				ok : function() {
					logOffSession(handlers);
				},
				cancel : function() {
					return;
				}
				
			});
        },
		getGlobalSettings : function (handlers) {
            setTimeout(function() {
                handlers.success({"allowLocalLogin":true,"defaultLoginDomain":{"name":"LOCAL","uri":"","loginDomain":"0"},"configuredLoginDomains":[]});
            }, 10)
        },
        setGlobalSettings : function (allowLocalLogin, defaultProviderId, handlers) {
            //REST.putObject('/authn/rest/authentication/globalsettings',
            //        {"allowLocalLogin": allowLocalLogin, "defaultProvider":{"providerId": defaultProviderId}},
            //        null, handlers);
            handlers.error({errorMessage: "authn.setGlobalSettings() not Implemented"})
        }
    };
});
