// (C) Copyright 2011 Hewlett-Packard Development Company, L.P.
/**
 * @type (BaselineCustomView)
 * This is a view class for Custom Baseline Add menu option.
 */
define(['hpsum/presenter/baseline/BaselinePresenter',
	'hp/core/Router',
    'hp/core/Notifications',
	'hp/core/HelpMenu',
    'hp/core/Localizer',
    'hp/view/DialogView',
    'hpsum/presenter/baseline/BaselinePresenter',
    'hp/view/FormStateView',
    'hp/model/Session',
    'hp/view/DialogView',
	'hp/lib/jquery.hpTooltip',
    'text!hpsumpages/common/confirm_dialog.html',
    'jquery',
    'hp/lib/jquery.hpStackedPanels',
    'lib/jquery.selectBox',
    'lib/jquery.dataTables',
    'hp/lib/jquery.hpCollapsible',
    'hp/lib/jquery.hpToggle',
	'hp/lib/jquery.hpSearchCombo',
	'lib/jquery.jstree',
	'lib/jquery-ui-timepicker-addon'],
function(presenter, router, notifications, helpMenu, localizer, DialogView, BaselinePresenter, FormStateView, session, dialogview, dialogContent) { "use strict";

    var BaselineCustomView = (function() {
      
        var FORM = '#hpsum-custom-baselines-add-form',
        	SAVEAS = '#hpsum-custom-baselines-saveas',
        	CREATE = '#hpsum-custom-baselines-create',
        	RESET = '#hpsum-baselines-reset',
            CANCEL = '#hpsum-custon-baselines-close',
			ADDBASELINE = '#hpsum-cbl-add-baseline-button',
			PANEL_SELECTOR = '#hpsum-cbl-panel-selector',
			COMPONENT_TYPE = '#component-type',
            PANELS = '#hpsum-custom-baselines-panels',
			COLLAPSE = '#hpsum-custom-baseline-collapsible',
			COLLAPSE_SYSTEM = '#hpsum-custom-baseline-collapsible-system',
			COLLAPSE_STORAGE = '#hpsum-custom-baseline-collapsible-storage',
			COLLAPSE_NIC = '#hpsum-custom-baseline-collapsible-nic',
			COLLAPSE_FCHBA = '#hpsum-custom-baseline-collapsible-fchba',
			COLLAPSE_ADVFILTERS = '#hpsum-custom-baseline-collapsible-advfilters',
			COLLAPSE_ARCH = '#hpsum-custom-baseline-collapsible-arch',
			COLLAPSE_DEVTYPE = '#hpsum-custom-baseline-collapsible-devtype',
			COLLAPSE_OSTYPE = '#hpsum-custom-baseline-collapsible-ostype',
			COLLAPSE_HWTYPE = '#hpsum-custom-baseline-collapsible-hardwaretype',
			COLLAPSE_HWTYPE_DL = '#hpsum-custom-baseline-collapsible-hardwaretype-DL',
			COLLAPSE_HWTYPE_ML = '#hpsum-custom-baseline-collapsible-hardwaretype-ML',
			COLLAPSE_HWTYPE_BL = '#hpsum-custom-baseline-collapsible-hardwaretype-BL',
			COLLAPSE_HWTYPE_SL = '#hpsum-custom-baseline-collapsible-hardwaretype-SL',
			COLLAPSE_HWTYPE_XL = '#hpsum-custom-baseline-collapsible-hardwaretype-XL',
			//COLLAPSE_SERVER = '#hpsum-custom-baseline-collapsible-server',
			DESCR = '#hpsum-custom-baselines-descr',
			VERSION = '#hpsum-custom-baselines-version',
			VERSION1 = '#hpsum-custom-baselines-version1',
			DATE_VERSION = '#hpsum-custom-baselines-datepicker-version',
			VERSION2 = '#hpsum-custom-baselines-version2',
			ROUTE_PREFIX = '/baseline/custom',
			HARDWARE_TYPE = '#hpsum-hardware-type',
			OPERATING_SYSTEM = '#hpsum-operating-system-type',
			CUSTOM_PANEL = '#hpsum-custom-baselines-panels',
			MATRIX_PATH = '#hpsum-vbl-location-path',
			LOCATION_TYPE = '#hpsum-vbl-location-type',
			PROXY_OPTIONS = '#hpsum-vbl-proxy-options',
            CSM_VERSION = '#hpsum-csm-version',
            BROWSE_MATRIX_LOCATION_BUTTON = '#hpsum-vbl-browse-location',
            BROWSE_MATRIX_LOCATION_ERROR = '#hpsum-vbl-invalid-location-error',
            TOTAL_SUMMARY = '#hpsum-vbl-total-summary',
            MISSING_SUMMARY = '#hpsum-vbl-missing-summary',
            SPLASH_DIALOG = '#hpsum-validate-wait-dialog',
            SPLASH_SPINNER = '#hpsum-validate-spinner',
            RETRIEVE_MATRIX_BUTTON = '#hpsum-baselines-getmatrix',
			MATRIX_LABEL = '#hpsum-vbl-location-label-path';
            
     	var TARGET_LOCATION = '#hpsum-custom-baselines-targetloc',
     		ISO_LOCATION = '#hpsum-custom-baselines-isoloc',
     		CREATEISO_CHKBOX = '#chkbox-createiso',
     		BOOTABLEISO_CHKBOX = '#chkbox-bootableiso',
     		MATCHMATRIXVERSION_CHKBOX = "#chkbox-match-csm-version",
     		SELECT_COMPTYPE = '#select-comptype',
     		SOURCES_TABLE = '#baseline-sources-table',
     		COMPONENTS_TABLE = '#hpsum-cbl-table-review',
     		COMPONENTS_CSM_TABLE = '#baseline-validate-table',
     		BASELINE_NAME_LABEL = '#hpsum-custom-baselines-id',
     		TARGET_BROWSE_BUTTON = '#hpsum-cbl-browse-target',
     		ISO_BROWSE_BUTTON = '#hpsum-cbl-browse-iso',
            BROWSE_TREE = '#browse',
            BROWSE_DIALOG = '#hpsum-browse-dialog',
			CONFIRM_DIALOG= '#hpsum-confirm-dialog',
            BROWSE_OK='#hp-baseline-add-ok',
	    	NO_COMP_SELECTED = true,
	    	MAX_DESCR_LENGTH = 50,
	    	MAX_VER_LENGTH = 10,
		ENTER_KEY = 13,		
		baslinesAdded = 0;
		var filtered_comp_list = [];
        /**
         * Constructor
         */
        function BaselineCustomView() {
            var berror = false;
			var errorDetails = '';
			var addInProgress = false;
			var operating_system_new = new Array();
			var hardware_checked_final = new Array();
			var operating_system_final = new Array();
			var components_new = new Array();
			var components_operating_system = new Array();
			var hardware_info = new Array();
			var operating_system_array = new Array();
			var operating_system_info;
            var browseDialogContents;
			var confirmDialogContents;
            var selectedTablesID = [];
            var filtered_comp_list = {};
            var compDoneCount = 0;
            var comp_selector_list;
            var compTimer;
            var updatingCompTable = false;
			var operating_system_list;
			var dl_array = [];
			var ml_array = [];
			var bl_array = [];
			var sl_array = [];
			var xl_array = [];
			var list_os;
			var bundle_os_id;
			var waitDialog;
			var proxyOptionValue;
			var csmfilterselected = false;
			var nodeTable = null; 
			var flag = false;
            var CreateCustomBaselinehandlers =	{
                    			success : function(data) {
                        			createCustomBaselineOnCreateSuccess(data);
                    		 	},
                    			error : function(errorInfo) {
                        			createCustomBaselineError(errorInfo);
                    			}
                		};
            
            var formStateView = new FormStateView();
            var oTableBaselines;
          
            function onItemAddSuccess(item) {
                
            }

            /**
             * @private
             */
            function onItemAddError(errorMessage) {
                notifications.show(errorMessage, 'error');
                addInProgress = false;
                $(CANCEL).trigger('click');
            }

            
            
            /**
             * @private
             * Call presenter's addItem() to add a new baseline item into Indexservice
             */
            function onCreate(bsaveas) {
				//Validate the input before proceeding with adding new custom baseline
				var berror = false;
				var errorDetails = '';
				var descr = $(DESCR).val(); 
				if (descr.length <= 0 )
				{
					$('#hpsum-cbl-descr-error').html(localizer.getString("hpsum.baseline.custom.descriptionRequired"));
					berror = true;
					errorDetails = '<p>' + localizer.getString("hpsum.baseline.custom.descriptionRequired") + '</p>';
				}
				
				if (descr.length > MAX_DESCR_LENGTH) { 
		 			$('#hpsum-cbl-descr-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + MAX_DESCR_LENGTH);
		 			berror = true;
					errorDetails = '<p>' + localizer.getString("hpsum.baseline.custom.maxlen") + MAX_DESCR_LENGTH + '</p>';
				}
				
				if($(VERSION2).val().length <= 0)
				{
					$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.versionRequired"));
					berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.versionRequired") + '</p>';
				}
				
				if($(VERSION2).val().length > MAX_VER_LENGTH)
				{
					$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + MAX_VER_LENGTH);
					berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.maxlen") + MAX_VER_LENGTH + '</p>';
				}
				
				if($(TARGET_LOCATION).val().length <= 0)
				{
					$('#hpsum-cbl-targetloc-error').html(localizer.getString("hpsum.baseline.custom.targetlocRequired"));
					berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.targetlocRequired") + '</p>';
				}

				var descrcheck = /^[\w\-\s]+$/;   
					
			    if ( !descrcheck.test(descr) )
			    {       				
			    	$('#hpsum-cbl-descr-error').html(localizer.getString("hpsum.baseline.custom.descriptionValidationMsg"));
		 			berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.descriptionError") + localizer.getString("hpsum.baseline.custom.descriptionValidationMsg") + '</p>';
		 		}
				
				//var versioncheck = /^[\d]+$/;   
					
			   // if ( !versioncheck.test($(VERSION2).val()) )
			    if ($(VERSION2).val() == '')
			    {       				
			    	$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.versionIdentifierError"));
		 			berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.versionError") + localizer.getString("hpsum.baseline.custom.versionIdentifierError") + '</p>';
		 		}
				
				if($(BOOTABLEISO_CHKBOX)[0].checked && $(ISO_LOCATION).val().length <= 0)
				{
					$('#hpsum-cbl-isoloc-error').html(localizer.getString("hpsum.baseline.custom.isolocRequired"));
					berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.isolocRequired") + '</p>';
				}
				
				if(berror)
				{
					formStateView.setMessage({
                                summary: localizer.getString("hpsum.baseline.custom.validationErrorMsg"),
                                status: 'error',
                                details: errorDetails});
                                
					return false;
				}
					
				var verstr = $(DATE_VERSION).val();
				verstr = verstr.replace(/\-/g, '.');
				verstr = verstr + '.' + $(VERSION2).val();
				
				var bundlename = $(BASELINE_NAME_LABEL).html();
				
				var criticalityopt = '';
				if($('#chkbox-critical')[0].checked)
				{
					criticalityopt = "critical";
				}
				
				if($('#chkbox-recommended')[0].checked){
					if(criticalityopt.length > 0)
						criticalityopt += "|" + "recommended";
					else
						criticalityopt = "recommended";
				}
				
				if($('#chkbox-optional')[0].checked){
					if(criticalityopt.length > 0)
						criticalityopt += "|" + "optional";
					else
						criticalityopt = "optional";
				}
				
				var oslist = [], devicelist = [];
				//if($('#chkbox-os-win2k3r2')[0].checked) {
				//	oslist.push('Window2003');
				//}
				
				var updatetype='';
				
				if($(SELECT_COMPTYPE).val().toLowerCase().match(/both/i))
                {
                	updatetype = 'software|firmware';	
                }
                
                if($(SELECT_COMPTYPE).val().toLowerCase().match(/software/i))
                {
                	updatetype = "software";
                }
                
                if($(SELECT_COMPTYPE).val().toLowerCase().match(/firmware/i))
                {
                	updatetype = "firmware";
                }
				
				var isolocation = $(ISO_LOCATION).val();
				var targetlocation = $('#hpsum-custom-baselines-targetloc').val();
				
				var bcreateiso = false, bbootableiso = false;
				if($(CREATEISO_CHKBOX)[0].checked)
					bcreateiso = true;
					
				if($('#chkbox-bootableiso')[0].checked)
					bbootableiso = true;
				
					
				var archopt='';
				if($('#chkbox-arch-x86')[0].checked)
				{
					archopt = "x86";
				}
				
				if($('#chkbox-arch-x64')[0].checked){
					if(archopt.length > 0)
						archopt += "|" + "x64";
					else
						archopt = "x64";
				}
				
				var serverlist = [];
				/*if($('#chkbox-server-dl380')[0].checked) {
					serverlist.push('Window2003')
				}*/
				
				var selBaselines = [];
				
				for(var i=0; i < selectedTablesID.length; i++)
				{
					var oTable = $(selectedTablesID[i].table_id).dataTable();
					if(oTable == undefined)
						continue;
					
					// This will clear out search strings and will repopulate all the rows
					oTable.fnFilter('');
					
					var allRows = $(selectedTablesID[i].table_id + ' tbody tr');
					
					var comps = oTable.fnGetData();
					var components = [];
					
					for(var tmp=0; tmp < allRows.length; tmp++){
		 				var compData = oTable.fnGetData(allRows[tmp].rowIndex-1);
		 				
		 				var bselected = false, bforce = false;
		 				
		 				if(allRows[tmp].className.indexOf('hp-selected') != -1)
		 					bselected = true;
		 				else
		 					bselected = false;
		 					
		 				if(bselected && (compData.baselineid === selectedTablesID[i].baseline))
		 					components.push(compData.component_file_name);
		 			}
					
					var baselineinfo = {
					          baseline_name : selectedTablesID[i].baseline,
					          component: components
					       };
					
					selBaselines.push(baselineinfo);	
				}
				
				if(bsaveas) {
					bcreateiso = false;
					bbootableiso = false;
					CreateCustomBaselinehandlers.success = function(data) {
                    			createCustomBaselineOnSaveSuccess(data);
                    	 	};
				} else {
					CreateCustomBaselinehandlers.success = function(data) {
                    			createCustomBaselineOnCreateSuccess(data);
                    	 	};
				}
								
				var item = {
					  hapi: {
					    bundle_name: bundlename,
					    bundle_header: descr,
					    criticality: criticalityopt,
					    os_type_list: {
					      os_type: oslist
					    },
					    device_type_list: {
					      device_type: devicelist
					    },
					    update_type: updatetype,
					    target_location: targetlocation,
					    iso_location: isolocation,
					    create_ISO: bcreateiso,
					    bootable_ISO: bbootableiso,
					    version: verstr,
					    architecture: archopt,
					    server_type_list: {
					      server_name: serverlist
					    },
					    baseline_list: {
					      baseline: selBaselines
					    }
					  }
					}; 
				
				if(! addInProgress) {
                    addInProgress = true;
                    $("#hpsum-custom-baselines-add-form :input").prop("disabled", true);
                    
                    formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.createCBLMsg"),
                        status: 'unknown', changing: true});
                    
                    presenter.createCustomBaseline(item, CreateCustomBaselinehandlers);
                    
                    formStateView.reset();
                    
                    if($('#chkbox-runinback')[0].checked){
                    	$(CANCEL).trigger('click');
                    }
                    
                }
				
				return false;
            }
            
            function createCustomBaselineOnSaveSuccess(data) {
            	
            	formStateView.setMessage({
                                summary: localizer.getString("hpsum.baseline.custom.createCBLMsgSuccess"),
                                status: 'ok',
                                details: ''});
                
				if($('#chkbox-runinback')[0].checked == false){
					var eventType = "SAVE";	
                	cblCreateStatusUpdate(data, eventType);
					}
                	
            }
			function createCustomBaselineOnCreateSuccess(data) {
            	
            	formStateView.setMessage({
                                summary: localizer.getString("hpsum.baseline.custom.createCBLMsgSuccess"),
                                status: 'ok',
                                details: ''});
                
                if($('#chkbox-runinback')[0].checked == false){
					var eventType = "CREATE";	
                	cblCreateStatusUpdate(data, eventType);
					}
                	
            }
            
            function cblCreateStatusUpdate(data, eventType){
            	
            	var bStopTimer = false, message;
            	
				if(eventType == "SAVE")
					message = localizer.getString("hpsum.baseline.custom.customSaveMsgSuccess");
				else
					message = localizer.getString("hpsum.baseline.custom.customCreateMsgSuccess");
				
            	var timer = setInterval(function () {
            		BaselinePresenter.getCustomBaselineStatus(data, {
            					success : function(data) {
                    				formStateView.setMessage({
		                                summary: data.hapi.location_state.replace(/_/g, ' '),
		                                status: 'ok',
		                                changing: true,
		                                details: data.hapi.location_info}
		                            );
									
                    				if(data.hapi.location_state === "custom_baseline_creation_completed" || data.hapi.location_state === "custom_baseline_creation_completed_with_error") {
										
										if(data.hapi.location_state === "custom_baseline_creation_completed")
										{
											var finalStatus = 'ok';
										}
										else
										{
											var finalStatus = 'error';
										}
                    					formStateView.setMessage({
			                                summary: data.hapi.location_state.replace(/_/g, ' '),
			                                status: finalStatus,
			                                changing: false,
			                                details: data.hapi.location_info
			                                }
		                              	);
		                              	
		                              	clearInterval(timer);
	                					timer = null;
										
										if(data.hapi.location_state === "custom_baseline_creation_completed")
										{
											if(eventType == "SAVE")
											{
												presenter.addItem({
												location:$(TARGET_LOCATION).val(),
												username:"",
												password:"",
												locationType:"local",
												proxy_settings:""},{
												success : onItemAddSuccess,
												error : onItemAddError
												});
											}
										}
										addInProgress = false;
	                					$("#hpsum-custom-baselines-add-form :input").prop("disabled", false);
	                					reset(false);
	                					enableAll();
	                				}
                    			},
                    			error : function(errorInfo) {
                        			formStateView.setMessage({
		                                summary: data.hapi.location_info,
		                                status: 'error',
		                                changing: false,
		                                details: data.hapi.location_state
		                                }
		                            );
		                            
		                            clearInterval(timer);
	                				timer = null;
                    			}
                			});
                }, 3000);
            }
            
            function createCustomBaselineError(errorinfo) {
            	addInProgress = false;
            	
            	formStateView.setMessage({
                                summary: localizer.getString("hpsum.baseline.custom.createCBLMsgError"),
                                status: 'error',
                                details: errorinfo});
                
                $("#hpsum-custom-baselines-add-form :input").prop("disabled", false);
                enableAll();
            }
            
			function changeLocation(location) {
                if (location.length > ROUTE_PREFIX.length) {
                    $(PANELS).hpStackedPanels('setPanelByLocation', '#' + location);
                } else {
                    $(PANELS).hpStackedPanels('setFirstPanel');
                }
            }
			
			function onAddBaseline() {
                if(addInProgress)
                	return;
                
                selectedTablesID = [];
                filtered_comp_list.length = 0;

                if(csmfilterselected)
                {
                	validateAgainstCSM();
                	return;
                }

                
                var bfirmware, bsoftware;
                if($(SELECT_COMPTYPE).val().toLowerCase().match(/both/i))
                {
                	bfirmware = true;
                	bsoftware = true;
                }
                
                if($(SELECT_COMPTYPE).val().toLowerCase().match(/software/i))
                {
                	bfirmware = false;
                	bsoftware = true;
                }
                
                if($(SELECT_COMPTYPE).val().toLowerCase().match(/firmware/i))
                {
                	bfirmware = true;
                	bsoftware = false;
                }
            		
                var val;
				
                //filters list
                var filters = {
                	firmware: bfirmware,
                	software: bsoftware,
                	critical: val = $('#chkbox-critical')[0].checked ? true : false,
                	recommended: val = $('#chkbox-recommended')[0].checked ? true : false,
                	optional: val = $('#chkbox-optional')[0].checked ? true : false,
                	arch_x86: val = $('#chkbox-arch-x86')[0].checked ? true : false,
                	arch_x64: val = $('#chkbox-arch-x64')[0].checked ? true : false,
                	//os_win2003r2: val = $('#chkbox-os-win2k3r2')[0].checked ? true : false,
                	/*os_win2008: val = $('#chkbox-os-win2k8')[0].checked ? true : false,
                	os_win2008r2: val = $('#chkbox-os-win2k8r2')[0].checked ? true : false,
                	os_win2012: val = $('#chkbox-os-win2012')[0].checked ? true : false,
                	os_rhel5: val = $('#chkbox-os-rhel5')[0].checked ? true : false,
                	os_rhel6: val = $('#chkbox-os-rhel6')[0].checked ? true : false,
                	os_sles10: val = $('#chkbox-os-sles10')[0].checked ? true : false,
                	os_sles11: val = $('#chkbox-os-sles11')[0].checked ? true : false,
                	os_vmware50: val = $('#chkbox-os-vmware50')[0].checked ? true : false,
                	os_vmware51: val = $('#chkbox-os-vmware51')[0].checked ? true : false,
                	os_vmware55: val = $('#chkbox-os-vmware55')[0].checked ? true : false,*/
                	//device_server: val = $('#chkbox-dev-server')[0].checked ? true : false,
                	device_oa: val = $('#chkbox-dev-oa')[0].checked ? true : false,
                	device_ilo: val = $('#chkbox-dev-ilo')[0].checked ? true : false,
                	device_nic: val = $('#chkbox-dev-nic')[0].checked ? true : false,
                	device_fchba: val = $('#chkbox-dev-fchbacna')[0].checked ? true : false,
                	device_arrayctrl: val = $('#chkbox-dev-arrayctrl')[0].checked ? true : false,
                	device_vc: val = $('#chkbox-dev-vc')[0].checked ? true : false,
                	device_sasswitches: val = $('#chkbox-dev-sasswitches')[0].checked ? true : false,
                	device_systemrom: val = $('#chkbox-dev-systemrom')[0].checked ? true : false,
                	device_tape: val = $('#chkbox-dev-tape')[0].checked ? true : false,
                	device_fcswitches: val = $('#chkbox-dev-fcswitches')[0].checked ? true : false,
					
                	device_harddrive: val = $('#chkbox-dev-harddrive')[0].checked ? true : false,
					
                	
					//}
                	//server_dl380: val = $('#chkbox-server-dl380')[0].checked ? true : false,
                	//server_dl360: val = $('#chkbox-server-dl360')[0].checked ? true : false
                };
                
                populateComponents(filters);
                
                enableActionButtons();
            }
            
            function populateBaselines() {
            	
            	
            	formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.populateSourcesMsg"), status: 'ok', changing: true});
            	
            	if(oTableBaselines)
				{
					oTableBaselines.fnClearTable();
				}
				
            	//get all the baselines based on filter condition
            	var handlers =	{
                    			success : function(data) {
                        			getBaselineSuccess(data);
                    		 	},
                    			error : function(errorInfo) {
                    				formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.populateSourcesErrorMsg") + errorInfo, status: 'error', changing: true});
                        			getBaselineError(errorInfo);
                    			}
                		};
                
                BaselinePresenter.getBaselinesAll(handlers);
            }
            
            function getBaselineSuccess(baselines) {
            	
            	if(oTableBaselines)
            	{
            		var HAS_AVAIABLE_BASELINE=false;

            		for(var i=0; i < baselines.length; i++)
            		{
            			if( baselines[i].baseline_state === "inventory_completed") {
            				HAS_AVAIABLE_BASELINE=true;
            				break;
            			}
            				//We shall show the warning and close this dialog
           			 
           			}

           			if(HAS_AVAIABLE_BASELINE===false){
           				var dialog = new dialogview();
            			 dialog.init({
                       				 contents: confirmDialogContents,
                        				ok: function(elem) {
                            					$(CANCEL).trigger('click');
                        				}	
                    				});
            			    $('#'+'hpsum-confirmation-dialog-title').html(localizer.getString("hpsum.baseline.custom.information"));
            			    $('#'+'hpsum-confirm-text').html(localizer.getString("hpsum.baseline.custom.customCreateMsgErr"));

            				return;
           			}

            		for(var i=0; i < baselines.length; i++)
            		{
            			/*if( baselines[i].baseline_state === "inventory_in_progress" || 
	                   		baselines[i].baseline_state === "comp_download_in_progress" ||
			   				baselines[i].baseline_state === "reading_web_catalog" ||
			   				baselines[i].baseline_state === "reading_manifest_xml" ||
			   				baselines[i].baseline_state === "manifest_component_processing") {

            				//We shall show the warning and close this dialog
            			 var dialog = new dialogview();
            			 dialog.init({
                       				 contents: confirmDialogContents,
                        				ok: function(elem) {
                            					$(CANCEL).trigger('click');
                        				}	
                    				});
            			    $('#'+'hpsum-confirmation-dialog-title').html(localizer.getString("hpsum.baseline.custom.information"));
            			    $('#'+'hpsum-confirm-text').html(localizer.getString("hpsum.baseline.custom.customCreateMsgErr"));

            				return;
            			}*/
	                	if(baselines[i].baseline_state !== "inventory_completed")
	                		continue;
						var toggleId = oTableBaselines.fnGetData().length;
            			var item = [{
							select: '<input id="toggle-' + toggleId + '" type="checkbox" />',
            				name: baselines[i].baseline_name,
            				version: baselines[i].baseline_version,
            				location: baselines[i].baseline_url,
            				baselineid: baselines[i].baseline_id,
            				uri: baselines[i].baseline_uri,
            				osdata: null
            			}];
            			
            			if(baselines[i].baseline_url.indexOf("/") == 0) {
            			    $('#bootable-iso-help').html(localizer.getString("hpsum.baseline.custom.bootableisoHelp") + '<br><br>' + localizer.getString("hpsum.baseline.custom.bootableisoHelpLinux"));
            			}

            			
            			oTableBaselines.fnAddData(item);
            			$('#toggle-' + toggleId).hpToggle({
									unchecked : localizer.getString("hpsum.oneTouchUpdate.select"),
									checked : localizer.getString("hpsum.oneTouchUpdate.selected")
								});
            			//get os data for the baseline
						getOsFilter(baselines[i].baseline_uri);
            			getOSData(baselines[i].baseline_uri);
						gethardwareInfo(baselines[i].baseline_uri);
						
            		}
            		
            		$(SOURCES_TABLE + ' tbody tr').last().addClass('hp-selected');
					var lastSelect = $(SOURCES_TABLE + ' tbody tr').last()[0].innerHTML.split('"');
					var lastSelectId = '#' + lastSelect[3];
					if(lastSelectId.indexOf('hpToggle')>=0)
					lastSelectId = '#' + lastSelect[3].slice(0, -9);
					else
					lastSelectId = '#' + lastSelect[5].slice(0, -9);
					
            		$(lastSelectId).prop('checked', true);
					$(lastSelectId).trigger('change');
					
					
            		//enable selection and deselection of row
					$(SOURCES_TABLE + " tbody tr").click( function( e ) {
						//toggle row selection	
						$(this).toggleClass('hp-selected');
						var rows = $(SOURCES_TABLE + ' tbody tr');
						for (var tmp = 0; tmp < rows.length; tmp++) {
						var rowData = oTableBaselines.fnGetData(rows[tmp]._DT_RowIndex);
						for (var i=0;i<hardware_info.length ;i++)
						{
						if(rowData.baselineid === hardware_info[i].data.BaselineServerData.bundle_id)
						if(rows[tmp].className.indexOf('hp-selected') != -1)
						{
						hardware_info[i].isselected = true;
						}
						else
						{
						hardware_info[i].isselected = false;
						}
						}
						}
						gethardwaresuccess();
						for (var tmp = 0; tmp < rows.length; tmp++) {
						var rowData = oTableBaselines.fnGetData(rows[tmp]._DT_RowIndex);
						for (var i=0;i<operating_system_array.length ;i++)
						{
						list_os = operating_system_array[i].uri.split("/");

				        bundle_os_id = list_os[7];
						if(rowData.baselineid === bundle_os_id)
						if(rows[tmp].className.indexOf('hp-selected') != -1)
						{
						operating_system_array[i].isselected = true;
						}
						else
						{
						operating_system_array[i].isselected = false;
						}
						}
						}
						getossuccess();
						checkBaselineSelected();

						var selectElem = this.innerHTML.split('"');
						var selectId = '#' + selectElem[3];
						if(selectId.indexOf('hpToggle')>=0)
						selectId = '#' + selectElem[3].slice(0, -9);
						else
						selectId = '#' + selectElem[5].slice(0, -9);
						 if(this.outerHTML.match(/hp-selected/i)){
								 $(selectId).prop('checked', true);
								 $(selectId).trigger('change');
							 } else {
								 $(selectId).removeAttr('checked');
								 $(selectId).trigger('change');
							 }
						
					});	
            	}
            }
            function checkBaselineSelected()
            {
            	var selectedrows = $(SOURCES_TABLE + ' tbody tr.hp-selected');
						if(selectedrows.length > 0)
							$(ADDBASELINE).attr("disabled", false);
						else
							$(ADDBASELINE).attr("disabled", true);
            }
            function getBaselineError(error) {
                
            } 
            
            function getOSData(uri) {
            	
            	formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.populateComponentOsMsg"), status: 'ok', changing: true});
            	
            	//get all the baselines based on filter condition
            	var handlers =	{
                    			success : function(data) {
                        			getOsDataSuccess(data,uri);
                    		 	},
                    			error : function(errorInfo) {
                    				formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.populateComponentOsErrorMsg") + errorInfo, status: 'error', changing: true});
                        			getOsDataError(errorInfo);
                    			}
                		};
                
                BaselinePresenter.getOsInfo(uri,handlers);
            }
			function getOsFilter(uri)
			{
			formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.populateComponentOsMsg"), status: 'ok', changing: true});
			var handlers =	{
                    			success : function(data) {
                        			getOsFilterSuccess(data,uri);
                    		 	},
                    			error : function(errorInfo) {
                    				//formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.populateComponentOsErrorMsg") + errorInfo, status: 'error', changing: true});
                        			getOsFilterError(errorInfo);
                    			}
                		};
                
                BaselinePresenter.getosname(uri,handlers);
			}
		     function getOsFilterSuccess(data,uri)
			{
			operating_system_info = data;
			}
			function getOsFilterError(errorInfo){}
			
			function gethardwareInfo(uri) {
						var list = uri.split("/");
				        var locid = list[5];
				        var baselineid = list[7];
						var item = 	{
                				location_id: locid,
				        		baseline_id: baselineid
				        	};
			
			
			var handlers =	{
                    			success : function(data) {
                        			gethardwareInfoSuccess(data);
                    		 	},
                    			error : function(errorInfo) {
                    				
                        			gethardwareInfoError(errorInfo);
                    			}
                		};
				BaselinePresenter.getHardwareInfo(item, handlers);		
						
			}
            function gethardwareInfoSuccess (data)
			{
			
			var item = {
						isselected :false,
						data : data.hapi
						
						};
						
			
			hardware_info.push(item);
			var rows = $(SOURCES_TABLE + ' tbody tr');
						
						for (var tmp = 0; tmp < rows.length; tmp++) {
						  var rowData_initial = oTableBaselines.fnGetData(rows[tmp]._DT_RowIndex);
						  for (var i=0;i<hardware_info.length ;i++)
						{
						if(rowData_initial.baselineid === hardware_info[i].data.BaselineServerData.bundle_id)
						if(rows[tmp].className.indexOf('hp-selected') != -1)
						{
						hardware_info[i].isselected = true;
						}
						else
						{
						hardware_info[i].isselected = false;
						}
						}
						}
			gethardwaresuccess();
			}
			function gethardwaresuccess()
			{
			flag = false;
			dl_array = [];
			bl_array = [];
			ml_array = [];
			sl_array = [];
			xl_array = [];
			//var html = "<ol><fieldset>";
			for(var n=0;n<hardware_info.length;n++)
			{
			if(hardware_info[n].isselected == true)
			{
			$(ADDBASELINE).attr("disabled",false);
			//var html = "<ol><fieldset>";
			for (var l =0;l<hardware_info[n].data.BaselineServerData.servers_name.length;l++)
			{
			var hardware_name = hardware_info[n].data.BaselineServerData.servers_name[l].split(' ');
			var hardware_name_new = hardware_name[2];
			if(hardware_name_new.charAt(0) == 'D')
			{
			var hardware_dl = hardware_info[n].data.BaselineServerData.servers_name[l].slice(12);
		    var hardware_dl_new = hardware_dl.slice(0,-6);
			dl_array.push(hardware_dl_new);
			dl_array.sort();
			}
			else if (hardware_name_new.charAt(0) == 'M')
			{
		    var hardware_ml = hardware_info[n].data.BaselineServerData.servers_name[l].slice(12);
			var hardware_ml_new = hardware_ml.slice(0,-6);
			ml_array.push(hardware_ml_new);
			ml_array.sort();
			}
			else if (hardware_name_new.charAt(0) == 'B')
			{
			var hardware_bl = hardware_info[n].data.BaselineServerData.servers_name[l].slice(12);
			var hardware_bl_new = hardware_bl.slice(0,-6);
			bl_array.push(hardware_bl_new);
			bl_array.sort();
			}
			else if (hardware_name_new.charAt(0) == 'S') {
			var hardware_sl = hardware_info[n].data.BaselineServerData.servers_name[l].slice(12);
			var hardware_sl_new = hardware_sl.slice(0,-6);
			sl_array.push(hardware_sl_new);
			sl_array.sort();
			}
			else if (hardware_name_new.charAt(0) == 'X')
			{
			var hardware_xl = hardware_info[n].data.BaselineServerData.servers_name[l].slice(12);
			var hardware_xl_new = hardware_xl.slice(0,-6);
			xl_array.push(hardware_xl_new);
			xl_array.sort();
			}
			}
			var dl_count= 0;
			var dl_data ="<table>";
			dl_data += "<tr><td><input id =hpsum-select-all-dl type = checkbox></td><td>Select all</td>";
					dl_data += "<td><input id =hpsum-deselect-all-dl type = checkbox></td><td>Deselect all</td></tr>";
			for(var idx = 0;idx < dl_array.length;){
				var dl_remaining = dl_array.length - dl_count;
				if(dl_remaining > 5)
					dl_remaining = 5;
					
				dl_data += "<tr>";
				
				switch(dl_remaining)
				{
					case 5: dl_data+= "<td><input  id =\"hpsum-hardware-type-dl-"+idx+"\" class = \"hpsum-dl-hardware\" type = \"checkbox\" data-model=\""+dl_array[idx]+"\"</td><td>" + dl_array[idx]+ "</td>";
							idx++;
							dl_count++;
				    case 4: dl_data+= "<td><input  id =\"hpsum-hardware-type-dl-"+idx+"\" class = \"hpsum-dl-hardware\" type = \"checkbox\" data-model=\""+dl_array[idx]+"\"</td><td>" + dl_array[idx]+ "</td>";
							idx++;
							dl_count++;
					case 3: dl_data+= "<td><input  id =\"hpsum-hardware-type-dl-"+idx+"\" class = \"hpsum-dl-hardware\" type = \"checkbox\" data-model=\""+dl_array[idx]+"\"</td><td>" + dl_array[idx]+ "</td>";
							idx++;
							dl_count++;
					case 2: dl_data+= "<td><input  id =\"hpsum-hardware-type-dl-"+ idx +"\" class = \"hpsum-dl-hardware\" type = \"checkbox\" data-model=\""+dl_array[idx]+"\"</td><td>" + dl_array[idx]+ "</td>";
							idx++;					
							dl_count++;
					case 1: dl_data+= "<td><input  id =\"hpsum-hardware-type-dl-"+ idx +"\"  class = \"hpsum-dl-hardware\" type = \"checkbox\" data-model=\""+dl_array[idx]+"\"</td><td>" + dl_array[idx]+ "</td>";
							idx++;		
							dl_count++;
				}
				dl_data += "</tr>";
			}
			dl_data+= "</table>";
			
			$('#hpsum-hardware-DL').html(dl_data);
			var ml_count= 0;
			var ml_data ="<table>";
			ml_data += "<tr><td><input id =hpsum-select-all-ml type = checkbox></td><td>Select all</td>";
					ml_data += "<td><input id =hpsum-deselect-all-ml type = checkbox></td><td>Deselect all</td></tr>";
			for(var idx = 0;idx < ml_array.length;){
				var ml_remaining = ml_array.length - ml_count;
				if(ml_remaining > 5)
					ml_remaining = 5;
					
				ml_data += "<tr>";
				
				switch(ml_remaining)
				{
					case 5: ml_data+= "<td><input  id =\"hpsum-hardware-type-ml-"+idx+"\" class = \"hpsum-ml-hardware\" type = \"checkbox\" data-model=\""+ml_array[idx]+"\"</td><td>" + ml_array[idx]+ "</td>";
							idx++;
							ml_count++;
					case 4: ml_data+= "<td><input  id =\"hpsum-hardware-type-ml-"+idx+"\" class = \"hpsum-ml-hardware\" type = \"checkbox\" data-model=\""+ml_array[idx]+"\"</td><td>" + ml_array[idx]+ "</td>";
							idx++;
							ml_count++;
					case 3: ml_data+= "<td><input  id =\"hpsum-hardware-type-ml-"+idx+"\" class = \"hpsum-ml-hardware\" type = \"checkbox\" data-model=\""+ml_array[idx]+"\"</td><td>" + ml_array[idx]+ "</td>";
							idx++;
							ml_count++;
					case 2: ml_data+= "<td><input  id =\"hpsum-hardware-type-ml-"+ idx +"\" class = \"hpsum-ml-hardware\" type = \"checkbox\" data-model=\""+ml_array[idx]+"\"</td><td>" + ml_array[idx]+ "</td>";
							idx++;					
							ml_count++;
					case 1: ml_data+= "<td><input  id =\"hpsum-hardware-type-ml-"+ idx +"\"  class = \"hpsum-ml-hardware\" type = \"checkbox\" data-model=\""+ml_array[idx]+"\"</td><td>" + ml_array[idx]+ "</td>";
							idx++;		
							ml_count++;
				}
				ml_data += "</tr>";
			}
			ml_data+= "</table>";
			
			$('#hpsum-hardware-ML').html(ml_data);
			var bl_count= 0;
			var bl_data ="<table>";
			bl_data += "<tr><td><input id =hpsum-select-all-bl type = checkbox></td><td>Select all</td>";
					bl_data += "<td><input id =hpsum-deselect-all-bl type = checkbox></td><td>Deselect all</td></tr>";
			for(var idx = 0;idx < bl_array.length;){
				var bl_remaining = bl_array.length - bl_count;
				if(bl_remaining > 5)
					bl_remaining = 5;
					
				bl_data += "<tr>";
				
				switch(bl_remaining)
				{
					case 5: bl_data+= "<td><input  id =\"hpsum-hardware-type-bl-"+idx+"\" class = \"hpsum-bl-hardware\" type = \"checkbox\" data-model=\""+bl_array[idx]+"\"</td><td>" + bl_array[idx]+ "</td>";
							idx++;
							bl_count++;
					case 4: bl_data+= "<td><input  id =\"hpsum-hardware-type-bl-"+idx+"\" class = \"hpsum-bl-hardware\" type = \"checkbox\" data-model=\""+bl_array[idx]+"\"</td><td>" + bl_array[idx]+ "</td>";
							idx++;
							bl_count++;
					case 3: bl_data+= "<td><input  id =\"hpsum-hardware-type-bl-"+idx+"\" class = \"hpsum-bl-hardware\" type = \"checkbox\" data-model=\""+bl_array[idx]+"\"</td><td>" + bl_array[idx]+ "</td>";
							idx++;
							bl_count++;
					case 2: bl_data+= "<td><input  id =\"hpsum-hardware-type-bl-"+ idx +"\" class = \"hpsum-bl-hardware\" type = \"checkbox\" data-model=\""+bl_array[idx]+"\"</td><td>" + bl_array[idx]+ "</td>";
							idx++;					
							bl_count++;
					case 1: bl_data+= "<td><input  id =\"hpsum-hardware-type-bl-"+ idx +"\"  class = \"hpsum-bl-hardware\" type = \"checkbox\" data-model=\""+bl_array[idx]+"\"</td><td>" + bl_array[idx]+ "</td>";
							idx++;		
							bl_count++;
				}
				bl_data += "</tr>";
			}
			bl_data+= "</table>";
			
			$('#hpsum-hardware-BL').html(bl_data);
			var sl_count= 0;
			var sl_data ="<table>";
			sl_data += "<tr><td><input id =hpsum-select-all-sl type = checkbox></td><td>Select all</td>";
					sl_data += "<td><input id =hpsum-deselect-all-sl type = checkbox></td><td>Deselect all</td></tr>";
			for(var idx = 0;idx < sl_array.length;){
				var sl_remaining = sl_array.length - sl_count;
				if(sl_remaining > 5)
					sl_remaining = 5;
					
				sl_data += "<tr>";
				
				switch(sl_remaining)
				{
					case 5: sl_data+= "<td><input  id =\"hpsum-hardware-type-sl-"+idx+"\" class = \"hpsum-sl-hardware\" type = \"checkbox\" data-model=\""+sl_array[idx]+"\"</td><td>" + sl_array[idx]+ "</td>";
							idx++;
							sl_count++;
					case 4: sl_data+= "<td><input  id =\"hpsum-hardware-type-sl-"+idx+"\" class = \"hpsum-sl-hardware\" type = \"checkbox\" data-model=\""+sl_array[idx]+"\"</td><td>" + sl_array[idx]+ "</td>";
							idx++;
							sl_count++;
					case 3: sl_data+= "<td><input  id =\"hpsum-hardware-type-sl-"+idx+"\" class = \"hpsum-sl-hardware\" type = \"checkbox\" data-model=\""+sl_array[idx]+"\"</td><td>" + sl_array[idx]+ "</td>";
							idx++;
							sl_count++;
					case 2: sl_data+= "<td><input  id =\"hpsum-hardware-type-sl-"+ idx +"\" class = \"hpsum-sl-hardware\" type = \"checkbox\" data-model=\""+sl_array[idx]+"\"</td><td>" + sl_array[idx]+ "</td>";
							idx++;					
							sl_count++;
					case 1: sl_data+= "<td><input  id =\"hpsum-hardware-type-sl-"+ idx +"\"  class = \"hpsum-sl-hardware\" type = \"checkbox\" data-model=\""+sl_array[idx]+"\"</td><td>" + sl_array[idx]+ "</td>";
							idx++;		
							sl_count++;
				}
				sl_data += "</tr>";
			}
			sl_data+= "</table>";
			
			$('#hpsum-hardware-SL').html(sl_data);
			
			var xl_count= 0;
			var xl_data ="<table>";
			xl_data += "<tr><td><input id =hpsum-select-all-xl type = checkbox></td><td>Select all</td>";
					xl_data += "<td><input id =hpsum-deselect-all-xl type = checkbox></td><td>Deselect all</td></tr>";
			for(var idx = 0;idx < xl_array.length;){
				var xl_remaining = xl_array.length - xl_count;
				if(xl_remaining > 5)
					xl_remaining = 5;
					
				xl_data += "<tr>";
				
				switch(xl_remaining)
				{
					case 5: xl_data+= "<td><input  id =\"hpsum-hardware-type-xl-"+idx+"\" class = \"hpsum-xl-hardware\" type = \"checkbox\" data-model=\""+xl_array[idx]+"\"</td><td>" + xl_array[idx]+ "</td>";
							idx++;
							xl_count++;
					case 4: xl_data+= "<td><input  id =\"hpsum-hardware-type-xl-"+idx+"\" class = \"hpsum-xl-hardware\" type = \"checkbox\" data-model=\""+xl_array[idx]+"\"</td><td>" + xl_array[idx]+ "</td>";
							idx++;
							xl_count++;
					case 3: xl_data+= "<td><input  id =\"hpsum-hardware-type-xl-"+idx+"\" class = \"hpsum-xl-hardware\" type = \"checkbox\" data-model=\""+xl_array[idx]+"\"</td><td>" + xl_array[idx]+ "</td>";
							idx++;
							xl_count++;
					case 2: xl_data+= "<td><input  id =\"hpsum-hardware-type-xl-"+ idx +"\" class = \"hpsum-xl-hardware\" type = \"checkbox\" data-model=\""+xl_array[idx]+"\"</td><td>" + xl_array[idx]+ "</td>";
							idx++;					
							xl_count++;
					case 1: xl_data+= "<td><input  id =\"hpsum-hardware-type-xl-"+ idx +"\"  class = \"hpsum-xl-hardware\" type = \"checkbox\" data-model=\""+xl_array[idx]+"\"</td><td>" + xl_array[idx]+ "</td>";
							idx++;		
							xl_count++;
				}
				xl_data += "</tr>";
			}
			xl_data+= "</table>";
			
			$('#hpsum-hardware-XL').html(xl_data);
			
			//dl_data = "</table>";
			//$('#hpsum-hardware-DL').html(dl_data);
			
			if(hardware_info[n].data.BaselineServerData.disable_hardware_filter == true)
			{
			flag = true;
			}
			}
			else{
			$(ADDBASELINE).attr("disabled",true);
			}
			
			}
			if(flag)
			{
				$('#hpsum-all-hardware').hide();
				$('#hpsum-filter-error').show();
				
			}
			else
			{
			$('#hpsum-all-hardware').show();
			$('#hpsum-filter-error').hide();
			
			}

			}
			function gethardwareInfoError(errorInfo){}
            function  getOsDataSuccess(data, uri) {
			var item = {
						isselected :false,
						data : data.hapi,
						uri : uri
						
						};
						
			
			operating_system_array.push(item);
			
			
			var rows = $(SOURCES_TABLE + ' tbody tr');
						
						for (var tmp = 0; tmp < rows.length; tmp++) {
						  var rowData_initial = oTableBaselines.fnGetData(rows[tmp]._DT_RowIndex);
						  for (var i=0;i<operating_system_array.length ;i++)
						{
						list_os = operating_system_array[i].uri.split("/");

				        bundle_os_id = list_os[7];
						if(rowData_initial.baselineid === bundle_os_id)
						if(rows[tmp].className.indexOf('hp-selected') != -1)
						{
						operating_system_array[i].isselected = true;
						}
						else
						{
						operating_system_array[i].isselected = false;
						}
						}
						}
			getossuccess();
            	}
			/* To check duplicate OS names are not present in the final list to be populated in the OS type filter*/
			function isosexists()
			{
			var alreadyexists=false;
			for(var m=0;m<=operating_system_final.length;m++)
			{
			if(operating_system_final[m] === operating_system_list)
			{
				alreadyexists = true;
				break;
			}
			}
			if(!alreadyexists)
			operating_system_final.push(operating_system_list);
			}
            function getossuccess()
			{
			operating_system_final = [];
			for(var n=0;n<operating_system_array.length;n++)
			{
			if(operating_system_array[n].isselected == true)
			{
			$(ADDBASELINE).attr("disabled",false);
		    var operating_system = new Array();
			var a = true;
		    operating_system_new = new Array();
			for (var j=0;j<operating_system_array[n].data.baseline_os.os.length;j++)
			{
		    operating_system = operating_system_array[n].data.baseline_os.os[j];
			for(var k =0;k<operating_system_new.length;k++)
			{
			if(operating_system == operating_system_new[k])
				a = false;
				break;
			}
			if(a)
				operating_system_new.push(operating_system);
			}
			for (var l =0;l<operating_system_new.length;l++)
			{
			   if (operating_system_new[l].match(/Microsoft Windows Server 2008 R2/))
			   {
			   operating_system_list = "Windows 2008 R2";
			   }
			   else if (operating_system_new[l].match(/Microsoft Windows Server 2008/))
			   {
			   operating_system_list = "Windows 2008";
			   }
			   else if (operating_system_new[l].match(/Microsoft Windows Server 2012 R2/))
			   {
			   operating_system_list = "Windows 2012 R2";
			   }
			   else if (operating_system_new[l].match(/Microsoft Windows Server 2012/))
			   {
			   operating_system_list = "Windows 2012";
			   }
			   else if (operating_system_new[l].match(/Red Hat Enterprise Linux 6/))
			   {
			   operating_system_list = "RHEL 6";
			   }
			   else if (operating_system_new[l].match(/Red Hat Enterprise Linux 5/))
			   {
			   operating_system_list = "RHEL 5";
		       }
			   else if (operating_system_new[l].match(/Red Hat Enterprise Linux 7/))
			   {
			   operating_system_list = "RHEL 7";
		       }
			   else if (operating_system_new[l].match(/VMware ESXi 5.0/))
			   {
			   operating_system_list = "VMware ESXi 5.0";
			   }
			   else if (operating_system_new[l].match(/VMware vSphere 5.1/))
			   {
			   operating_system_list = "VMware ESXi 5.1";
			   }
			   else if (operating_system_new[l].match(/VMware vSphere 5.5/))
			   {
			   operating_system_list = "VMware ESXi 5.5";
			   }
			   else if (operating_system_new[l].match(/SUSE LINUX Enterprise Server 11/))
			   {
			   operating_system_list = "SLES 11";
			   }
			   else if (operating_system_new[l].match(/SUSE LINUX Enterprise Server 12/))
			   {
			   operating_system_list = "SLES 12";
			   }
			   isosexists();
			}
			operating_system_final.sort();
			var os_count= 0;
			var os_data ="<table>";
			for(var idx = 0;idx <operating_system_final.length;)
			{
				var os_remaining = operating_system_final.length - os_count;
				if(os_remaining > 4)
			    os_remaining = 4;
			    os_data += "<tr>";
				switch(os_remaining)
				{
				
					case 4: os_data+= "<td><input  id =\"hpsum-os-type-"+idx+"\" class = \"hpsum-os-info\" type = \"checkbox\" data-model=\""+operating_system_final[idx]+"\"</td><td>" + operating_system_final[idx]+ "</td>";
							idx++;
							os_count++;
					case 3: os_data+= "<td><input  id =\"hpsum-os-type-"+idx+"\" class = \"hpsum-os-info\" type = \"checkbox\" data-model=\""+operating_system_final[idx]+"\"</td><td>" + operating_system_final[idx]+ "</td>";
							idx++;
							os_count++;
					case 2: os_data+= "<td><input  id =\"hpsum-os-type-"+ idx +"\" class = \"hpsum-os-info\" type = \"checkbox\" data-model=\""+operating_system_final[idx]+"\"</td><td>" + operating_system_final[idx]+ "</td>";
							idx++;					
							os_count++;
					case 1: os_data+= "<td><input  id =\"hpsum-os-type-"+ idx +"\"  class = \"hpsum-os-info\" type = \"checkbox\" data-model=\""+operating_system_final[idx]+"\"</td><td>" + operating_system_final[idx]+ "</td>";
							idx++;		
							os_count++;
				}
				os_data += "</tr>";
			}
			os_data+= "</table>";
			$('#hpsum-operating-system-info').empty();
			$('#hpsum-operating-system-info').html(os_data);
			formStateView.reset();
			}
			else{
			$(ADDBASELINE).attr("disabled",true);
			    }
			}
            }
            
            function  getOsDataError(data) {
            }
            
            function populateComponents(filters) {
            	
            	$('#all-cbl-baselines').empty();
            	
            	//var oTableBaselines = $(SOURCES_TABLE).dataTable();
            	var baselines = [], selectedRows;
            	if(oTableBaselines)
            	{
					baselines = oTableBaselines.fnGetData();
					
					selectedRows = $(SOURCES_TABLE + ' tbody tr.hp-selected');
			 	} 
			 	
			 	var tableid = '#hpsum-cbl-table-review'; //+ nodeData.baselineid;
            	
				if(selectedRows.length>0)
				{
					$('#all-cbl-baselines').append('<input id="chkbox-hw-selectall" type="checkbox" style="padding-left:10px" />' +  
						'<label for="chkbox-hw-selectall" style="padding-right:100px">' + localizer.getString("hpsum.baseline.custom.selectall") + '</label>'); 
					$('#all-cbl-baselines').append('<input id="chkbox-hw-deselectall" type="checkbox" style="padding-left:10px" />' + 		
						'<label for="chkbox-hw-deselectall" >' + localizer.getString("hpsum.baseline.custom.deselectall") + '</label>' ); 
					$('#all-cbl-baselines').append('<table class="hp-selectable" id="hpsum-cbl-table-review"><thead><tr><td><b>'+	 localizer.getString("hpsum.oneTouchUpdate.selectComponents") + '</b></td><td><b>' + 
						localizer.getString("hpsum.baseline.addBaseline.id") + '</b></td><td><b>' +
						localizer.getString("hpsum.baseline.addBaseline.description") + '</b></td><td><b>' + 
						localizer.getString("hpsum.baseline.version") + '</b></td>' + //<td><b>' + 
						//localizer.getString("hpsum.baseline.addBaseline.configured") + '</b></td>
						'</tr></thead></table>');
				}
				
				baslinesAdded = 0;			
				
            	for(var tmp=0; tmp < selectedRows.length; tmp++){
	 				var nodeData = oTableBaselines.fnGetData(selectedRows[tmp].rowIndex-1);
	 				
	 				selectedTablesID.push({table_id : tableid, baseline: nodeData.baselineid});
                    
					//initialize table
					initBaselineTable(tableid);
					
					//populate table rows 
					populateTable(tableid, nodeData.uri, filters, nodeData.osdata, selectedRows.length);	 					
	 			}
		 	}
            
            function populateTable(tableid, uri, filters, osdata, selectedBlCount){
            	var list = uri.split("/");
				var locid = list[5];
				var baselineid = list[7];
            	
            	//get all the baselines based on filter condition
            	var handlers =	{
                    			success : function(data) {
                        			getBundleDataSuccess(data, tableid, filters, osdata, baselineid, selectedBlCount);
                        			formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.retrieveCompMsgDone"), status: 'ok', changing: false});
                    		 	},
                    			error : function(errorInfo) {
                        			getBundleDataError(errorInfo);
                        			formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.retrieveCompMsgError"), status: 'error', changing: false});
                    			}
                			};
                
                
					
                var item = 	{
                				location_id: locid,
				        		baseline_id: baselineid
				        	};
				
				formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.retrieveCompMsg"), status: 'unknown', changing: true});
                        
            	//add component rows into table based on the filters
            	BaselinePresenter.getBundleIndexData(item, handlers);
            	
            }
            
            
            function getBundleDataSuccess(data, tableid, filters, osdata, baselineid, selectedBlCount) {
            	var hardware_checked_new = new Array();
				var hardware_checked_new_dl = new Array();
				var hardware_checked_new_ml = new Array();
				var hardware_checked_new_bl = new Array();
				var hardware_checked_new_sl = new Array();
				var hardware_checked_new_xl = new Array();
				var checked_os_windows = 1;
				var checked_os_linux = 1;
				var checked_os_sles =1;
				var operating_system_checked_new = new Array();
            	var oTable = $(tableid).dataTable();
            	
            	if(!oTable)
            		return;
            	
            	var comps_matched = $.grep(data.hapi.output_data.baselines.baseline[0].components.component, function(comp, index) {
						                            return (
						                            	(filters.software === true && (comp.product_typeInString === 'Driver' || comp.product_typeInString === 'Software')) ||
						                            	(filters.firmware === true && comp.product_typeInString === 'Firmware')
						                            	);
				});
				
				if(filters.critical || filters.recommended || filters.optional) {
					comps_matched = $.grep(comps_matched, function(comp, index) {
							                            return (
							                            	(filters.critical === true && comp.criticality === 'Critical') ||
							                            	(filters.recommended === true && comp.criticality === 'Recommended') ||
							                            	(filters.optional === true && comp.criticality === 'Optional')
							                            	);
					});
				}
				
				if(filters.arch_x86 || filters.arch_x64) {
					comps_matched = $.grep(comps_matched, function(comp, index) {
							                            return (
							                            	(filters.arch_x86 === true && (comp.platform.match(/x86$/i) || comp.platform.match(/nt$/i))) ||
						                            		(filters.arch_x64 === true && (comp.platform.match(/x86_64$/i) || comp.platform.match(/ia64$/i) || comp.platform.match(/x86-64$/i) || comp.platform.match(/nt64$/i) || comp.platform.match(/amd64$/i)))
							                            	); 
					});
				}
				
				if(filters.device_oa || filters.device_nic || filters.device_ilo || filters.device_vc || filters.device_arrayctrl || 
					filters.device_sasswitches || filters.device_tape || filters.device_systemrom || filters.device_harddrive || 
					filters.device_fcswitches || filters.device_fchba) {
					comps_matched = $.grep(comps_matched, function(comp, index) {
							                            return (
							                            	(filters.device_oa === true && comp.product_subtypeInString === 'OA') ||
							                            	(filters.device_nic === true && (comp.product_subtypeInString == 'NIC' || comp.product_subtypeInString == 'Intel NIC' || comp.product_subtypeInString == 'NetXEN NIC' || comp.family.match(/nic/i) || comp.family.match(/net/i) || comp.family.match(/e1000e/i) || comp.family.match(/qlgc-utils/i) || comp.family.match(/qlgc-docs/i) 	|| comp.family.match(/igb/i) ||  comp.family.match(/ixgbe/i) || comp.family.match(/tg3/i))) ||
							                            	(filters.device_ilo === true && (comp.product_subtypeInString.indexOf('Management Processor') != -1 || comp.family.match(/ilo/i) || comp.family.match(/hponcfg/i) || comp.family.match(/hpmouse/i))) ||
							                            	(filters.device_vc === true && comp.product_subtypeInString === 'VC') ||
							                            	(filters.device_arrayctrl === true && (comp.product_subtypeInString === 'Array Controller' || comp.family.match(/cis/i) || comp.family.match(/sa/i))) ||
							                            	(filters.device_sasswitches === true && comp.product_subtypeInString === 'Solex') ||
							                            	(filters.device_tape === true && (comp.product_subtypeInString == 'Tape' || comp.family.match(/tape/i))) ||
							                            	(filters.device_systemrom === true && comp.product_subtypeInString === 'BIOS') ||
							                            	(filters.device_harddrive === true && (comp.product_subtypeInString.indexOf('Hard Drive') != -1 || comp.family.match(/scsi/i))) ||
							                            	(filters.device_fcswitches === true && (comp.product_subtypeInString == 'Brocade' || comp.product_subtypeInString == 'Cisco' || comp.product_subtypeInString == 'QLogic')) ||
							                            	(filters.device_fchba === true && (comp.product_subtypeInString == 'Brocade' || comp.product_subtypeInString == 'Emulex' || comp.product_subtypeInString == 'QLogic' || comp.family.match(/fc/i) || comp.family.match(/qla/i) || comp.family.match(/fibre/i) || comp.family.match(/storport/i) || comp.family.match(/bfa/i) || comp.family.match(/ipfc/i))) 
							                            	);
					});
				}
				
				//filter components based on OS filter 
			     for (var m=0;m<operating_system_final.length;m++)
				    {
					 
					 var value = $('#hpsum-os-type-'+m)[0].checked ? true : false;
					 if(value == true)
					 {
					 //var operating_system_checked = $('#hpsum-os-type-'+m)[0].dataset.model ;
					 var operating_system_checked = $('#hpsum-os-type-'+m).data("model");
					 if(operating_system_checked)
					 {
					 	operating_system_checked_new.push(operating_system_checked);
					 }					 
					 }
					}
					
					for(var p=0;p<operating_system_checked_new.length;p++)
					{
					for(var r=0;r<operating_system_info.hapi.components.component.length;r++)
					{
						for(var q=0;q<operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name.length;q++)
						{
							if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/Microsoft Windows Server 2008 R2/))
			                {
			                 operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "Windows 2008 R2";
			                }
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/Microsoft Windows Server 2008/))
							{
							operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "Windows 2008";
							}
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/Red Hat Enterprise Linux 6/))
							{
							operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "RHEL 6";
							}
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/Red Hat Enterprise Linux 5/))
							{
							operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "RHEL 5";
							}
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/VMware ESXi 5.0/))
							{
							operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "VMware ESXi 5.0";
							}
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/VMware vSphere 5.1/))
							{
							operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "VMware ESXi 5.1";
							}
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/VMware vSphere 5.5/))
							{
							operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "VMware ESXi 5.5";
							}
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/SUSE LINUX Enterprise Server 11/))
							{
							operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "SLES 11";
							}
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/SUSE LINUX Enterprise Server 12/))
							{
							operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "SLES 12";
							}
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/Microsoft Windows Server 2012 R2/))
			                {
			                operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "Windows 2012 R2";
			                }
							else if (operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q].match(/Microsoft Windows Server 2012/))
			                {
			                operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q]= "Windows 2012";
			                }
							if (operating_system_checked_new[p].slice(0,7) != 'Windows')
							{
							checked_os_windows = 0;
							}
							if (operating_system_checked_new[p].slice(0,4) != 'RHEL')
							{
							checked_os_linux = 0;
							}
							if (operating_system_checked_new[p].slice(0,4) != 'SLES')
							{
							checked_os_sles = 0;
							}
							if (operating_system_checked_new[p] == operating_system_info.hapi.components.component[r].operating_systems.Operating_system_name[q])
							{
								
								var components_file = operating_system_info.hapi.components.component[r].component_file_name;
								components_operating_system.push(components_file);
							}
						}
					}
					}
					
					if(components_operating_system.length > 0)
					{
					comps_matched = $.grep(comps_matched, function(comp, index) {
										
									if ($.grep(components_operating_system, function(comp2, index2) {
			                            return (comp2 === comp.component_file_name);
			                        }).length > 0) {
			                            return true;
			                        }
			                        
			                        return false;					
					});
					}
					//filter components based on Hardware filter 
					if (flag == false)
					{
					for (var m=0;m<dl_array.length;m++)
					{
						var value = $('#hpsum-hardware-type-dl-'+m)[0].checked ? true : false;
						if(value == true)
						{
							var hardware_checked_dl;
								if ( $('#hpsum-hardware-type-dl-'+m)[0].dataset !== undefined ) 
									hardware_checked_dl = $('#hpsum-hardware-type-dl-'+m)[0].dataset.model;
								else
									hardware_checked_dl = $('#hpsum-hardware-type-dl-'+m)[0].getAttribute('data-model'); 

							hardware_checked_new_dl.push(hardware_checked_dl);
						}
						
					}
					for (var m=0;m<ml_array.length;m++)
					{
						var value = $('#hpsum-hardware-type-ml-'+m)[0].checked ? true : false;
						if(value == true)
						{
							var hardware_checked_ml;
								if( $('#hpsum-hardware-type-ml-'+m)[0].dataset !== undefined )
									hardware_checked_ml = $('#hpsum-hardware-type-ml-'+m)[0].dataset.model;
								else
									hardware_checked_ml = $('#hpsum-hardware-type-ml-'+m)[0].getAttribute('data-model'); 

			                hardware_checked_new_ml.push(hardware_checked_ml);
						}
					}
					
					for (var m=0;m<bl_array.length;m++)
					{
						var value = $('#hpsum-hardware-type-bl-'+m)[0].checked ? true : false;
						if(value == true)
						{
							var hardware_checked_bl;
								if ( $('#hpsum-hardware-type-bl-'+m)[0].dataset !== undefined )
									hardware_checked_bl = $('#hpsum-hardware-type-bl-'+m)[0].dataset.model;
								else
									hardware_checked_bl = $('#hpsum-hardware-type-bl-'+m)[0].getAttribute('data-model');

							hardware_checked_new_bl.push(hardware_checked_bl);
						}
					}
					for (var m=0;m<sl_array.length;m++)
					{
						var value = $('#hpsum-hardware-type-sl-'+m)[0].checked ? true : false;
						if(value == true)
						{
							var hardware_checked_sl;
								if( $('#hpsum-hardware-type-sl-'+m)[0].dataset !== undefined )
									hardware_checked_sl = $('#hpsum-hardware-type-sl-'+m)[0].dataset.model;
								else
									hardware_checked_sl = $('#hpsum-hardware-type-sl-'+m)[0].getAttribute('data-model');
								
				        	hardware_checked_new_sl.push(hardware_checked_sl);
						}
					}
					for (var m=0;m<xl_array.length;m++)
					{
						var value = $('#hpsum-hardware-type-xl-'+m)[0].checked ? true : false;
						if(value == true)
						{
							var hardware_checked_xl;
								if( $('#hpsum-hardware-type-xl-'+m)[0].dataset !== undefined )
									hardware_checked_xl = $('#hpsum-hardware-type-xl-'+m)[0].dataset.model;
								else
									hardware_checked_xl = $('#hpsum-hardware-type-xl-'+m)[0].getAttribute('data-model');
								
				        	hardware_checked_new_xl.push(hardware_checked_xl);
						}
					}
					hardware_checked_final = hardware_checked_new_dl.concat(hardware_checked_new_bl,hardware_checked_new_ml,hardware_checked_new_sl,hardware_checked_new_xl);
					
					for(var i=0;i<hardware_info.length;i++)
					{
					if(hardware_checked_final.length > 0)
					{
						for(var j=0; j< hardware_info[i].data.BaselineServerData.platform_independent_comp_list.length;j++)
						{
							components_new.push(hardware_info[i].data.BaselineServerData.platform_independent_comp_list[j]);
						}
					}
					
					
						for (var l=0;l<hardware_info[i].data.BaselineServerData.servers_component_info.length;l++)
						{
							for (var r=0;r<hardware_checked_final.length;r++)
							{  
							
							    if(hardware_info[i].data.BaselineServerData.servers_component_info[l].system_name =="HP ProLiant"+ ' ' + hardware_checked_final[r] +"Server")
								{
								for(var j=0; j< hardware_info[i].data.BaselineServerData.servers_component_info[l].comp_list.length;j++)
								{
									components_file = hardware_info[i].data.BaselineServerData.servers_component_info[l].comp_list[j];
									components_new.push(components_file);
								}
						        
								}
							}
						}
					}
					}
							
							
					
					if(components_new.length > 0)
					{
					comps_matched = $.grep(comps_matched, function(comp, index) {
										
									if ($.grep(components_new,function(comp2, index2) {
			                            return (comp2 === comp.component_file_name);
			                        }).length > 0) {
			                            return true;
			                        }
			                        
			                        return false;					
					});
					}
					
			    if(comps_matched.length > 0)
            	{
                    //If no components have already been added, we add all components from 
                    //current baseline to the filtered components list
                    if($.isEmptyObject(filtered_comp_list)) {
                        for( var i=0; i<comps_matched.length; i++) {
                            var comp = comps_matched[i];
                            var comp_refine = comp.component_file_name.replace(/\./g,'_');
                            comp.select = '<input id="toggle-' + comp_refine + data.hapi.baseline_id + '" style="display:none" type="checkbox" checked/>';
                            comp.baselineid = baselineid;
                            filtered_comp_list[comp.component_file_name] = comp;
                        }
                    }
                    else {
                        //Components already present in the filtered components list from other baseline.
                        //Remove any duplicate components and add the rest to the filtered components list
                        for( var i=comps_matched.length-1; i>=0; i--) {
                            var comp = comps_matched[i];                           
                                var comp_refine = comp.component_file_name.replace(/\./g,'_');
                                comp.select = '<input id="toggle-' + comp_refine + data.hapi.baseline_id + '" style="display:none" type="checkbox" checked/>';
                                comp.baselineid = baselineid;
                        }
                    }		if(operating_system_checked_new.length > 0)
							{
							if (checked_os_windows == 1)
							{
							var comps_matched_temp = new Array();
							for (var w=0; w<comps_matched.length;w++)
							{
							if(comps_matched[w].component_file_name.slice(-3) != 'rpm' && comps_matched[w].component_file_name.slice(-5) != 'scexe' )
							{
							
							comps_matched_temp.push(comps_matched[w]);
							
							}
							
							}
							
							comps_matched = comps_matched_temp;
							}
							if (checked_os_linux == 1 || checked_os_sles == 1)
							{
							var comps_matched_temp = new Array();
							for (var w=0; w<comps_matched.length;w++)
							{
							if(comps_matched[w].component_file_name.slice(-4) != '.exe')
							{
							
							comps_matched_temp.push(comps_matched[w]);
							
							}
							
							}
							
							comps_matched = comps_matched_temp;
							}
									
							}
                    
                    oTable.fnAddData(comps_matched);

					$(tableid + ' tbody tr').addClass('hp-selected');
            		NO_COMP_SELECTED = false;
            		enableActionButtons();
            			
            	}
            	baslinesAdded++;
				//Bind click only after all the sekected baselines are added
				if(selectedBlCount==baslinesAdded){
                    comp_selector_list = $('input[type="checkbox"]', tableid);
                    
				$(tableid + " tbody tr").click( function( e ) {
            		var srcElem;
					//Check if firefox or (chrome and IE)
					if (e.srcElement) {
						srcElem = e.srcElement;
						//Chrome and IE
						} else {
						srcElem = e.target;
						//Firefox
						}
					var data = oTable.fnGetData(this);
					var clickedCellIndex = srcElem.cellIndex;
					if (clickedCellIndex === undefined) {
						var selectid = data.select.split('"');
						selectid ='#'+ selectid[1];//+'-hpToggle';
						if(srcElem.innerHTML.match(/Selected/i)){
							$(selectid).removeAttr('checked');
							$(selectid).trigger('change');
						} else if(srcElem.innerHTML.match(/Select/i)){
							$(selectid).prop('checked', true);
							$(selectid).trigger('change');
						}
					}
					//toggle row selection	
					$(this).toggleClass('hp-selected');	
					
					//Select toggle button changes 
					$('#chkbox-hw-selectall')[0].checked =false; 
					$('#chkbox-hw-deselectall')[0].checked =false; 
					var selectid = data.select.split('"');
					selectid='#'+selectid[1];//+'-hpToggle';
					if ($(this).hasClass('hp-selected')) {
						$(selectid).prop('checked', true);
					} else {
						$(selectid).removeAttr('checked');
					}
					$(selectid).trigger('change');
									
					var selectedRows = $(tableid + ' tbody tr');
 					    var count = 0;
 					    for (var tmp = 0; tmp < selectedRows.length; tmp++) 
 					    {
 					       	if (selectedRows[tmp].className.indexOf('hp-selected') != -1)
 					    	count++;
 					    }
 					    	
						if(count > 0)
						{
							NO_COMP_SELECTED = false;
							enableActionButtons();							
						}
						else
						{
							NO_COMP_SELECTED = true;	
							disableActionButtons();							
						}				
											
										
				});
                    //Update the component selection toggles in batches to prevent the  UI from
                    //freezing when processing a large number of components simultaneoulsy
                    if(comp_selector_list.length == 0)
                        closeFilterSplash();
                    else {
                        updatingCompTable = false;
                        compDoneCount = 0;
                        compTimer = setInterval(function(){updateCompTableToggles()}, 1000);
                    }
            	}
            }
            
            function updateCompTableToggles() {
                
                if(updatingCompTable)
                    return;
                
                updatingCompTable = true;
                var toDoCounter = compDoneCount + 100;
                for(var i = compDoneCount; i < toDoCounter; i++) {
                    $(comp_selector_list[i]).hpToggle({
                        unchecked : localizer.getString("hpsum.oneTouchUpdate.select"),
                        checked : localizer.getString("hpsum.oneTouchUpdate.selected")
                    });
                    compDoneCount++;
                    if(compDoneCount == comp_selector_list.length) {
                        clearInterval(compTimer);
                        closeFilterSplash();
                        break;
                    }
                }
                updatingCompTable = false;
                return;
            }
            
            function showFilterSplash(){
                
                 $('#hpsum-filter-dialog').dialog({
                    modal : true,
                    position : "center",
                    draggable : false,
                    resizable : false,
                    show : 'fade',
                    dialogClass : 'hp-splash-dialog',
                    width : 400
                });
                
                $('#hpsum-filter-spinner').show();   
            }
            
            function closeFilterSplash()
            {
                $('#hpsum-filter-spinner').hide();
                $('#hpsum-filter-dialog').dialog().dialog('destroy');
            }
            
            function getBundleDataError(error) {
                closeFilterSplash();
            }
            
            //Initialize install review table to add all the components
            function initBaselineTable(tableid) {
            	
            	var data = [{
							select:'',
            				component_file_name: 'cp0000.exe',
            				package_name: 'HP Package',
            				component_version: '2012.10.10',
							baselineid: '',
                			Configured: 'Yes'}];
				    
				var oTab = $(tableid).dataTable({
					oLanguage: {
					    sEmptyTable: localizer.getString('hpsum.baseline.custom.noMatchingComponents'),
					    sSearch: localizer.getString('hpsum.common.search')
							   },
				    bPaginate : false,
				    bProcessing : true,
				    bFilter : true,
				    bSort : false,
				    bAutoWidth : false,
				    bInfo : false,
				    bRetrieve : true,
				    bDestroy : true,
				    aoColumns : [
						{mDataProp: 'select'},
						{mDataProp: 'component_file_name'},
				        {mDataProp: 'package_name'},
				        {mDataProp: 'component_version'},
				        {mDataProp: 'baselineid', "bVisible": false}],
				    aaSorting: [],
				    fnRowCallback : function( nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
				        
				        return nRow;
				    }
				    });
			 
				$(tableid + ' tbody tr').first().addClass('hp-selected');
			}
			
			//Initialize Baseline sources table to list all the available baselines
            function initSourcesTable() {
            	
            	var data = [{
							select: 'Select',
            				name: 'HP Proliant SPP',
            				version: '2013.04.23',
            				location: 'C:/SPP',
            				baselineid: 'bp0001',
            				uri: 'baseline/location..../bp00001',
            				osdata: 'obj'
            				}];
				    
				var oTab = $(SOURCES_TABLE).dataTable({
					oLanguage: {
					    sEmptyTable: localizer.getString('hpsum.baseline.custom.noBaselinesAvailable'),
					    sSearch: localizer.getString('hpsum.common.search')
							   },
				    bPaginate : false,
				    bProcessing : true,
				    bFilter : false,
				    bSort : false,
				    bAutoWidth : false,
				    bInfo : false,
				    bRetrieve : true,
				    bDestroy : true,
				    aoColumns : [
						{mDataProp: 'select'},
				    	{mDataProp: 'name'},
				    	{mDataProp: 'version'},
				        {mDataProp: 'location'},
				        {mDataProp: 'baselineid', "bVisible": false},
				        {mDataProp: 'uri', "bVisible": false},
				        {mDataProp: 'osdata', "bVisible": false}
				        ],
				    aaSorting: [],
				    fnRowCallback : function( nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
				        //$(nRow).attr('id', aData.component_file_name);
				        return nRow;
				    }
				    });
			 
				$(SOURCES_TABLE + ' tbody tr').first().addClass('hp-selected');
				
				oTableBaselines = $(SOURCES_TABLE).dataTable();
			}
            
            function enableActionButtons()
			{
				if(addInProgress)
					return;
				
				components_new = [];
				components_operating_system = []; 

				var descr = $(DESCR).val(); 
				if (descr.length <= 0 )
				{
					$(CREATE).attr("disabled", true);
					$(SAVEAS).attr("disabled", true);
					return false;
				}
				
				if($(DATE_VERSION).val().length <= 0)
				{
					$(CREATE).attr("disabled", true);
					$(SAVEAS).attr("disabled", true);
					return false;
				}
				
				if($(TARGET_LOCATION).val().length <= 0)
				{
					$(CREATE).attr("disabled", true);
					$(SAVEAS).attr("disabled", true);
					return false;
				}
		
				if (NO_COMP_SELECTED)
				{
					$(CREATE).attr("disabled", true);
					$(SAVEAS).attr("disabled", true);
					return false;
				}
				
				if(!berror)
				{
					cleanErrorMessage();
				}
				
				if($('#chkbox-bootableiso')[0].checked)
					if($(ISO_LOCATION).val().length <= 0)
					{
						$(CREATE).attr("disabled", true);
						$(SAVEAS).attr("disabled", true);
						return false;
					}
				
				$(CREATE).attr("disabled", false);
          		$(SAVEAS).attr("disabled", false);
			}
			
			function disableActionButtons()
			{
				$(CREATE).attr("disabled", true);
          		$(SAVEAS).attr("disabled", true);
			}

			function disableAll()
			{
				//$("#hpsum-custom-baselines-add-form :input").prop("disabled", true);
				$(ADDBASELINE).attr("disabled",true);
				$(SELECT_COMPTYPE).attr("disabled",true);
				$(SOURCES_TABLE).removeClass('hp-selectable');
				$(COMPONENTS_TABLE).removeClass('hp-selectable');
			}
			
			function enableAll()
			{
				//$("#hpsum-custom-baselines-add-form :input").prop("disabled", false);
				$(FORM).attr("disabled",false);
				$(CUSTOM_PANEL).attr("disabled",false);
				$(ADDBASELINE).attr("disabled",false);
				$(SELECT_COMPTYPE).attr("disabled",false);
				$(SOURCES_TABLE).addClass('hp-selectable');
				$(COMPONENTS_TABLE).addClass('hp-selectable');
			}

			function cleanErrorMessage()
			{
				
				$('#hpsum-cbl-descr-error').empty();
				$('#hpsum-cbl-version-error').empty();
				$('#hpsum-cbl-targetloc-error').empty();
				$('#hpsum-cbl-apply-filter-error').empty();
				berror = false;
			}
			function onCSMValidationSuccess(data) {            	
            	closeSaveWait();
            	var msg;
            	
            	if(data.hapi.hcode === 0) {
            		msg = 'ok';            		
            	} else {
            		msg = 'error';
            		$('#hpsum-validate-csm-local').hide();
            	}
                
                $('#hpsum-vbl-summary').show();
                $('#hpsum-vbl-components').show();
                $(TOTAL_SUMMARY).html(data.hapi.total_no_of_component + localizer.getString('hpsum.baseline.validate.totalSummary'));
                $(MISSING_SUMMARY).html(data.hapi.total_no_of_missing_component + localizer.getString('hpsum.baseline.validate.missingSummary'));
                $(MATRIX_LABEL).html(localizer.getString('hpsum.baseline.validate.csmPath'));
                initComponentsTable();
                populateComponentsTable(data);
               	formStateView.setMessage({
                    summary: data.hapi.hmessage,
                    status: msg,
                    details: ""});
            	if(data.hapi.hcode === 0)
            	{
            		NO_COMP_SELECTED = false;
            		enableActionButtons();            		
            	}
            	else
            		disableActionButtons();
            }
            
            function onCSMValidationError(data) {            	
            	closeSaveWait();
            }
			

            //Initialize install components table to add all the missing components
            function initComponentsTable() {
                
                  nodeTable = $(COMPONENTS_CSM_TABLE).dataTable({
                        oLanguage: {
                                sEmptyTable: localizer.getString('hpsum.node.noItemsFound')
                               },
                    sScrollY: "400px",
                    bScrollCollapse: true,
                    bPaginate : false,
                    bProcessing : true,
                    bFilter : true,
                    bSort : true,
                    bAutoWidth : true,
                    bInfo : false,
                    bRetrieve : true,
                     bDestroy : true,
                        aoColumns : [     
                            {mDataProp: 'component_id'},                       
                            {mDataProp: 'package_name'},
                            {mDataProp: 'component_version'},
                            {mDataProp: 'found'}],
                    aaSorting: [],
                    });
                nodeTable.fnClearTable();
            }

            function populateComponentsTable(data){

                nodeTable = $(COMPONENTS_CSM_TABLE).dataTable();
                nodeTable.fnClearTable();
                nodeTable.fnAddData(data.hapi.missing_comp_list.component);
                nodeTable.fnAddData(data.hapi.available_components.component);                   
            }
			function setLocationType(){
                 if($(LOCATION_TYPE).val() == 'local'){
                    //$('#hpsum-validate-csm-local').show();
                    $('#hpsum-vbl-summary').hide();
                    $('#hpsum-vbl-components').hide();
                    $('#hpsum-validate-csm-local').hide();
                    $('#hpsum-validate-csm-version').hide();
                    $('#hpsum-validate-csm-ftp').hide();
                    $(PROXY_OPTIONS).hide();
                    $(MATRIX_PATH).val('');
                    $(MATRIX_LABEL).html(localizer.getString('hpsum.baseline.validate.csmPath'));
                    $(RETRIEVE_MATRIX_BUTTON).css( "display", "none" );
                    $(RETRIEVE_MATRIX_BUTTON).off('click',retrieveReciepeFile);
                    formStateView.reset();
                }
                else if($(LOCATION_TYPE).val() == 'FTP'){
                        $('#hpsum-validate-csm-local').hide();
                        $('#hpsum-validate-csm-version').hide();
                        $('#hpsum-validate-csm-ftp').show();
                        $('#hpsum-vbl-summary').hide();
                        $('#hpsum-vbl-components').hide();
                        $(MATRIX_PATH).val('');
                        $(MATRIX_LABEL).html(localizer.getString('hpsum.baseline.add.enterWorkingDirectory'));
                        $(RETRIEVE_MATRIX_BUTTON).show();
                        $(".hpsum-proxy").attr("disabled", false);
                        $('#hpsum-vbl-proxy-options').selectBox('enable');
                        $(PROXY_OPTIONS).selectBox('value', 'No');
                        onProxyOptionsChange('No');
                        $(RETRIEVE_MATRIX_BUTTON).on('click',retrieveReciepeFile);
                        
                        if($(MATRIX_PATH).val()== '')
                            $(RETRIEVE_MATRIX_BUTTON).attr("disabled", true);
                        
                        $(MATRIX_PATH).on('change',setRetrieveButtonState);
                        $(MATRIX_PATH).on('input',setRetrieveButtonState);
                        $(ADDBASELINE).attr("disabled", true);
			 formStateView.reset();
                    }             
            }
            function onProxyOptionsChange(msg) 
            {
                var value = $(this).val();
                if(value == "No" || msg == "No"){
                    $('#hpsum-vbl-proxy-usehp-item').hide();
                    $('#hpsum-vbl-proxy-usescript-item').hide();
                    proxyOptionValue = "No";
                }
                else if(value == "Server"){
                    $('#hpsum-vbl-proxy-usehp-item').show();
                    $('#hpsum-vbl-proxy-usescript-item').hide();
                    $('#hpsum-vbl-proxy-url').attr("disabled",false);
                    $('#hpsum-vbl-proxy-port').attr("disabled",false);
                    $('#hpsum-vbl-proxy-username').attr("disabled",false);
                    $('#hpsum-vbl-proxy-password').attr("disabled",false);
                    proxyOptionValue = "Server";
                }
                else if (value == "Script"){
                    $('#hpsum-vbl-proxy-usehp-item').hide();
                    $('#hpsum-vbl-proxy-usescript-item').show();
                    $('#hpsum-vbl-proxy-script').attr("disabled",false);
                    $('#hpsum-vbl-proxyscript-username').attr("disabled",false);
                    $('#hpsum-vbl-proxyscript-password').attr("disabled",false);
                    proxyOptionValue = "Script";
                }
            }
              function retrieveReciepeFile() {
                var input = {
                    hapi: {
                        working_location :$(MATRIX_PATH).val(),
                        proxy_settings: getProxyJsonObject()
                    }
                };
                
                presenter.getPFWReciepefile(input, {
                    success:function(data){
                        closeSaveWait();
                        $(".hpsum-proxy").attr("disabled", true);
                        $('#hpsum-proxy-options').selectBox('disable');

                        var msg;
                        
                        if(data.hapi.hcode === 0) {
                            msg = 'ok';
                            var xmlFile = $(MATRIX_PATH).val() + "/MatrixConfig.xml";
                            saveLocalMatrixFile(xmlFile);
                            checkBaselineSelected();
                            $(RETRIEVE_MATRIX_BUTTON).attr("disabled", true);                            
                        }
                        else{
                            msg = 'error';
                        }
                             
                        formStateView.setMessage({
                            summary: data.hapi.hmessage,
                            status: msg,
                            details: ""});
                    },
                    error:function(message) {
                        closeSaveWait();
                    }
                });

                showSaveWait(localizer.getString('hpsum.baseline.validate.retrieveInProgress'));
            }
            function setRetrieveButtonState(){
                if($(LOCATION_TYPE).val() == 'FTP'){
                       if($(MATRIX_PATH).val()== '')
                            $(RETRIEVE_MATRIX_BUTTON).attr("disabled", true);
                        else
                            $(RETRIEVE_MATRIX_BUTTON).attr("disabled", false);
                      }
            }
             function getProxyJsonObject(){
                var proxy_settings;
                if((proxyOptionValue == "No") || (proxyOptionValue == undefined))
                    proxy_settings ='';
                else if(proxyOptionValue == "Server"){
                    proxy_settings = {
                        proxy_username: $('#hpsum-vbl-proxy-username').val(),
                        proxy_password: $('#hpsum-vbl-proxy-password').val(),
                        proxy_ftp_port: $('#hpsum-vbl-proxy-port').val(),
                        proxy_url: $('#hpsum-vbl-proxy-url').val(),
                        use_proxy_script:false
                    };
                }
                else if(proxyOptionValue == "Script"){
                    proxy_settings = {
                        proxy_username: $('#hpsum-vbl-proxyscript-username').val(),
                        proxy_password: $('#hpsum-vbl-proxyscript-password').val(),
                        use_proxy_script: true,
                        proxy_script: $('#hpsum-vbl-proxy-url').val()
                    };
                }
                return proxy_settings;
            }
			            function showSaveWait(msg) {					
					
					if (!waitDialog) {
						waitDialog = $(SPLASH_DIALOG);
						waitDialog.dialog({
							modal : true,
							dialogClass : 'hp-simple-dialog',
							position : "center",
							draggable : false,
							resizable : false,
							width : 260,
							height : 180
						});
					}						                   

					$('#hpsum-bs-validate-wait-message', waitDialog).html(msg);
					$(SPLASH_SPINNER).show();
					msg='';
					waitDialog.dialog('open');
				}

				function closeSaveWait() {
					$(SPLASH_SPINNER).hide();
					if (waitDialog) {
						waitDialog.dialog('close');
					}
				}
            
            /**
             * * Saves the given local matrix xml file and wait for the engine to response
             * * Till engine response page will be blocked. 
             */
            function saveLocalMatrixFile(matrixXmlFile) {
            	var msg = localizer.getString('hpsum.baseline.validate.saveInProgress');
            	showSaveWait(msg);
            	            	
            	var input = {
            		hapi: {
            			uri : matrixXmlFile            			
            		}            		
            	};
            	
            	presenter.saveReciepeFile(input, 
            		{
                        success : onItemSaveSuccess,
                        error : onItemSaveError
                    });            	
            }
            
            
            function onItemSaveSuccess(data) {
            	
            	closeSaveWait();
            	var msg;
            	
            	if(data.hapi.hcode === 0) {
            		msg = 'success';
            		$('#hpsum-validate-csm-local').show();
                    $('#hpsum-validate-csm-version').show();
            		var versions = data.hapi.available_versions.matrix_version;
            		var length = versions.length;
            		var selectdata = '<select id=hpsum-csm-version class= hp-select>';
            		for(var i = 0; i < length; ++i) {
            			var ver = versions[i].version;
            			var baseline = versions[i].associated_bundle_name;
            			selectdata += '<option value="' + baseline + '">' + ver + '</option>';
            		}
            		selectdata += '</select>';
            		$('#hpsum-csm-selectbox').html(selectdata);
            		var selectvalue = $('#hpsum-csm-version').val();
            		$('#hpsum-starting-bl-used-value').text(selectvalue);	
            		$('#hpsum-csm-version').change(function(){
            			var selectvalue = $('#hpsum-csm-version').val();
            			$('#hpsum-starting-bl-used-value').text(selectvalue);
            		});
            	} else {
            		msg = 'error';
            		$('#hpsum-validate-csm-local').hide();
                    $('#hpsum-validate-csm-version').hide();
            	}
                     
               	formStateView.setMessage({
                    summary: data.hapi.hmessage,
                    status: msg,
                    details: ""});
            	
            }
            
            function onItemSaveError(data) {
            	closeSaveWait();
            }

            /**
             * * Initialize and display browse dialog.
             * * User can navigate to any folder and choose a valid matrix file location 
             */
           function initBrowseMatrixDialog(){
                var dialogView = new DialogView();
                dialogView.init({contents: browseDialogContents,
                    position : "center",
                    ok: function (elem) {
                        
                        var node = $(BROWSE_TREE).jstree('get_selected');
                        if(node[0] == null)//|| (node[0] && node[0].attributes["rel"].value != "package"))
                        {
                            var loc_type = $(LOCATION_TYPE).val();
                            if(loc_type == 'local')
                            {
                                return false;
                            }
                        }
                        //$(MATRIX_PATH).val(node[0].id);
                        //$(MATRIX_PATH).trigger('change');
                        if($(LOCATION_TYPE).val() == 'local') {
                            checkBaselineSelected();
			    $('#hpsum-validate-csm-version').show();
                            $('#hpsum-validate-csm-local').show();
                            var xmlFile = $(MATRIX_PATH).val();
                       		saveLocalMatrixFile(xmlFile);
                       		$(RETRIEVE_MATRIX_BUTTON).hide();
                       	} else {
                       		$(MATRIX_PATH).val(node[0].id);
                        	$(MATRIX_PATH).trigger('change'); 
                        }
                    },
                    cancel: function () {
                        $(MATRIX_PATH).val('');
                        $(MATRIX_PATH).trigger('change');
                    }
                });
            }
            /**
             * @private
             * Call presenter's addItem() to add a new baseline item into Indexservice
             */
            function onCSMCreate(bsaveas) {
				//Validate the input before proceeding with adding new custom baseline
				var berror = false;
				var errorDetails = '';
				var descr = $(DESCR).val(); 
				if (descr.length <= 0 )
				{
					$('#hpsum-cbl-descr-error').html(localizer.getString("hpsum.baseline.custom.descriptionRequired"));
					berror = true;
					errorDetails = '<p>' + localizer.getString("hpsum.baseline.custom.descriptionRequired") + '</p>';
				}
				
				if (descr.length > MAX_DESCR_LENGTH) { 
		 			$('#hpsum-cbl-descr-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + MAX_DESCR_LENGTH);
		 			berror = true;
					errorDetails = '<p>' + localizer.getString("hpsum.baseline.custom.maxlen") + MAX_DESCR_LENGTH + '</p>';
				}
				
				if($(VERSION2).val().length <= 0)
				{
					$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.versionRequired"));
					berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.versionRequired") + '</p>';
				}
				
				if($(VERSION2).val().length > MAX_VER_LENGTH)
				{
					$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + MAX_VER_LENGTH);
					berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.maxlen") + MAX_VER_LENGTH + '</p>';
				}
				
				if($(TARGET_LOCATION).val().length <= 0)
				{
					$('#hpsum-cbl-targetloc-error').html(localizer.getString("hpsum.baseline.custom.targetlocRequired"));
					berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.targetlocRequired") + '</p>';
				}

				var descrcheck = /^[\w\-\s]+$/;   
					
			    if ( !descrcheck.test(descr) )
			    {       				
			    	$('#hpsum-cbl-descr-error').html(localizer.getString("hpsum.baseline.custom.descriptionValidationMsg"));
		 			berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.descriptionError") + localizer.getString("hpsum.baseline.custom.descriptionValidationMsg") + '</p>';
		 		}
				
				//var versioncheck = /^[\d]+$/;   
					
			   // if ( !versioncheck.test($(VERSION2).val()) )
			    if ($(VERSION2).val() == '')
			    {       				
			    	$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.versionIdentifierError"));
		 			berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.versionError") + localizer.getString("hpsum.baseline.custom.versionIdentifierError") + '</p>';
		 		}
				
				if($(BOOTABLEISO_CHKBOX)[0].checked && $(ISO_LOCATION).val().length <= 0)
				{
					$('#hpsum-cbl-isoloc-error').html(localizer.getString("hpsum.baseline.custom.isolocRequired"));
					berror = true;
					errorDetails += '<p>' + localizer.getString("hpsum.baseline.custom.isolocRequired") + '</p>';
				}
				
				if(berror)
				{
					formStateView.setMessage({
                                summary: localizer.getString("hpsum.baseline.custom.validationErrorMsg"),
                                status: 'error',
                                details: errorDetails});
                                
					return false;
				}
					
				var verstr = $(DATE_VERSION).val();
				verstr = verstr.replace(/\-/g, '.');
				verstr = verstr + '.' + $(VERSION2).val();
				
				var bundlename = $(BASELINE_NAME_LABEL).html();
				
	
				
				var isolocation = $(ISO_LOCATION).val();
				var targetlocation = $('#hpsum-custom-baselines-targetloc').val();
				
				var bcreateiso = false, bbootableiso = false;
				if($(CREATEISO_CHKBOX)[0].checked)
					bcreateiso = true;
					
				if($('#chkbox-bootableiso')[0].checked)
					bbootableiso = true;
				
					
				
				var serverlist = [];
				/*if($('#chkbox-server-dl380')[0].checked) {
					serverlist.push('Window2003')
				}*/
				
				var selBaselines = [],selectedRows;
            	if(oTableBaselines)
            	{					
					selectedRows = $(SOURCES_TABLE + ' tbody tr.hp-selected');
			 	} 
			 	for(var tmp=0; tmp < selectedRows.length; tmp++){
	 				var nodeData = oTableBaselines.fnGetData(selectedRows[tmp].rowIndex-1);
	 				var list = nodeData.uri.split("/");
					var baselineid = list[7];
					var components = []; 
					var datarows = $(COMPONENTS_CSM_TABLE + ' tbody tr');
					for (var index = 0; index < datarows.length ; index++)
					{
						if(baselineid === nodeTable.fnGetData(index).bundle_id)
							components.push(nodeTable.fnGetData(index).component_id);
					}
					var baselineinfo = {
					          baseline_name : baselineid,
					          component: components
					       };
					selBaselines.push(baselineinfo);
				}
				
				/*for(var i=0; i < selectedTablesID.length; i++)
				{
					var oTable = $(selectedTablesID[i].table_id).dataTable();
					if(oTable == undefined)
						continue;
					
					var selectedRows = $(selectedTablesID[i].table_id + ' tbody tr');
					
					var comps = oTable.fnGetData();
					var components = [];
					
					for(var tmp=0; tmp < selectedRows.length; tmp++){
		 				var compData = oTable.fnGetData(selectedRows[tmp].rowIndex-1);
		 				var bselected = false, bforce = false;
		 				
		 				if(selectedRows[tmp].className.indexOf('hp-selected') != -1)
		 					bselected = true;
		 				else
		 					bselected = false;
		 					
		 				if(bselected && (compData.baselineid === selectedTablesID[i].baseline))
		 					components.push(compData.component_file_name);
		 			}
					
					var baselineinfo = {
					          baseline_name : selectedTablesID[i].baseline,
					          component: components
					       };
					
					selBaselines.push(baselineinfo);	
				}*/
				
				if(bsaveas) {
					bcreateiso = false;
					bbootableiso = false;
				}
								
				var item = {
					  hapi: {
					    bundle_name: bundlename,
					    bundle_header: descr,
					    target_location: targetlocation,
					    iso_location: isolocation,
					    create_ISO: bcreateiso,
					    bootable_ISO: bbootableiso,
					    version: verstr,
					    baseline_list: {
					      baseline: selBaselines
					    }
					  }
					}; 
				
				if(! addInProgress) {
                    addInProgress = true;
                    $("#hpsum-custom-baselines-add-form :input").prop("disabled", true);
                    
                    formStateView.setMessage({summary: localizer.getString("hpsum.baseline.custom.createCBLMsg"),
                        status: 'unknown', changing: true});
                    
                    presenter.createCustomBaseline(item, CreateCustomBaselinehandlers);
                    
                    formStateView.reset();
                    
                    if($('#chkbox-runinback')[0].checked){
                    	$(CANCEL).trigger('click');
                    }
                    
                }
				
				return false;
            }
			/**
             * * Reset all the fields such as descr, versions, target location etc
            */
			function reset(bResetFormState)
          	{
          		NO_COMP_SELECTED = true;
          		addInProgress = false;
          		filtered_comp_list = {};
          		$(CREATE).attr("disabled", true);
          		$(SAVEAS).attr("disabled", true);
          		
          		//empty all text boxes and checkboxes
          		$(':text').val('');
          		$(':checkbox').attr('checked', false);
          		$(DESCR).val('');
          		$(BASELINE_NAME_LABEL).html('');
          		
          		//This will create a custom baseline name with current values
            	var descr = $(DESCR).val(), name, curDateVersion, monthValue;
				descr = descr.replace(/\s+/g, '-').toLowerCase();
				curDateVersion = new Date();
				
				//Avoid adding an unnecessary '-' to the name when description is emppty
	          	if (descr != '') {
	          		//getMonth() returns month from 0 - 11 range, hence adding 1 to the getMonth() result
	          		monthValue = curDateVersion.getMonth() + 1;
					name = 'bp-' + descr + '-' + curDateVersion.getFullYear() + '-' + monthValue + '-' + curDateVersion.getDate();
				} else {
					//getMonth() returns month from 0 - 11 range, hence adding 1 to the getMonth() result
					monthValue = curDateVersion.getMonth() + 1;
					name = 'bp' + descr + '-' + curDateVersion.getFullYear() + '-' + monthValue + '-' + curDateVersion.getDate();
				}
	          	$(BASELINE_NAME_LABEL).html(name);
	          	
	          	//This will initialize date picker with current date version
				$(DATE_VERSION).datepicker('setDate', new Date());

				$(CREATEISO_CHKBOX).attr('checked',true); 
				$('#chkbox-bootableiso').attr('checked',false);
				
				//clear tables
				$('#all-cbl-baselines').empty();
							
				cleanErrorMessage();
				
				if(bResetFormState) {
					formStateView.reset();
					populateBaselines();
				}
				$('#hpsum-validate-csm-ftp').hide();
                $('#hpsum-validate-csm-local').hide();
                $('#hpsum-vbl-proxy-usehp-item').hide();
                $('#hpsum-vbl-proxy-usescript-item').hide();
                $('#hpsum-vbl-components').hide();
                $('#hpsum-matrix-from-ftp').hide();
				$('#hpsum-custom-baseline-non-matrix-filters').show();
				$('#hpsum-validate-csm-location-type').hide();
            	$(MATRIX_PATH).val("");
          	}
          	
          	/**
             * * Initialize event functions for fields such as descr, target location, version etc
            */
          	function initialize() {
	          		
          		$(DATE_VERSION).change(function(ev) {
          			var descr = $(DESCR).val(), name;
					//replacing spaces with dashes
					descr = descr.replace(/\s+/g, '-').toLowerCase();
					
					//Avoid adding an unnecessary '-' to the name when description is emppty
					if (descr != '') {
	          	 		name = 'bp-' + descr + '-' + $(DATE_VERSION).val() + '-' + $(VERSION2).val();
	          	 	}
	          	 	else {
	          	 		name = 'bp' + descr + '-' + $(DATE_VERSION).val() + '-' + $(VERSION2).val();
	          	 	}
	          		$(BASELINE_NAME_LABEL).html(name);
	          	});
	          			
          		$(VERSION2).blur(function(){
					var descr = $(DESCR).val(), name;
					//replacing spaces with dashes
					descr = descr.replace(/\s+/g, '-').toLowerCase();
					
					//Avoid adding an unnecessary '-' to the name when description is emppty
	          		if (descr != '') {
	          	 		name = 'bp-' + descr + '-' + $(DATE_VERSION).val() + '-' + $(VERSION2).val();
	          	 	}
	          	 	else {
	          	 		name = 'bp' + descr + '-' + $(DATE_VERSION).val() + '-' + $(VERSION2).val();
	          	 	}
	          		$(BASELINE_NAME_LABEL).html(name);
	          		
	          		enableActionButtons();
          		});
          	
          		$(DESCR).bind('keypress', function (event) {
          			
          			var theEvent = event || window.event;
					var key = theEvent.keyCode || theEvent.which;
					
					var keychar = String.fromCharCode(key);
					
					var keycheck = /^[\w\-\s]+$/;   
					
					//key 46, 37 and 39 removed from the below condition as key code for keypress event are different than keydown event
					//We are handling these code in keydown event method
					/* code		keypress	keydown
						46		.		    Delete
						37		%		    Left arrow
						39		'		    Right arrow */
					//Ashwini:5/5/14 Added key==46 to if statement as for Firefox, keypress is getting hit for del(46) also.	
					if (!(key == 8  ||  key == 27 || key==46)) // backspace escape
					{
					    if ( !keycheck.test(keychar) )
					    {       
					    	$('#hpsum-cbl-descr-error').html(localizer.getString("hpsum.baseline.custom.descriptionValidationMsg"));
					        theEvent.returnValue = false;//for IE
							
							if (theEvent.preventDefault) 
								theEvent.preventDefault();//Firefox
						}
						else
							return true;
					}
					
					return theEvent.returnValue;
  				});
          		   
          				
          		$(DESCR).blur(function(){
          			if($(DESCR).val().length <= MAX_DESCR_LENGTH)
          			{
          				$('#hpsum-cbl-descr-error').empty();
          				
          				var descr = $(DESCR).val(), name;
						//replacing spaces with dashes
						descr = descr.replace(/\s+/g, '-').toLowerCase();
		          		
		          		//Avoid adding an unnecessary '-' to the name when description is emppty
						if (descr != '') {
							name = 'bp-' + descr + '-' + $(DATE_VERSION).val() + '-' + $(VERSION2).val();
						} else {
							name = 'bp' + descr + '-' + $(DATE_VERSION).val() + '-' + $(VERSION2).val();
						}

		          		$(BASELINE_NAME_LABEL).html(name);
          			}
          			enableActionButtons();
          		});
          		
          		$(TARGET_LOCATION).blur(function(){
					enableActionButtons();
          		});
          		
          		$(ISO_LOCATION).blur(function(){
					enableActionButtons();
          		});
          		
          		

					$(VERSION).keydown(function(e) {
						var key = e.which || e.keyCode;
						
						if (!e.shiftKey) { 
						if (!e.shiftKey && !e.altKey && !e.ctrlKey &&
						// comma, period and minus, . on keypad
						key == 190 || key == 188 || key == 109 || key == 110 ||
						// Backspace and Tab and Enter
						key == 8 || key == 9 || key == 13 ||
						// Home and End
						key == 35 || key == 36 ||
						// left and right arrows
						key == 37 || key == 39 ||
						// Del and Ins
						key == 46 || key == 45) {

							return true;
						}

						if (($(VERSION).val().length) < 4) {

							if (
							// numbers
							key >= 48 && key <= 57 ||
							// Numeric keypad
							key >= 96 && key <= 105) {

								return true;
							}

						} else {
							$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + 4);
						}
						}
						e.preventDefault();
					});

					$(VERSION1).keydown(function(e) {
						var key = e.which || e.keyCode;
						if (!e.shiftKey) { 
						if (!e.shiftKey && !e.altKey && !e.ctrlKey &&
						// comma, period and minus, . on keypad
						key == 190 || key == 188 || key == 109 || key == 110 ||
						// Backspace and Tab and Enter
						key == 8 || key == 9 || key == 13 ||
						// Home and End
						key == 35 || key == 36 ||
						// left and right arrows
						key == 37 || key == 39 ||
						// Del and Ins
						key == 46 || key == 45) {

							return true;
						}

						if (($(VERSION1).val().length) < 2) {
							if (
							// numbers
							key >= 48 && key <= 57 ||
							// Numeric keypad
							key >= 96 && key <= 105) {

								return true;
							}

						} else {
							$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + 2);
						}
						}
						e.preventDefault();
					}); 

				
				$(VERSION2).bind('keypress', function (event) {
					
					var theEvent = event || window.event;
					var key = theEvent.keyCode || theEvent.which;
					
					var keychar = String.fromCharCode(key);
					
					var keycheck = /^[a-zA-Z0-9]+$/;
					
					if (!(key == 8  ||  key == 27  || key == 46  || key == 37 || key == 39 || key == 9)) // backspace delete  escape arrows
					{
					    if ( !keycheck.test(keychar) )
					    {       
					        theEvent.returnValue = false;//for IE
							
							if (theEvent.preventDefault) 
								theEvent.preventDefault();//Firefox
						}
						else
							return true;
					}
					
					return theEvent.returnValue;
				});
				
				$(VERSION2).keydown(function(e){
					var key = e.which || e.keyCode;
					
					if (!e.shiftKey && !e.altKey && !e.ctrlKey &&
                     // comma, period and minus, . on keypad
                        key == 190 || key == 188 || key == 109 || key == 110 ||
                     // Backspace and Tab and Enter
                        key == 8 || key == 9 || key == 13 ||
                     // Home and End
                        key == 35 || key == 36 ||
                     // left and right arrows
                        key == 37 || key == 39 ||
                     // Del and Ins
                        key == 46 || key == 45)
                    {
                    	if($(VERSION2).val().length <= MAX_VER_LENGTH)
                    		$('#hpsum-cbl-version-error').empty();
                    	
                        return true;
                    }
					
					
					if ($(VERSION2).val().length < 2) {
						return true;
					} else {
						$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + 2);
					}

                    	
                    /*if (
                     // numbers   
                        key >= 48 && key <= 57 ||
                     // Numeric keypad
                        key >= 96 && key <= 105 )
                    {
                    	if($(VERSION2).val().length < 2)
                    	{
                    		return true;
                    	}
                    	else
                    	{
                    		$('#hpsum-cbl-version-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + 2);
                    	}
                    }*/

                    e.preventDefault();
				});
				
				
				$(DESCR).keydown(function(event) {
					
					var currentLen = $(DESCR).val().length;
			        
					if (currentLen > MAX_DESCR_LENGTH) { 
			 			// Trim the field current length over the maxlength.
						$(DESCR).val($(DESCR).val().slice(0, MAX_DESCR_LENGTH));
						$('#hpsum-cbl-descr-error').html(localizer.getString("hpsum.baseline.custom.maxlen") + MAX_DESCR_LENGTH);
			 			event.preventDefault();
			 			return false;
					}
					else
					{
						return true;
					}
			  	});	
          		
          	}
          	
          	/**
             * * Initialize and display browse dialog.
             * * User can navigate to any folder and choose a valid baseline location 
             */
            function initBrowseDialog(inputType){
            	var id = '';
            	
            	if(inputType === 'target')
            		id = TARGET_LOCATION;
            		
        		if(inputType === 'iso')
        			id = ISO_LOCATION;
            	
            	var dialogView = new DialogView();
            	dialogView.init({contents: browseDialogContents,
                	position : "center",
                    ok: function (elem) {
                    	
                    	var node = $(BROWSE_TREE).jstree('get_selected');
                    	if(node[0] == null)
                    	{
                    		return false;
                    	}
                    	$(id).val(node[0].id);
                    	//$(CREATE).attr("disabled", false);
                    },
                    cancel: function () {
                    	$(id).val('');
						$('#hpsum-hardware-info').html(' ');
                    }
                });
            }
            
            /**
             * * Create a JsTree inside the browse dialog.
             * * This includes operations such as JSON data load through AJAX call, configuration of tree etc.
             */
            function createTree(inputType){
            	
            	var id = '';
            	
            	if(inputType === 'target')
            		id = TARGET_LOCATION;
            		
        		if(inputType === 'iso')
        			id = ISO_LOCATION;
            	
            	var uri = "Session/" + session.getToken()  + "/Baseline/browse";
				var initial_folder = $(id).val();
				
				$(BROWSE_TREE).empty();
                $(BROWSE_TREE).jstree({
                        "json_data" : {
                        		   "ajax" : {
						           		"url" : function (node) {
	                                        var url;
	                                        if (node == -1) {
	                                            url = "Session/" + session.getToken()  + "/Baseline/browse";
	                                        } else {
	                                            url = null;
	                                        }
	                                        return url;
	                                    },
										"type" : "POST",
					                    "dataType" : "json",
					                    "data" : function (n) { 
												var object = {
														"hapi": {
    														"uri": $(id).val().length > 0 ? $(id).val() : ".."
														}
													}; 
												
												return JSON.stringify(object); 
										},
										"success" : function (output) {
											
											var data = [], children = [], index, node, bAddParent = false;
											
											//hcode has string value in the response payload. This need to be changed later when it is 
											//changed to integer value
											if(output.hapi.hcode != "0")
											{
												//add a node to navigate to parent directory 
												node = {
											        		"data" : "..",
											        		"attr" : { "id" : "..", "rel" : "parent"},
											                "state" : "open",
											               };
											               
											    data.push( node );
												return data;
											}
											
											//iterate through folders and create child nodes
											for(var i=0; i < output.hapi.folders.folder.length; i++ ){
												var folder = output.hapi.folders.folder[i];
												var child, rel;
												
												if(i === 0) 
												{
													var str = $(id).val();
													if(str === '/')
													{
														bAddParent = false;
													}
													else if(i == 0) // && (str.length > 0 && str.indexOf('/') === -1)) 
													{
														bAddParent = true;
														continue;
													}
												}	
												
												//if it is root folder and drive, add the first item as a sibling node instead of parent node
												//change icon if folder is a valid package
												if(folder.possible_package)
													rel = "package";
												else
													rel = "folder";
												
												//take only last folder name from complete path
												//var str = folder.folder_name.substring(folder.folder_name.lastIndexOf('/')+1);
												var strfolder, idfolder;
												if(str === '/') {
													strfolder = folder.folder_name.substring(0, folder.folder_name.indexOf('/')-1);//folder.folder_name;
													idfolder = folder.folder_name.substring(0, folder.folder_name.indexOf('/'));
												}
												else {
													strfolder = folder.folder_name.substring(folder.folder_name.lastIndexOf('/')+1);
													idfolder = folder.folder_name;
												}
												
												//create children nodes
									        	child = {
									        		"data" : strfolder,
									        		 "attr" : {"id" : idfolder, "rel" : rel}
									        		};
										        children.push( child );
										    }
											
											//add a node to navigate to parent directory 
											node = {
										        		"data" : "..",
										        		"attr" : { "id" : "..", "rel" : "parent"},
										                "state" : "open",
										               };
										               
										    data.push( node );
										    
										    if(bAddParent) {
										    	var rel, val;
										    	if(output.hapi.folders.folder[0].possible_package)
													rel = "package";
												else
													rel = "folder";
													
												if($(id).val() === '')
													val = output.hapi.folders.folder[0].folder_name;
												else
													val = $(id).val();
											    //add parent folder to folder list
												node = {
											        		"data" : val,//output.hapi.folders.folder[0].folder_name,
											        		"attr" : { "id" : val, "rel" : rel}, //{ "id" : output.hapi.folders.folder[0].folder_name, "rel" : rel},
											                "metadata" :  output.hapi.folders.folder[0],
											                "state" : "open",
											                "children" : children
											               };
											               
											    data.push( node );
											}
											else
											{
												data.push(children);
											}
											
										                
											return data;
										}
						           }
						},
                        "themes" : {
                                "theme" : "default",
                                "url" : "/css/style.css",
                                "dots" : true,
                                "icons" : true
                        },
                        "plugins" : [ "themes", "json_data", "ui" , "crrm", "types" ],
                        "types" : {
                                "max_depth" : -2,
                                "max_children" : -2,
                                "valid_children" : [ "drive" ],
                                "types" : {
                                        "default" : {
                                                "valid_children" : "none",
                                                "icon" : {
                                                        "image" : "/img/hp-piano/collapse-closed.png"
                                                }
                                        },
                                        "folder" : {
                                                "valid_children" : [ "default", "folder", "package" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/collapse-closed.png"
                                                }
                                        },
                                        "package" : {
                                                "valid_children" : [ "default", "folder" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/status-ok.png"
                                                }
                                        },
                                        "drive" : {
                                                "valid_children" : [ "default", "folder" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/down-arrow.png"
                                                },
                                                "start_drag" : false,
                                                "move_node" : false,
                                                "delete_node" : false,
                                                "remove" : false
                                        },
                                        "parent" : {
                                                "valid_children" : [ "default", "folder", "drive", "package" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/grid-collapse.png"
                                                },
                                                "start_drag" : false,
                                                "move_node" : false,
                                                "delete_node" : false,
                                                "remove" : false
                                        }
                                        
                                }
                        }
                })
                .bind("dblclick.jstree", function (event, data) {
                		var node = $(BROWSE_TREE).jstree('get_selected');
                		if(node[0].id === "..")
                		{
                			if(node[0].nextSibling)
                			{
                				var str = $(id).val(); 
                				if(str === '')
                				{
                					$(id).val(node[0].nextSibling.id.substring(0, node[0].nextSibling.id.lastIndexOf("/")));
                				}
                				else if(str === '/')
                				{
                					
                				}
                				else
                				{
	                				if(str.indexOf('/') != -1)
	                					$(id).val(node[0].nextSibling.id.substring(0, node[0].nextSibling.id.lastIndexOf("/")));
	                				else
	                					$(id).val("/");
	                			}
                			}
                			else
                			{
                				$(id).val("/");
                			}
                		}
                		else 
                		{	
                    		$(id).val(node[0].id);
                    	}
                		
                		$(BROWSE_TREE).jstree("refresh");
                });
            }
            
            function onBootableIsoClick()
            {
            	if($(BOOTABLEISO_CHKBOX)[0].checked)
            		$('#hpsum-bootableiso-opt').show();
            	else
            		$('#hpsum-bootableiso-opt').hide();
            		
            	enableActionButtons();
            }
          	
          	function onMatchMatrixVersionClick()
          	{
          		if($(MATCHMATRIXVERSION_CHKBOX)[0].checked)
          		{
            		csmfilterselected = true;
            		$('#hpsum-custom-baseline-non-matrix-filters').hide();
            		$(ADDBASELINE).attr("disabled", true);
            		onCSMFilterInit();
          		}
            	else
            	{
            		//$('#hpsum-custom-baseline-matrix-filters').hide();
            		$('#hpsum-validate-csm-location-type').hide();
            		$('#hpsum-validate-csm-ftp').hide();
                	$('#hpsum-validate-csm-local').hide();
                	$('#hpsum-vbl-proxy-usehp-item').hide();
              	  	$('#hpsum-vbl-proxy-usescript-item').hide();
               	 	$('#hpsum-vbl-components').hide();
               		$('#hpsum-matrix-from-ftp').hide();
            		$('#hpsum-custom-baseline-non-matrix-filters').show();
            		checkBaselineSelected();
            		csmfilterselected = false;
            	}
          	}
          	   /**
             * @public
             * Initialization funtion for the object
             * All the controls actions are initialized in this function.
             */
            function onCSMFilterInit() {
                
                $(LOCATION_TYPE).selectBox({autoWidth: false});
                $(PROXY_OPTIONS).selectBox({autoWidth: false});
                $(CSM_VERSION).selectBox({autoWidth: false});
                $(LOCATION_TYPE).change(setLocationType);
                $(PROXY_OPTIONS).change(onProxyOptionsChange);              

              

                $(BROWSE_MATRIX_LOCATION_BUTTON).on('click', function() {
                    initBrowseMatrixDialog();
                    $(BROWSE_OK).attr("disabled", "disabled");
                    createCSMTree();
                });             
          
				$('#hpsum-validate-csm-location-type').show();
                $('#hpsum-validate-csm-ftp').hide();
                $('#hpsum-validate-csm-local').hide();
                $('#hpsum-vbl-proxy-usehp-item').hide();
                $('#hpsum-vbl-proxy-usescript-item').hide();
                $('#hpsum-vbl-components').hide();
                $('#hpsum-matrix-from-ftp').hide();
                $(MATRIX_PATH).val("");
                $('#hpsum-matrix-from-ftp').show();
                $(RETRIEVE_MATRIX_BUTTON).hide();
                formStateView.reset();
                
            }
             function handleInvalidPath(hapi) {
                if (hapi.hcode == 5) {
                    $(BROWSE_MATRIX_LOCATION_ERROR).text(localizer.getString('hpsum.baseline.add.inValidLocation'));
                    $(MATRIX_PATH).addClass("hp-error");
                    $(BROWSE_MATRIX_LOCATION_ERROR).show();
                    $(MATRIX_PATH).keyup(onPathEdit);
                    $('#browse-dialog-cancel').trigger('click');
                    $(ADDBASELINE).attr("disabled", true);   
                } else {
                    $(BROWSE_MATRIX_LOCATION_ERROR).hide();
                    $(MATRIX_PATH).removeClass("hp-error");
                    $(MATRIX_PATH).unbind('keyup', onPathEdit);
                }
            }
            function onPathEdit() {
                $(BROWSE_MATRIX_LOCATION_ERROR).hide();
                $(MATRIX_PATH).removeClass("hp-error");
                $(MATRIX_PATH).unbind('keyup', onPathEdit);
            }
            function validateAgainstCSM(){
            	var msg = localizer.getString('hpsum.baseline.validate.validationInProgress');
            	showSaveWait(msg);
            	var URI;
            	
            	URI = "/Session/" + session.getToken()  + "/Baseline/validatereciepefile";
            	var selectedIndex = $('#hpsum-csm-version')[0].selectedIndex;
            	var selectedVersion = $('#hpsum-csm-version')[0][selectedIndex].text;   
            	var baselines = [], selectedRows;
            	if(oTableBaselines)
            	{
					//baselines = oTableBaselines.fnGetData();
					
					selectedRows = $(SOURCES_TABLE + ' tbody tr.hp-selected');
			 	} 
			 	for(var tmp=0; tmp < selectedRows.length; tmp++){
	 				var nodeData = oTableBaselines.fnGetData(selectedRows[tmp].rowIndex-1);
	 				var list = nodeData.uri.split("/");
					var locid = list[5];
					var baselineid = list[7]; 
					var baseid = locid + "/" +baselineid;
					baselines.push(baseid)  ;
					}       	
            	var input = {
            		hapi: {
            			csm_version : selectedVersion,
            			baseline : baselines
            		}            		
            	};
            	presenter.validateReciepeFile(URI, input, {
                        success : onCSMValidationSuccess,
                        error : onCSMValidationError
                    });

            }
    /**
             * * Create a JsTree inside the browse dialog.
             * * This includes operations such as JSON data load through AJAX call, configuration of tree etc.
             */

            function createCSMTree(){
                
                var uri = "Session/" + session.getToken()  + "/Baseline/browse";
                var initial_folder = $(MATRIX_PATH).val();
                
                $(BROWSE_TREE).empty();
                $(BROWSE_TREE).jstree({
                        "json_data" : {
                                   "ajax" : {
                                        "url" : function (node) {
                                            var url;
                                            if (node == -1) {
                                                url = "Session/" + session.getToken()  + "/Baseline/browse";
                                            } else {
                                                url = null;
                                            }
                                            return url;
                                        },
                                        "type" : "POST",
                                        "dataType" : "json",
                                        "data" : function (n) { 
                                                var object = {
                                                        "hapi": {
                                                            "uri": $(MATRIX_PATH).val().length > 0 ? $(MATRIX_PATH).val() : "..",
                                                            "showXml": true
                                                        }
                                                    }; 
                                                
                                                return JSON.stringify(object); 
                                        },
                                        "success" : function (output) {
                                            
                                            var data = [], children = [], index, node, bAddParent = false;
                                            
                                            //This will handle if user has given an invalid location to browse.
                                            handleInvalidPath(output.hapi);
                                            
                                            //hcode has string value in the response payload. This need to be changed later when it is 
                                            //changed to integer value
                                            if(output.hapi.hcode != "0")
                                            {
                                                //add a node to navigate to parent directory 
                                                node = {
                                                            "data" : "..",
                                                            "attr" : { "id" : "..", "rel" : "parent"},
                                                            "state" : "open",
                                                           };
                                                           
                                                data.push( node );
                                                return data;
                                            }
                                            
                                            //iterate through folders and create child nodes
                                            for(var i=0; i < output.hapi.folders.folder.length; i++ ){
                                                var folder = output.hapi.folders.folder[i];
                                                var child, rel;
                                                
                                                if(i === 0) 
                                                {
                                                    var str = $(MATRIX_PATH).val();
                                                    if(str === '/')
                                                    {
                                                        bAddParent = false;
                                                    }
                                                    else if(i == 0) // && (str.length > 0 && str.indexOf('/') === -1)) 
                                                    {
                                                        bAddParent = true;
                                                        continue;
                                                    }
                                                }   
                                                
                                                //if it is root folder and drive, add the first item as a sibling node instead of parent node
                                                //change icon if folder is a valid package
                                                if(folder.possible_package)
                                                    rel = "package";
                                                else
                                                    rel = "folder";
                                                
                                                //take only last folder name from complete path
                                                //var str = folder.folder_name.substring(folder.folder_name.lastIndexOf('/')+1);
                                                var strfolder, idfolder;
                                                if(str === '/' && folder.folder_name.indexOf('/') != 0) {
                                                    strfolder = folder.folder_name.substring(0, folder.folder_name.indexOf('/')-1);
                                                    idfolder = folder.folder_name.substring(0, folder.folder_name.indexOf('/'));
                                                }
                                                else {
                                                strfolder = folder.folder_name.substring(folder.folder_name.lastIndexOf('/')+1);
                                                idfolder = folder.folder_name;
                                                }
                                                
                                                //create children nodes
                                                if(strfolder.length > 0 && idfolder.length > 0) {
                                                    child = {
                                                        "data" : strfolder,
                                                         "attr" : {"id" : idfolder, "rel" : rel}
                                                        };
                                                    children.push( child );
                                                }
                                            }
                                            
                                            //add a node to navigate to parent directory 
                                            node = {
                                                        "data" : "..",
                                                        "attr" : { "id" : "..", "rel" : "parent"},
                                                        "state" : "open",
                                                       };
                                                       
                                            data.push( node );
                                            
                                            if(bAddParent) {
                                                var rel, val;
                                                if(output.hapi.folders.folder[0].possible_package)
                                                    rel = "package";
                                                else
                                                    rel = "folder";
                                                    
                                                if($(MATRIX_PATH).val() === '')
                                                    val = output.hapi.folders.folder[0].folder_name;
                                                else
                                                    val = $(MATRIX_PATH).val();
                                                //add parent folder to folder list
                                                node = {
                                                            "data" : val,//output.hapi.folders.folder[0].folder_name,
                                                            "attr" : { "id" : val, "rel" : rel}, //{ "id" : output.hapi.folders.folder[0].folder_name, "rel" : rel},
                                                            "metadata" :  output.hapi.folders.folder[0],
                                                            "state" : "open",
                                                            "children" : children
                                                           };
                                                           
                                                data.push( node );
                                            }
                                            else
                                            {
                                                data.push(children);
                                            }
                                            
                                                        
                                            return data;
                                        }
                                   }
                        },
                        "themes" : {
                                "theme" : "default",
                                "url" : "/css/style.css",
                                "dots" : true,
                                "icons" : true
                        },
                        "plugins" : [ "themes", "json_data", "ui" , "crrm", "types" ],
                        "types" : {
                                "max_depth" : -2,
                                "max_children" : -2,
                                "valid_children" : [ "drive" ],
                                "types" : {
                                        "default" : {
                                                "valid_children" : "none",
                                                "icon" : {
                                                        "image" : "/img/hp-piano/collapse-closed.png"
                                                }
                                        },
                                        "folder" : {
                                                "valid_children" : [ "default", "folder", "package" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/collapse-closed.png"
                                                }
                                        },
                                        "package" : {
                                                "valid_children" : [ "default", "folder" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/status-ok.png"
                                                }
                                        },
                                        "drive" : {
                                                "valid_children" : [ "default", "folder" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/down-arrow.png"
                                                },
                                                "start_drag" : false,
                                                "move_node" : false,
                                                "delete_node" : false,
                                                "remove" : false
                                        },
                                        "parent" : {
                                                "valid_children" : [ "default", "folder", "drive", "package" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/grid-collapse.png"
                                                },
                                                "start_drag" : false,
                                                "move_node" : false,
                                                "delete_node" : false,
                                                "remove" : false
                                        }
                                        
                                }
                        }
                })
                .bind("dblclick.jstree", function (event, data) {
                        var node = $(BROWSE_TREE).jstree('get_selected');
                        var xmlname = node[0].id;
                		if (xmlname.match(".xml$"))
                			return;
                        if(node[0].id === "..")
                        {
                            if(node[0].nextSibling)
                            {
                                var str = $(MATRIX_PATH).val(); 
                                if(str === '')
                                {
                                    $(MATRIX_PATH).val(node[0].nextSibling.id.substring(0, node[0].nextSibling.id.lastIndexOf("/")));
                                    $(MATRIX_PATH).trigger('change');
                                }
                                else if(str === '/')
                                {
                                    
                                }
                                else
                                {
                                    if(str.indexOf('/') != -1){
                                        $(MATRIX_PATH).val(node[0].nextSibling.id.substring(0, node[0].nextSibling.id.lastIndexOf("/")));
                                        $(MATRIX_PATH).trigger('change');
                                    }
                                    else{
                                        $(MATRIX_PATH).val("/");
                                        $(MATRIX_PATH).trigger('change');
                                    }
                                }
                            }
                            else
                            {
                                $(MATRIX_PATH).val("/");
                                $(MATRIX_PATH).trigger('change');
                            }
                        }
                        else 
                        {   
                            $(MATRIX_PATH).val(node[0].id);
                            $(MATRIX_PATH).trigger('change');
                        }
                        
                        $(BROWSE_TREE).jstree("refresh");
                })
                .bind("select_node.jstree", function (event, data) { 
                    var node = $(BROWSE_TREE).jstree('get_selected');
                    var str = $(MATRIX_PATH).val(); 
                    var xmlname = node[0].id;
                    
                    var loc_type = $(LOCATION_TYPE).val();
                    if (loc_type != 'FTP'){
                        /*if(node[0] )&& node[0].attributes["rel"].value != "package")
                            $(BROWSE_OK).attr("disabled","disabled");
                        else*/
                            
                            if (xmlname.match(".xml$") && !(str.match(".xml$"))) {
                    			var xmlFileSelected=str + "/" + xmlname;                    			
                    			$(MATRIX_PATH).val(xmlFileSelected);
                    			$(MATRIX_PATH).trigger('change');
								$(BROWSE_OK).removeAttr("disabled");
                    		}
                    }                    
                    else
                        $(BROWSE_OK).removeAttr("disabled");
                        });
                }
         
          	/**
             * @public
             */
            this.resume = function () {
            	selectedTablesID = [];
            	$(COLLAPSE_ADVFILTERS).hpCollapsible('collapse');
				$('#hpsum-custom-baseline-collapsible-ostype').hpCollapsible('collapse');
				$('#hpsum-custom-baseline-collapsible-hardwaretype').hpCollapsible('collapse');
				
            	$(BASELINE_NAME_LABEL).empty();
				hardware_info = [];
				operating_system_array = [];
				NO_COMP_SELECTED = true;
				$("#hpsum-custom-baselines-add-form :input").prop("disabled", false);
				$('#hpsum-bootableiso-opt').hide();
				$('#hpsum-validate-csm-location-type').hide();
            		$('#hpsum-validate-csm-ftp').hide();
                	$('#hpsum-validate-csm-local').hide();
                	$('#hpsum-vbl-proxy-usehp-item').hide();
              	  	$('#hpsum-vbl-proxy-usescript-item').hide();
               	 	$('#hpsum-vbl-components').hide();
               		$('#hpsum-matrix-from-ftp').hide();
				$('#hpsum-custom-baseline-non-matrix-filters').show();
				enableAll();
            	reset(true);
            };
            
            this.pause = function () {
            };
            
            /**
             * @public
             * Initialization funtion for the object
             * All the controls actions are initialized in this function.
             */
            this.init = function() {
				
				$('#createiso-chkbox-item').hide(); 
				
				//Let's add date picker to allow user to pick a date
				$(DATE_VERSION).datepicker({dateFormat: 'yy-mm-dd'});
				       	
            	initialize();
            	
            	selectedTablesID = [];
                
                $('#hpsum-cbl-title').text(localizer.getString("hpsum.baseline.custom.createBaseline"));
	        $(COMPONENT_TYPE).attr('tooltip', localizer.getString('hpsum.baseline.custom.comptypehelp')).hpTooltip();
                $('#hpsum-custom-baseline-collapsible-devtype').attr('tooltip', localizer.getString('hpsum.baseline.custom.deviceTypehelp')).hpTooltip();
		$('#hpsum-custom-baseline-collapsible-hardwaretype').attr('tooltip', localizer.getString('hpsum.baseline.custom.hardwareTypehelp')).hpTooltip();
                formStateView.init({form: FORM, routePattern: ROUTE_PREFIX + '.*', autoTrack: true});
                
                
                $(SAVEAS).live('click', function(ev) {
                	disableActionButtons();
                	disableAll();
                	if(csmfilterselected)
                		onCSMCreate(true);
                	else
                	    onCreate(true);
                    ev.preventDefault();
                });
                
                $(CREATE).live('click', function(ev) {
                	disableActionButtons();
                	disableAll();
                    if(csmfilterselected)
                		onCSMCreate(false);
                	else
                	    onCreate(false);
                    ev.preventDefault();
                });
                
                $(RESET).live('click', function(ev) {
                    reset(true);
                    ev.preventDefault();
                });
                  
                $(CANCEL).live('click', function(ev) {
                    $('#hpsum-hardware-info').html(' ');
					$('#hpsum-operating-system-info').html(' ');
					//$('#hpsum-all-hardware').html(' ');
                    ev.preventDefault();
                });
               	$(PANELS).hpStackedPanels({
                    panelSelector : PANEL_SELECTOR
                });
				$('#hpsum-select-all-dl').live('click', function(ev){
			    if ($('#hpsum-select-all-dl')[0].checked == true)
			    {
			       for (var idx = 0; idx < dl_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-dl-'+idx)[0].checked = true;
					 $('#hpsum-select-all-dl')[0].disabled = true;
					 $('#hpsum-deselect-all-dl')[0].checked = false;
					 $('#hpsum-deselect-all-dl')[0].disabled = false;
			       }
				   
				 
			    }
				});
				$('.hpsum-dl-hardware').live('click', function(ev){
				for (var idx = 0; idx < dl_array.length; idx++)
				{
				if ($('#hpsum-hardware-type-dl-'+idx)[0].checked == false)
				{
				$('#hpsum-select-all-dl')[0].disabled = false;
				$('#hpsum-select-all-dl')[0].checked = false;
				}
				if ($('#hpsum-hardware-type-dl-'+idx)[0].checked == true)
				{
				$('#hpsum-deselect-all-dl')[0].disabled = false;
				$('#hpsum-select-all-dl')[0].disabled = false;
				$('#hpsum-deselect-all-dl')[0].checked = false;
				}
				}
				});
				
				$('#hpsum-deselect-all-dl').live('click', function(ev){
			    if ($('#hpsum-deselect-all-dl')[0].checked == true)
			    {
			       for (var idx = 0; idx < dl_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-dl-'+idx)[0].checked = false;
					 $('#hpsum-select-all-dl')[0].disabled = false;
					 $('#hpsum-select-all-dl')[0].checked = false;
					 $('#hpsum-deselect-all-dl')[0].disabled = true;
			       }
				   
				 
			    }
				});
				$('#hpsum-select-all-ml').live('click', function(ev){
			    if ($('#hpsum-select-all-ml')[0].checked == true)
			    {
			       for (var idx = 0; idx < ml_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-ml-'+idx)[0].checked = true;
					 $('#hpsum-select-all-ml')[0].disabled = true;
					 $('#hpsum-deselect-all-ml')[0].checked = false;
					 $('#hpsum-deselect-all-ml')[0].disabled = false;
			       }
				   			 
			    }
				});
				$('.hpsum-ml-hardware').live('click', function(ev){
				for (var idx = 0; idx < ml_array.length; idx++)
				{
				if ($('#hpsum-hardware-type-ml-'+idx)[0].checked == false)
				{
				$('#hpsum-select-all-ml')[0].disabled = false;
				$('#hpsum-select-all-ml')[0].checked = false;
				}
				if ($('#hpsum-hardware-type-ml-'+idx)[0].checked == true)
				{
				$('#hpsum-deselect-all-ml')[0].disabled = false;
				$('#hpsum-select-all-ml')[0].disabled = false;
				$('#hpsum-deselect-all-ml')[0].checked = false;
				}
				}
				});
				
				$('#hpsum-deselect-all-ml').live('click', function(ev){
			    if ($('#hpsum-deselect-all-ml')[0].checked == true)
			    {
			       for (var idx = 0; idx < ml_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-ml-'+idx)[0].checked = false;
					 $('#hpsum-select-all-ml')[0].disabled = false;
					 $('#hpsum-select-all-ml')[0].checked = false;
					 $('#hpsum-deselect-all-ml')[0].disabled = true;
			       }
				   
				 
			    }
				});
				$('#hpsum-select-all-bl').live('click', function(ev){
			    if ($('#hpsum-select-all-bl')[0].checked == true)
			    {
			       for (var idx = 0; idx < bl_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-bl-'+idx)[0].checked = true;
					 $('#hpsum-select-all-bl')[0].disabled = true;
					 $('#hpsum-deselect-all-bl')[0].checked = false;
					 $('#hpsum-deselect-all-bl')[0].disabled = false;
			       }
				   
				 
			    }
				});
				$('.hpsum-bl-hardware').live('click', function(ev){
				for (var idx = 0; idx < bl_array.length; idx++)
				{
				if ($('#hpsum-hardware-type-bl-'+idx)[0].checked == false)
				{
				$('#hpsum-select-all-bl')[0].disabled = false;
				$('#hpsum-select-all-bl')[0].checked = false;
				}
				if ($('#hpsum-hardware-type-bl-'+idx)[0].checked == true)
				{
				$('#hpsum-deselect-all-bl')[0].disabled = false;
				$('#hpsum-select-all-bl')[0].disabled = false;
				$('#hpsum-deselect-all-bl')[0].checked = false;
				}
				}
				});
				
				$('#hpsum-deselect-all-bl').live('click', function(ev){
			    if ($('#hpsum-deselect-all-bl')[0].checked == true)
			    {
			       for (var idx = 0; idx < bl_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-bl-'+idx)[0].checked = false;
					 $('#hpsum-select-all-bl')[0].disabled = false;
					 $('#hpsum-select-all-bl')[0].checked = false;
					 $('#hpsum-deselect-all-bl')[0].disabled = true;
			       }
				   
				 
			    }
				});
				$('#hpsum-select-all-sl').live('click', function(ev){
			    if ($('#hpsum-select-all-sl')[0].checked == true)
			    {
			       for (var idx = 0; idx < sl_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-sl-'+idx)[0].checked = true;
					 $('#hpsum-select-all-sl')[0].disabled = true;
					 $('#hpsum-deselect-all-sl')[0].checked = false;
					 $('#hpsum-deselect-all-sl')[0].disabled = false;
			       }
				   
				 
			    }
				});
				
				$('#hpsum-select-all-xl').live('click', function(ev){
			    if ($('#hpsum-select-all-xl')[0].checked == true)
			    {
			       for (var idx = 0; idx < xl_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-xl-'+idx)[0].checked = true;
					 $('#hpsum-select-all-xl')[0].disabled = true;
					 $('#hpsum-deselect-all-xl')[0].checked = false;
					 $('#hpsum-deselect-all-xl')[0].disabled = false;
			       }
				   
				 
			    }
				});
				
				$('.hpsum-sl-hardware').live('click', function(ev){
				for (var idx = 0; idx < sl_array.length; idx++)
				{
				if ($('#hpsum-hardware-type-sl-'+idx)[0].checked == false)
				{
				$('#hpsum-select-all-sl')[0].disabled = false;
				$('#hpsum-select-all-sl')[0].checked = false;
				}
				if ($('#hpsum-hardware-type-sl-'+idx)[0].checked == true)
				{
				$('#hpsum-deselect-all-sl')[0].disabled = false;
				$('#hpsum-select-all-sl')[0].disabled = false;
				$('#hpsum-deselect-all-sl')[0].checked = false;
				}
				}
				});
				
				$('#hpsum-deselect-all-sl').live('click', function(ev){
			    if ($('#hpsum-deselect-all-sl')[0].checked == true)
			    {
			       for (var idx = 0; idx < sl_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-sl-'+idx)[0].checked = false;
					 $('#hpsum-select-all-sl')[0].disabled = false;
					 $('#hpsum-select-all-sl')[0].checked = false;
					 $('#hpsum-deselect-all-sl')[0].disabled = true;
			       }
				   
				 
			    }
				});
				$('#hpsum-deselect-all-xl').live('click', function(ev){
			    if ($('#hpsum-deselect-all-xl')[0].checked == true)
			    {
			       for (var idx = 0; idx < xl_array.length; idx++)
			       {
			         $('#hpsum-hardware-type-xl-'+idx)[0].checked = false;
					 $('#hpsum-select-all-xl')[0].disabled = false;
					 $('#hpsum-select-all-xl')[0].checked = false;
					 $('#hpsum-deselect-all-xl')[0].disabled = true;
			       }
				   
				 
			    }
				});
				$('#chkbox-hw-selectall').live('click', function(ev){ 
  			    if ($('#chkbox-hw-selectall')[0].checked == true) 
  			    { 
  			    	$('#chkbox-hw-deselectall')[0].checked = false; 
  			    	$(COMPONENTS_TABLE + ' tbody tr').addClass('hp-selected');	 
  			    	var selectedRows = $(COMPONENTS_TABLE + ' tbody tr'); 
  			    	for (var tmp = 0; tmp < selectedRows.length; tmp++)  
   					    { 
   					    	var data = $(COMPONENTS_TABLE).dataTable().fnGetData(selectedRows[tmp].rowIndex-1); var selectid = data.select.split('"'); 
  							selectid ='#'+ selectid[1];	
  							$(selectid).prop('checked', true);	 
  					    	$(selectid).trigger('change'); 
  					    } 
  					    NO_COMP_SELECTED = false;      
  					    enableActionButtons();  
  				} 
  				});		 
  				$('#chkbox-hw-deselectall').live('click', function(ev){ 	    
  				if ($('#chkbox-hw-deselectall')[0].checked == true) 
  			    {	 
  			    	$('#chkbox-hw-selectall')[0].checked =false;		        
  				    $(COMPONENTS_TABLE + ' tbody tr').removeClass('hp-selected');	 
  			        var selectedRows = $(COMPONENTS_TABLE + ' tbody tr'); 
  			    	for (var tmp = 0; tmp < selectedRows.length; tmp++)  
  					    { 
  					    	var data = $(COMPONENTS_TABLE).dataTable().fnGetData(selectedRows[tmp].rowIndex-1); 
 					    	var selectid = data.select.split('"'); 
 							selectid ='#'+ selectid[1]; 
 							$(selectid).removeAttr('checked'); 
 					    	$(selectid).trigger('change'); 
 					    }  
 					NO_COMP_SELECTED = true;	 
 					disableActionButtons(); 
 				} 
 			    });	    

				$(COLLAPSE).hpCollapsible();
				$(COLLAPSE_SYSTEM).hpCollapsible();
				$(COLLAPSE_STORAGE).hpCollapsible();
				$(COLLAPSE_NIC).hpCollapsible();
				$(COLLAPSE_FCHBA).hpCollapsible();
				$(COLLAPSE_ADVFILTERS).hpCollapsible();
				$(COLLAPSE_ARCH).hpCollapsible();
				$(COLLAPSE_OSTYPE).hpCollapsible();
				$(COLLAPSE_DEVTYPE).hpCollapsible();
				$(COLLAPSE_HWTYPE).hpCollapsible();
				$(COLLAPSE_HWTYPE_DL).hpCollapsible();
				$(COLLAPSE_HWTYPE_ML).hpCollapsible();
				$(COLLAPSE_HWTYPE_BL).hpCollapsible();
				$(COLLAPSE_HWTYPE_SL).hpCollapsible();
				$(COLLAPSE_HWTYPE_XL).hpCollapsible();
				//$(COLLAPSE_SERVER).hpCollapsible();

				$(ADDBASELINE).on('click', onAddBaseline);
				
				$(SELECT_COMPTYPE).selectBox({autoWidth: false});
				
				$(BOOTABLEISO_CHKBOX).on('click', onBootableIsoClick);
				$(MATCHMATRIXVERSION_CHKBOX).on('click',onMatchMatrixVersionClick);
				
				initSourcesTable();
				
				browseDialogContents = $(BROWSE_DIALOG).detach().show();
				confirmDialogContents = $(CONFIRM_DIALOG).detach().show();
                
                $(TARGET_BROWSE_BUTTON).on('click', function () {
                  
                  	initBrowseDialog('target');
                  	
                    createTree('target');
	            });
	            
	            
	            $(ISO_BROWSE_BUTTON).on('click', function () {
                  
                  	initBrowseDialog('iso');
                  	
                    createTree('iso');
	            });
				
				$(ISO_LOCATION).on('keypress', function (e) {
				var key = e.which || e.keyCode;
				if(key == ENTER_KEY)
				{
                  	initBrowseDialog('iso');
                  	createTree('iso');
					e.preventDefault();
				}
	            });
				//addbaselineDialogContents = $('#hpsum-cbl-add-baseline-dialog').detach().show();
				
				router.watch('baseline custom section', ROUTE_PREFIX + '.*',
                    {parent: ROUTE_PREFIX, change: changeLocation});
					
                this.resume();
            };
        }

        return BaselineCustomView;
    }());
    
    return new BaselineCustomView();
});
