// (C) Copyright 2011-2012 Hewlett-Packard Development Company, L.P.

define(['hpsum/presenter/ilofederation/iloFederationPresenter',
        'hp/core/Router',
        'hp/core/UrlFragment',
        'hp/core/Notifications',
        'hp/core/Localizer',
        'jquery',
        'hp/lib/jquery.hpStackedPanels',
        'hp/lib/jquery.hpSearchCombo',
        'lib/jquery.selectBox'],
function(presenter,router, urlFragment, notifications, localizer) { "use strict";

    var iloFederationEditView = (function() {

        var FAILEDMSG ='#hpsum-sug-edit-failed-details',
            FAILEDPANEL ='#hpsum-sug-edit-failed',
            OK = '#hpsum-ilofederation-edit-ok',
            CANCEL ='#hpsum-ilofederation-edit-close',
            PANEL_SELECTOR = '#hpsum-sug-edit-panel-selector',
            PANELS = '#hpsum-sug-edit-panels',
            BASELINES = '#hpsum-sug-edit-baselines-search',
            HOTFIX=  '#hpsum-sug-edit-hotfix-search',
            GROUPNAME = '#hpsum-ilofed-group-name',
            GROUPDESCR = '#hpsum-ilofed-group-descr',
            INTERFACEILO = '#hpsum-ilofed-edit-interfaceilo',
            CURRENT_BASELINE = '#hpsum-ilofed-edit-baseline',
            CURRENT_HOTFIX = '#hpsum-ilofed-edit-addpackage',
            USERNAME = '#hpsum-sug-edit-credential-username',
            PASSWORD = '#hpsum-sug-edit-credential-password',
            USERNAME_ERR ='#hpsum-sug-edit-username-err',
			PASSWORD_ERR ='#hpsum-sug-edit-password-err';
        var ROUTE_PREFIX = '/ilofederation/edit';
                      
        /**
         * Constructor
         */
        function iloFederationEditView() {
          
            var nodeItem=null;
            var baselines='',
                hotfixes='',
                knownilos=[],
                assocBaseline=null,
                newBaseline = null,
                newHotFix  = null,
                assocHotFix = null;
            var searchResults = [];
            
            var optiondetails = { 
					hapi: {
					}
           	};
                
            function onItemChange(item) 
            {
            	item = item.hapi;
            	$(USERNAME).val("");
            	$(PASSWORD).val("");
            	
            	if (item) {
            		
            		$(GROUPNAME).text(item.sug_name);
                    $(GROUPDESCR).val(item.sug_description);
                    
                    nodeItem= item;
                    newBaseline = null;
    				newHotFix  = null;
    				if(item.hasOwnProperty("sug_interface_ilo_ip") && item.sug_interface_ilo_ip)
    					$(INTERFACEILO).text(item.sug_interface_ilo_ip);
    				else
    					$(INTERFACEILO).text("");
    					
                    if(item.baselines || item.sug_baselines){
                    	var tempbaselines = [];
                    	if(item.baselines)
                    		tempbaselines = item.baselines;
                    	else if(item.sug_baselines)
                    		tempbaselines = item.sug_baselines;
                    		
                    	for (var i=0; i<tempbaselines.length; i++ ){
                    		var baseline = presenter.getBaselineDetailsforId(tempbaselines[i]);
                    		if(baseline){
                    			if(baseline.name.match(/^Additional Package/i)){
                    				$(CURRENT_HOTFIX).text(baseline.name);
                    				assocHotFix = baseline; 
                    			}else{
                    				$(CURRENT_BASELINE).text(baseline.name);
                    				assocBaseline = baseline;
                    			}
                    		}
                    	}
 					 }
 					 else {
 					 	$(CURRENT_BASELINE).text('');
                         //editOptions.hapi.baselines = {remove_existing_baselines:'true'};
                         $(CURRENT_HOTFIX).text('');
 					 }
 				} else {
                    $(GROUPNAME).text("");
                    $(GROUPDESCR).val("");
                }
                
            }
            
            function onEdit() 
            {
               var baselinesdata = [];
               if($(BASELINES).val())
                   baselinesdata.push($(BASELINES).val());

               if($(HOTFIX).val())
                  baselinesdata.push($(HOTFIX).val());
               
               if(baselinesdata.length > 0) {
               		optiondetails.hapi.baselines = {remove_existing_baselines:'true'};
               		optiondetails.hapi.baselines.baseline = baselinesdata;
               }
               else
               {
               		optiondetails.hapi.baselines = {remove_existing_baselines:'false'};
               		optiondetails.hapi.baselines.baseline = baselinesdata;
               }
               
               optiondetails.hapi.sug_description = $(GROUPDESCR).val();
               optiondetails.hapi.username = $(USERNAME).val();
               optiondetails.hapi.password = $(PASSWORD).val();
               
               presenter.setattribute(nodeItem,optiondetails, {
						success : function(data) {
							$(CANCEL).trigger('click');
						},
						error : onsetattributeerror
				});
            }
            
            function onsetattributeerror(error) {
            	notifications.show(error);
            	$(FAILEDPANEL).show();
                if(errorMessage)
                    $(FAILEDMSG).text(errorMessage);
                else
                    $(FAILEDMSG).text(localizer.getString('hpsum.ilofederation.editError'));
                    
                $(OK).attr("disabled", "disabled");
            }            
            
            function changeLocation(location) {
                
            }
            
            this.resume = function () {
                presenter.on('itemChange', onItemChange);
                $(PANELS).hpStackedPanels('resume');
                 baselines = hotfixes = localizer.getString('hpsum.common.loading');
                    presenter.getAllBaselines({
                            success:getBaselinesSuccess,
                            error: getBaselinesError
                    });
                $(OK).removeAttr("disabled");
                $(USERNAME).removeClass("hp-error");
            	$(PASSWORD).removeClass("hp-error");
                $(USERNAME_ERR).hide();
				$(PASSWORD_ERR).hide();    
            };
            
            this.pause = function () {
                presenter.off('itemChange', onItemChange);
                $(GROUPNAME).val('');
                $(BASELINES).hpSearchCombo('set', {id:'', name: ''});
                $(HOTFIX).hpSearchCombo('set', {id:'', name: ''});
                $(PANELS).hpStackedPanels('pause');
                $(USERNAME_ERR).hide();
				$(PASSWORD_ERR).hide();
				$(CURRENT_BASELINE).text('');
                $(CURRENT_HOTFIX).text('');
            };
            
            /**
             * @public
             */
            this.init = function () {
              
                $(FAILEDPANEL).hide();
                $(CANCEL).click(function () {
                    router.go(urlFragment.replaceView(router.location(), 'show'));
                });
                $(PANELS).hpStackedPanels({
                        panelSelector : PANEL_SELECTOR
                    });

                //Baselines

                $(BASELINES).hpSearchCombo({getResults:getBaseline});
                $(HOTFIX).hpSearchCombo({getResults: getHotfixes});

                $(OK).on('click', function(ev) {
                    onEdit();
                    ev.preventDefault();
                });
                $(OK).removeAttr("disabled");

                router.watch('ilofederation edit section', ROUTE_PREFIX + '.*',
                    {parent: ROUTE_PREFIX, change: changeLocation});
                
                this.resume();
            };

            function getBaseline(string, handlers,count,start){
                var results=baselines;
                    if (string && string.length > 0) {
                         results =
                            $.grep(baselines, function(option, index) {
                                return (option.name.match(
                                         new RegExp(string, 'i')));
                          });   
                     }
                    handlers.success({count: results.length, members: results,start: 0, total: results.length});
            }
            
            function getHotfixes(string, handlers,count,start){
                    var results=hotfixes;
                    if (string && string.length > 0) {
                         results =
                            $.grep(hotfixes, function(option, index) {
                                return (option.name.match(
                                         new RegExp(string, 'i')));
                          });   
                     }
                    handlers.success({count: results.length, members: results,start: 0, total: results.length});
            }

            function getBaselinesSuccess(searchResults)
            {
                    baselines = $.grep(searchResults, function (option, index ) {
                        return !(option.name.match(new RegExp('^Additional', 'i')));
                    });
                    hotfixes = $.grep(searchResults, function (option, index) {
                        return (option.name.match(new RegExp('^Additional', 'i')));
                    });
            }
            
            function getBaselinesError(msg)
            {
                
            }


        }

        return new iloFederationEditView();
    }());
    
    return iloFederationEditView;
});
