// (C) Copyright 2011-2012 Hewlett-Packard Development Company, L.P.

define(['hpsum/presenter/ilofederation/iloFederationPresenter',
    'hp/core/Router',
    'hp/core/UrlFragment',
    'hp/core/Notifications',
    'hp/view/FormStateView',
    'hp/model/Session',
    'hp/core/Localizer',
    'hp/view/DialogView',
    'text!hpPages/core/header_help.html',
    'jquery',
    'hp/lib/jquery.hpStackedPanels',
    'hp/lib/jquery.hpSearchCombo',
    'hp/lib/jquery.hpCollapsible',
    'hp/lib/jquery.hpToggle',
    'lib/jquery.dataTables',
    'lib/jquery.jstree',
    'hp/lib/jquery.hpSelect'],
function(presenter,router, urlFragment, notifications, FormStateView, session, localizer,DialogView,headerHelpHtml) { "use strict";

    var iloOfflineDeployView = (function() {
      
        var OK = '#hpsum-node-offdeploy-ok';
        var CANCEL ='#hpsum-node-offdeploy-close';
        var FORM = '#hpsum-node-offdeploy-form';
        var TITLE = '#hpsum-node-details-title';
        var TYPE ='#hpsum-node-type';
        var NAME = '#hpsum-node-name',
            INTERFACEILO = '#hpsum-node-interface',
            OFFLINEDEPLOYOPTION= '#hpsum-ilofederation-offdeploy-option',
            BROWSEVALIDATE= '#hpsum-node-isolocation-button',
            FILTERINGDIV='#hpsum-iofed-offdep-filtering',
            FILTERCOLLAPSE= '#hpsum-ilofed-offlinedeploy-collapsible',
            PATH = '#hpsum-node-isolocation',
            BROWSE_TREE = '#browse',
            BROWSE_DIALOG = '#hpsum-browse-dialog',
             BROWSE_LOCATION_ERROR = '#hpsum-invalid-location-error',
             BROWSE_OK='#hp-baseline-add-ok',
            HTTP_URL = '#hpsum-http-url',
            HTTP_ERROR = '#hpsum-invalid-httpurl-error',
            INSTALLED_SYSTEM_TYPE_TABLE = '#ilofed-installed-system-type-table',
            OFFLINE_DEPLOY_CONFORMATION = '#hpsum-offline-deploy-confirm',
            SERVER_RESET_COUNT='#hpsum-offline-deploy-server-count',
            FILTER_NOT_SELECTED = '#hpsum-filter-error',
            ISO_PATH_ERROR = '#hpsum-node-isolocation-error-block',
            SELECTALL = '#ilofed-offline-deploy-selectall',
            DESELECTALL = '#ilofed-offline-deploy-deselectall',
            FORM = '#hpsum-node-offdeploy-form',
            URL_ICON = '#hpsum-url-icon',
			SPLASH_DIALOG = '#hpsum-validate-wait-dialog',
			SPLASH_SPINNER = '#hpsum-add-spinner',
			URL_EMPTY = '#hpsum-node-isolocation-empty-error';

        var poweredOnServerCount;
        
        
        /**
         * Constructor
         */
        function iloOfflineDeployView() {
          
            var formStateView = new FormStateView();
            var inventoryInProgress = false;
            var sugItem=null;
            var searchResults = [];
            var selectedServers =0;
            var browseDialogContents;
            var offlineDeployConfirmationDialog;
			var validateWaitDialog;
                
            function onItemChange(item) {
            	item = item.hapi;
				if(item.sug_state.match(/inventory/i)) {
					$(CANCEL).trigger('click');
				}
                if (item) {
                    $(TITLE).text(item.sug_name);
                    $(NAME).text(item.sug_name);
                    $(INTERFACEILO).text(item.sug_interface_ilo_ip);
                 
                    sugItem= item;
                    $(FILTERCOLLAPSE).hpCollapsible('expand');
                    $("#ilofed-installed-system-type-table > tbody > tr").remove();
                    $("#ilofed-installed-system-type-table_filter").remove();
                    $("#ilofed-installed-system-type-table_processing").remove();
                       // Populate the all the discovered server models and counts
                    if (item.server_types && item.server_types.length > 0) {
                            
                        var systemsTable = initSystemsTable();
                        systemsTable.fnClearTable();

                            // Go ahead and populate all the systems in the systems table
                        var idx;
                        for (idx = 0; idx < item.server_types.length; idx++) {
                            var system = item.server_types[idx];
                            var selectedtoggle = '<input id="selectToggle-' + idx + '" class="toggle" type="checkbox" checked/>';
                            systemsTable.fnAddData([{selected:selectedtoggle, server_model : system.server_model, count : system.count}]);
                        }
                        
                        $(INSTALLED_SYSTEM_TYPE_TABLE + ' tbody tr').addClass('hp-selected');
                        $('.toggle').hpToggle({
                            unchecked : localizer.getString("hpsum.oneTouchUpdate.select"),
                            checked : localizer.getString("hpsum.oneTouchUpdate.selected")
                        });
                      $(INSTALLED_SYSTEM_TYPE_TABLE + " tbody tr").click(function(e) {
                        var srcElem;
                                    //Check if firefox or (chrome and IE)
                        if (e.srcElement) {
                            srcElem = e.srcElement;
                                            //Chrome and IE
                            } else {
                            srcElem = e.target;
                                        //Firefox
                            }
                            var data = systemsTable.fnGetData(this);
                            var clickedCellIndex = srcElem.cellIndex;
                            var selectid = data.selected.split('"');
                            selectid ='#'+selectid[1];
                            if(clickedCellIndex === undefined){
                                if(srcElem.className =='hp-on'){
                                    $(this).removeClass('hp-selected');
                                    $(selectid).removeAttr('checked');
                                }else{
                                     $(FILTER_NOT_SELECTED).hide();
                                     $(this).addClass('hp-selected');
                                    $(selectid).attr('checked', 'checked');
                                }
                                $(selectid).trigger('change');

                            }
                            else {
                                if ($(this).hasClass('hp-selected')) {
                                        $(selectid).removeAttr('checked');
                                    }
                                    else {
                                        $(selectid).prop('checked', true);
                                    }
                                    $(selectid).trigger('change');
                                    $(this).toggleClass('hp-selected');

                            }

                        });
                    }

                    // set the number of servers to be reset during offline deployment process
                    poweredOnServerCount = item.powered_on_servers;
                }
                

            }


            function initSystemsTable() {
                
                if($.fn.DataTable.fnIsDataTable( $(INSTALLED_SYSTEM_TYPE_TABLE)[0] ))
                {
                    $(INSTALLED_SYSTEM_TYPE_TABLE).dataTable().fnDestroy(); 
                }  
                                
                return $(INSTALLED_SYSTEM_TYPE_TABLE).dataTable({
                    bPaginate : false,
                    bLengthChange : false,
                    bFilter : false,
                    bSort : false,
                    bInfo : false,
                    bAutoWidth : false,
                    bRetrieve : true,
                    aoColumns : [
                        {mDataProp: 'selected',"sWidth":"30%"},                       
                        {mDataProp: 'server_model', "sWidth":"30%"},
                        {mDataProp: 'count', "sWidth":"30%"}
                        ]
                });
            }
            function onPathEdit() {
                $(BROWSE_LOCATION_ERROR).hide();
                $(ISO_PATH_ERROR).hide();
                $(PATH).removeClass("hp-error");
				$(URL_EMPTY).hide();
				$(URL_ICON).removeClass('hpsum-error');
                $(PATH).unbind('keyup', onPathEdit);
            }


             function handleInvalidPath(hapi) {
               if (hapi.hcode == 5) {
                    $(BROWSE_LOCATION_ERROR).text(localizer.getString('hpsum.baseline.add.inValidLocation'));
                    $(PATH).addClass("hp-error");
                    $(BROWSE_LOCATION_ERROR).show();
                    $(PATH).keyup(onPathEdit);
                    $('#browse-dialog-cancel').trigger('click');
                        $(ADD).attr("disabled", true);
                } else {
                    $(BROWSE_LOCATION_ERROR).hide();
                    $(PATH).removeClass("hp-error");
                    $(PATH).unbind('keyup', onPathEdit);
                }
            }

             function initBrowseDialog(){
                new DialogView({contents: browseDialogContents,
                    position : "center",
                    ok: function (elem) {
                        
                        var node = $(BROWSE_TREE).jstree('get_selected');
                        if(node[0] == null || (node[0] && node[0].attributes["rel"].value != "package"))
                        {

                            //alert("Please select a valid folder!");
                                showInfoDialog();
                                return false;
                        }
                        $(PATH).val(node[0].id);
                        var path = $(PATH).val();
                        path = path.replace("_C_", ":");
                        $(PATH).val(path);
                        $(PATH).trigger('change');
                        if($(HTTP_URL).val() == ""){
                            $(HTTP_ERROR).show();
                            $(OK).attr("disabled", true);
                        }
                        if($(LOCATION_TYPE).val() == 'local')
                            $(OK).attr("disabled", false);
                    },
                    cancel: function () {
                        $(PATH).val('');
                        $(PATH).trigger('change');
                    }
                });
            }
            
            /**
             * * Create a JsTree inside the browse dialog.
             * * This includes operations such as JSON data load through AJAX call, configuration of tree etc.
             */
            function createTree(){
                
                var uri = "Session/" + session.getToken()  + "/Baseline/browse";
                var initial_folder = $(PATH).val();
                
                $(BROWSE_TREE).empty();
                $(BROWSE_TREE).jstree({
                        "json_data" : {
                                   "ajax" : {
                                        "url" : function (node) {
                                            var url;
                                            if (node == -1) {
                                                url = "Session/" + session.getToken()  + "/Baseline/browse";
                                            } else {
                                                url = null;
                                            }
                                            return url;
                                        },
                                        "type" : "POST",
                                        "dataType" : "json",
                                        "data" : function (n) {
                                            var uri = $(PATH).val().length > 0 ? $(PATH).val() : "..";
                                            uri = uri.replace("_C_", ":"); 
                                                var object = {
                                                        "hapi": {
                                                            "uri": uri
                                                        }
                                                    }; 
                                                
                                                return JSON.stringify(object); 
                                        },
                                        "success" : function (output) {
                                            
                                            var data = [], children = [], index, node, bAddParent = false;
                                            
                                            //This will handle if user has given an invalid location to browse.
                                            handleInvalidPath(output.hapi);
                                            
                                            //hcode has string value in the response payload. This need to be changed later when it is 
                                            //changed to integer value
                                            if(output.hapi.hcode != "0")
                                            {
                                                //add a node to navigate to parent directory 
                                                node = {
                                                            "data" : "..",
                                                            "attr" : { "id" : "..", "rel" : "parent"},
                                                            "state" : "open",
                                                           }
                                                           
                                                data.push( node );
                                                return data;
                                            }
                                            
                                            //iterate through folders and create child nodes
                                            for(var i=0; i < output.hapi.folders.folder.length; i++ ){
                                                var folder = output.hapi.folders.folder[i];
                                                var child, rel;
                                                
                                                if(i === 0) 
                                                {
                                                    var str = $(PATH).val();
                                                    if(str === '/')
                                                    {
                                                        bAddParent = false;
                                                    }
                                                    else if(i == 0) // && (str.length > 0 && str.indexOf('/') === -1)) 
                                                    {
                                                        bAddParent = true;
                                                        continue;
                                                    }
                                                }   
                                                
                                                //if it is root folder and drive, add the first item as a sibling node instead of parent node
                                                //change icon if folder is a valid package
                                                if(folder.possible_package)
                                                    rel = "package";
                                                else
                                                    rel = "folder";
                                                
                                                //take only last folder name from complete path
                                                //var str = folder.folder_name.substring(folder.folder_name.lastIndexOf('/')+1);
                                                var strfolder, idfolder;
                                                if(str === '/' && folder.folder_name.indexOf('/') != 0) {
                                                    strfolder = folder.folder_name.substring(0, folder.folder_name.indexOf('/')-1);
                                                    idfolder = folder.folder_name.substring(0, folder.folder_name.indexOf('/'));
                                                }
                                                else {
                                                strfolder = folder.folder_name.substring(folder.folder_name.lastIndexOf('/')+1);
                                                idfolder = folder.folder_name;
                                                }
                                                idfolder = idfolder.replace(":", "_C_");
                                                //create children nodes
                                                if(strfolder.length > 0 && idfolder.length > 0) {
                                                    child = {
                                                        "data" : strfolder,
                                                         "attr" : {"id" : idfolder, "rel" : rel}
                                                        }
                                                    children.push( child );
                                                }
                                            }
                                            
                                            //add a node to navigate to parent directory 
                                            node = {
                                                        "data" : "..",
                                                        "attr" : { "id" : "..", "rel" : "parent"},
                                                        "state" : "open",
                                                       }
                                                       
                                            data.push( node );
                                            
                                            if(bAddParent) {
                                                var rel, val;
                                                if(output.hapi.folders.folder[0].possible_package)
                                                    rel = "package";
                                                else
                                                    rel = "folder";
                                                    
                                                if($(PATH).val() === '')
                                                    val = output.hapi.folders.folder[0].folder_name
                                                else
                                                    val = $(PATH).val();
                                                
                                                var valId = val; 
                                                valId = valId.replace(":", "_C_");
                                                val = val.replace("_C_", ":");
                                                
                                                //add parent folder to folder list
                                                node = {
                                                            "data" : val,//output.hapi.folders.folder[0].folder_name,
                                                            "attr" : { "id" : valId, "rel" : rel}, //{ "id" : output.hapi.folders.folder[0].folder_name, "rel" : rel},
                                                            "metadata" :  output.hapi.folders.folder[0],
                                                            "state" : "open",
                                                            "children" : children
                                                           }
                                                           
                                                data.push( node );
                                            }
                                            else
                                            {
                                                data.push(children);
                                            }
                                            
                                                        
                                            return data;
                                        }
                                   }
                        },
                        "themes" : {
                                "theme" : "default",
                                "url" : "/css/style.css",
                                "dots" : true,
                                "icons" : true
                        },
                        "plugins" : [ "themes", "json_data", "ui" , "crrm", "types" ],
                        "types" : {
                                "max_depth" : -2,
                                "max_children" : -2,
                                "valid_children" : [ "drive" ],
                                "types" : {
                                        "default" : {
                                                "valid_children" : "none",
                                                "icon" : {
                                                        "image" : "/img/hp-piano/collapse-closed.png"
                                                }
                                        },
                                        "folder" : {
                                                "valid_children" : [ "default", "folder", "package" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/collapse-closed.png"
                                                }
                                        },
                                       /* "package" : {
                                                "valid_children" : [ "default", "folder" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/status-ok.png"
                                                }
                                        },*/
                                        "drive" : {
                                                "valid_children" : [ "default", "folder" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/down-arrow.png"
                                                },
                                                "start_drag" : false,
                                                "move_node" : false,
                                                "delete_node" : false,
                                                "remove" : false
                                        },
                                        "parent" : {
                                                "valid_children" : [ "default", "folder", "drive", "package" ],
                                                "icon" : {
                                                        "image" : "/img/hp-piano/grid-collapse.png"
                                                },
                                                "start_drag" : false,
                                                "move_node" : false,
                                                "delete_node" : false,
                                                "remove" : false
                                        }
                                        
                                }
                        }
                })
                .bind("click.jstree", function (event, data) {
                        var node = $(BROWSE_TREE).jstree('get_selected');
                        if(node[0].id === "..")
                        {
                            if(node[0].nextSibling)
                            {
                                var str = $(PATH).val(); 
                                if(str === '')
                                {
                                    $(PATH).val(node[0].nextSibling.id.substring(0, node[0].nextSibling.id.lastIndexOf("/")));
                                    $(PATH).trigger('change');
                                }
                                else if(str === '/')
                                {
                                    
                                }
                                else
                                {
                                    if(str.indexOf('/') != -1){
                                        $(PATH).val(node[0].nextSibling.id.substring(0, node[0].nextSibling.id.lastIndexOf("/")));
                                        $(PATH).trigger('change');
                                    }
                                    else{
                                        $(PATH).val("/");
                                        $(PATH).trigger('change');
                                    }
                                }
                            }
                            else
                            {
                                $(PATH).val("/");
                                $(PATH).trigger('change');
                            }
                        }
                        else 
                        {   
                            $(PATH).val(node[0].id);
                            $(PATH).trigger('change');
                        }
                        
                        $(BROWSE_TREE).jstree("refresh");
                })
                .bind("select_node.jstree", function (event, data) { 
                    var node = $(BROWSE_TREE).jstree('get_selected');
                    var loc_type = 'local';
                    if (loc_type != 'FTP' && loc_type != 'HTTP'){
                        if(node[0] && node[0].attributes["rel"].value != "package")
                            $(BROWSE_OK).attr("disabled","disabled");
                        else
                            $(BROWSE_OK).removeAttr("disabled");
                        }
                    else
                        $(BROWSE_OK).removeAttr("disabled");
                    });
                }
            
       

            function onBrowse(){
                 initBrowseDialog();

                $(BROWSE_OK).attr("disabled", "disabled");
                    createTree();
            }
			
			function showValidateWait(msg) {					
					
					if (!validateWaitDialog) {
						validateWaitDialog = $(SPLASH_DIALOG);
						validateWaitDialog.dialog({
							modal : true,
							dialogClass : 'hp-simple-dialog',
							position : "center",
							draggable : false,
							resizable : false,
							width : 260,
							height : 180
						});
					}
					if(msg == undefined)
						msg = localizer.getString('hpsum.ilofederation.validateInProgress');
					$('#hpsum-validate-wait-message', validateWaitDialog).html(msg);
					$(SPLASH_SPINNER).show();
					msg='';
					validateWaitDialog.dialog('open');
				}
				
			function closeValidateWait() {
					$(SPLASH_SPINNER).hide();
					if (validateWaitDialog) {
						validateWaitDialog.dialog('close');
					}
			}

            function onValidate(startdeploy){
			
			    if(startdeploy == null)
					startdeploy = false;
					
                var isValidIp = false;
                var urlEntered = $(PATH).val().toLowerCase();
				if (urlEntered.length == 0)
				{
				    //put in the proper error  message here
					$(URL_EMPTY).fadeIn('fast');
					$(PATH).addClass('hp-error');
					$(PATH).on("keyup", onPathEdit);
					//$(ISO_PATH_ERROR).fadeIn('fast');
					$(URL_ICON).removeClass('hpsum-ok').addClass('hpsum-error');
					return false;
				}

                var parser = document.createElement('a');
                parser.href = urlEntered;
                var ip = parser.hostname;


                if(ip.toLowerCase() == 'localhost')
                   isValidIp = true;
                    //ipv4 match
                if(ip == '0.0.0.0' | ip == '255.255.255.255'){
                    onItemAddError(localizer.getString('hpsum.node.ipCannotBe') + ' ' + ip);
                    isValidIp = false;
                }
                var patt = /^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
                if(ip.match(patt))
                    isValidIp = true;
                else{
                    patt = /^((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))?$/;
                    if(ip.match(patt))
                        isValidIp = true;
                    else
                    {
                        patt = /^[a-zA-Z0-9-_]+(\.[a-zA-Z0-9-_]+)*\.([a-zA-Z]{2,4})$/;
                        //FQDN match
                        if(ip.match(patt))
                            isValidIp = true;                           
                        else{
                            //check for unqualified domain name or netbios hostname
                            var hostnamepatt = "^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$";
                            if(ip.match(hostnamepatt))
                                isValidIp = true;                            
                        }
                     }
                }

                var protocolUsed = parser.protocol; 
                if(protocolUsed != "http:" || (!isValidIp))
                {
                    $(PATH).addClass('hp-error');
                    $(PATH).on("keyup", onPathEdit);
                    $(ISO_PATH_ERROR).fadeIn('fast');
                    $(URL_ICON).removeClass('hpsum-ok').addClass('hpsum-error');
                    return false;

                }
                 else
                 {
                    //var isoPattern  = /\.(iso)+$/;
					var isoPattern  = /\/*\.(iso)+$/;
                    if(!urlEntered.match(isoPattern))
                    {
                        $(PATH).addClass('hp-error');
                        $(PATH).on("keyup", onPathEdit);
                        $(ISO_PATH_ERROR).fadeIn('fast');
                        $(URL_ICON).removeClass('hpsum-ok').addClass('hpsum-error');
                        return false;
                    }                   
                    
                 }
				 
				showValidateWait();
				var data;
                var retcode;
				
				presenter.validate({ url_path:$(PATH).val()
										},
										{
											success:function(data){
                                                retcode = data.hapi.hcode;
												closeValidateWait();
                                                 if(retcode == 0)
                                                 {
													$(PATH).removeClass('hp-error');
                                                    $(URL_ICON).removeClass('hpsum-error').addClass('hpsum-ok');
                                                    $(ISO_PATH_ERROR).fadeOut('fast');
													if(startdeploy)
														onValidateSuccess();
														
                                                    return true;

                                                 }
                                                 else
                                                 {
                                                    $(PATH).addClass('hp-error');
                                                    $(PATH).on("keyup", onPathEdit);
                                                    $(ISO_PATH_ERROR).fadeIn('fast');
                                                    $(URL_ICON).removeClass('hpsum-ok').addClass('hpsum-error');
                                                    return false;
                                                 }
											},
											error:function(data){
												closeValidateWait();
                                                $(PATH).addClass('hp-error');
                                                $(PATH).on("keyup", onPathEdit);
                                                $(ISO_PATH_ERROR).fadeIn('fast');
                                                $(URL_ICON).removeClass('hpsum-ok').addClass('hpsum-error');
                                                return false;
											}
										});
             }

            function deployOptionChanged(val){
                if($(OFFLINEDEPLOYOPTION).val() == 'hpsum' || val =='hpsum'){
                    $(BROWSEVALIDATE).off('click', onValidate);
                    $(BROWSEVALIDATE).on('click', onBrowse);
                    $(BROWSEVALIDATE).text(localizer.getString("hpsum.common.browse"));
                }else{
                     $(BROWSEVALIDATE).off('click', onBrowse);
                    $(BROWSEVALIDATE).on('click', function(ev){onValidate(false);});
                    $(BROWSEVALIDATE).text(localizer.getString("hpsum.baseline.show.validate"));

                }

            }

            function getAllSelectedServerTypes()
            {

                var selectedList = [];
                selectedServers =0;
                var totalRows = $(INSTALLED_SYSTEM_TYPE_TABLE + ' tbody tr').size();
                var selectedRows = $(INSTALLED_SYSTEM_TYPE_TABLE + ' tbody tr.hp-selected').size();

                // If all the rows stay selected, we do not have to filter by servers
                if (totalRows != selectedRows) {
                    $(INSTALLED_SYSTEM_TYPE_TABLE + ' tbody tr.hp-selected').each(function(index, value){
                        var list = $('td',value);
                        selectedServers +=  Number($(list[2]).text());
                        selectedList.push($(list[1]).text());
                    });
                } else {
                    selectedList.push("AllSelected");
                }

                return selectedList;
            }

            function onDeploy(ev)
            {
              
				 var mode;
                if($(OFFLINEDEPLOYOPTION).val() != 'hpsum'){
                    mode = 1;
                }else{
                    mode = 0;
                }

                var serverTypes = getAllSelectedServerTypes();

                if( serverTypes.length != 0 ) {
                    if (serverTypes[0] == "AllSelected")
                        serverTypes = [];
                }
                    
                presenter.deploy(  {  deploy_mode:mode,
                                      url_or_path:$(PATH).val(),
                                      server_type_filter: serverTypes,
                                      sug_id : sugItem.sug_id
                                 },
                                 {
                                    success:function(data){

                                    },
                                    error:function(data){

                                    }
                                });
                $('#hpsum-node-offdeploy-close').trigger('click');
				
				ev.preventDefault();
               
            }
			
			function onValidateSuccess()
			{	
				var serverTypes = getAllSelectedServerTypes();

                    if( serverTypes.length == 0 )
                    {
                        $(FILTER_NOT_SELECTED).fadeIn(400, function(){});
                        ev.preventDefault();
                        return false;
                    }
                    else 
                    {
                        $(FILTER_NOT_SELECTED).fadeOut(400, function(){});
                    }
		                        var serverCount =0;
                    if (serverTypes[0] == "AllSelected") 
                        serverCount = poweredOnServerCount;
                    else
                        serverCount = selectedServers;

                    

                    $(SERVER_RESET_COUNT, offlineDeployConfirmationDialog).text(serverCount);

                   
                    new DialogView({contents: offlineDeployConfirmationDialog,
	                    position : "center",
	                    ok: function (elem) {	                        
	                       onDeploy();
	                    },
	                    cancel: function () {
	                        
	                    }
	                });
			}


            
            this.resume = function () {
            	presenter.on('itemChange', onItemChange);
                $(FILTER_NOT_SELECTED).hide();
				$(URL_EMPTY).hide();
		 selectedServers =0;		
                deployOptionChanged();

            };
            
            this.pause = function () {
            	presenter.off('itemChange', onItemChange);
                $(ISO_PATH_ERROR).fadeOut('fast');
				$(URL_EMPTY).fadeOut('fast');
            };

            /**
             * @public
             */
            this.init = function () {
              
				var resource = router.location().split('/');
                	resource = resource[1];
                	if(resource === 'node')
                		$(TYPE).val("Unknown");
                	else
                		$(TYPE).val(resource);
               		$('#hpsum-node-offdeploy-close').click(function () {
                    router.go(urlFragment.replaceView(router.location(), 'show'));
                });

                $(FILTER_NOT_SELECTED).hide();

                browseDialogContents = $(BROWSE_DIALOG).detach().show();
                offlineDeployConfirmationDialog = $(OFFLINE_DEPLOY_CONFORMATION).detach().show();
               
               var ROUTE_PREFIX = '/'+ resource +'/offlinedeploy';
               
               $(OFFLINEDEPLOYOPTION).hpSelect().on('change', deployOptionChanged);
                
                $(OK).on('click', function(ev) {
                    onValidate(true);                    
                    ev.preventDefault();
                });
                
                $(SELECTALL).on('click', function(ev){
			    	$(INSTALLED_SYSTEM_TYPE_TABLE + ' tbody tr').each( function () {
		                $(this).addClass('hp-selected');
		                var temptable = $(INSTALLED_SYSTEM_TYPE_TABLE).dataTable();
		                var data = temptable.fnGetData(this);
                        var selectid = data.selected.split('"');
                        selectid ='#'+selectid[1];
                        $(selectid).attr('checked', 'checked');
                        $(selectid).trigger('change');
		            });
			    });
				
				$(DESELECTALL).on('click', function(ev){
			    	$(INSTALLED_SYSTEM_TYPE_TABLE + ' tbody tr').each( function () {
		            	$(this).removeClass('hp-selected');
		            	var temptable = $(INSTALLED_SYSTEM_TYPE_TABLE).dataTable();
		            	var data = temptable.fnGetData(this);
                        var selectid = data.selected.split('"');
                        selectid ='#'+selectid[1];
                        $(selectid).removeAttr('checked');
                        $(selectid).trigger('change');
		            });
			    });
				
                $(FILTERCOLLAPSE).hpCollapsible();

                 if ($('.hp-details-header-controls', $(FORM).parent()).length === 0) {
                    var headerHelp = $(headerHelpHtml);
                    localizer.localizeDom(headerHelp);
                    $('.hp-details-header', $(FORM).parent()).append(headerHelp);
                }
                $(ISO_PATH_ERROR).fadeOut('fast');

                
                this.resume();
            };
        }

        return new iloOfflineDeployView();
    }());
    
    return iloOfflineDeployView;
});
