// (C) Copyright 2011-2012 Hewlett-Packard Development Company, L.P.

define(['hpsum/presenter/node/NodePresenter',
    'hp/core/Router',
    'hp/core/UrlFragment',
    'hp/core/Notifications',
	'hp/core/Localizer',
    'hp/view/FormStateView',
    'jquery',
    'hp/lib/jquery.hpStackedPanels',
    'hp/lib/jquery.hpSearchCombo',
    'hp/lib/jquery.hpCollapsible',
    'lib/jquery.selectBox'],
function(presenter,  router, urlFragment, notifications, localizer, FormStateView) { "use strict";

    var NodeEditView = (function() {
      
        var OK = '#hpsum-node-edit-ok';
        var PANEL_SELECTOR = '#hpsum-node-edit-panel-selector';
        var PANELS = '#hpsum-node-edit-panels';
        var FORM = '#hpsum-node-edit-form';
        var TITLE = '#hpsum-node-details-title';
        var TYPE ='#hpsum-node-type';
        var NAME = '#hpsum-node-name',
        	CANCEL ='#hpsum-node-edit-close',
        	DESCRIPTION = '#hpsum-node-description',
        	USERNAME = '#hpsum-node-credential-username',
           	PASSWORD = '#hpsum-node-credential-password',
			CURRENT_BASELINE = '#hpsum-node-baseline',
            CURRENT_HOTFIX = '#hpsum-node-addpackage',
			LINUXUSERNAME = '#hpsum-linux-node-credential-username',
			LINUXPASSWORD = '#hpsum-linux-node-credential-password',
			LINUX_ENTER_CRED = '#hpsum-linux-node-cred-details',
			LINUX_CRED_PANEL = '#hpsum-linux-node-edit-credentials',
        	BASELINES = '#hpsum-node-baselines-search',
        	NONECHECKBOX = '.nonecheckbox',
        	USESNMPCHECKBOX ='.useSNMPcheckbox',
			USEAGENTLESSCHECKBOX ='.useAgentlesscheckbox',
			INSTALLATIONOPTION = '#hpsum-installation-option',
			USEWEBEMCHECKBOX ='.useWEBEMcheckbox',
			DOWNGRADECHKBOXCOMP ='.downgradechkbox',
			REWRITECHKBOXCOMP ='.rewritechkbox',
			INSTALL_ERROR='#force-options-tbody-err',
			FIRMWARECHKBOXCOMP ='.firmwarechkbox',
			SOFTWARECHKBOXCOMP ='.softwarechkbox',
			REBOOTOPTION = '#hpsum-reboot-option',
			DELAYSEC= '#hpsum-node-delay-seconds',
			DELAYSECERR= '#hpsum-node-delay-seconds-err',
			DELAYMSG= '#hpsum-node-reboot-message',
			REBOOT_ACTIVATE = '#hpsum-reboot-to-activate-options',
			COMMON_REBOOT = '#hpsum-common-reboot-options',
			ACTIVATE_SELECTION = '#hpsum-activate-selection',
			NO_REBOOT_REQ = '#hpsum-no-reboot-required',
            HOTFIX = '#hpsum-node-hotfix-search',
        	PARTNER_TYPE ='#hpsum-node-add-partner',
           	PARTNER_CRED_PANEL ='#hpsum-node-add-partner-credentials',
            PARTNER_IP_LABEL = '#hpsum-node-partner-ip',
            PARTNER_IP_VALUE ='#hpsum-node-partner-ip-value',
            PARTNER_ENTER_CRED = '#hpsum-node-partner-cred-details',
            PARTNER_USERNAME = '#hpsum-node-partner-credential-username',
           	PARTNER_PASSWORD = '#hpsum-node-partner-credential-password',
			ADD_ASSOC_NODES = '#hpsum-node-addassocnodes',
			BASELINE_INPUT = '#hpsum-node-baselines-search-input',
			BASELINE_INPUT_ERR = '#hpsum-node-baselines-search-input-err',
			HOTFIX_INPUT = '#hpsum-node-hotfix-search-input',
			HOTFIX_INPUT_ERR = '#hpsum-node-hotfix-search-input-err';
        var ROUTE_PREFIX = '/node/edit';
        
        /**
         * Constructor
         */
        function NodeEditView() {
          
            var formStateView = new FormStateView();
            var updateInProgress = false;
			var useSudoCredentials = false;
            var searchResults = [];
            var nodeItem = null;
	    var checkedVal = '';
            var currentbaseline = "";
            var currenthotfixbaseline = "";
            var baselines = "";
            var hotfixes = "";
            var newbaseline = "";
            var newhotfix = "";
            var partnerUsername ='';
            var partnerPassword ='';
            var partnerType ='';
            var auto_add_assoc_nodes;
            var node_skip = $("input[name='hpsum-node-edit-active']:checked").val();
            var editOptions =  {
                    	hapi: {
                    	username : $(USERNAME).val(),
                    	password : $(PASSWORD).val(),
                    	description : $(DESCRIPTION).val(),
						su_username : $(LINUXUSERNAME).val(),
						su_password : $(LINUXPASSWORD).val(),
						use_sudo : useSudoCredentials,
						auto_add_assoc_nodes : auto_add_assoc_nodes,
						node_skip : node_skip
                    	}
                    };
			var setOk = false;
			
            function onItemChange(item) {
            	item = item.hapi;
                if (item) {
                	nodeItem =item;
                    $(TITLE).text(item.name);
                    $(NAME).text(item.name);
                    $(DESCRIPTION).val(item.description);

					
                    if(nodeItem.hasOwnProperty('activate_sfw')){
					    $('#hpsum-reboot-options-collapsible').removeClass('hp-collapsed');
						$(COMMON_REBOOT).hide();
						$(REBOOT_ACTIVATE).show();
						if(!nodeItem.is_powered_on) {
							$(ACTIVATE_SELECTION).closest("li").hide();
							$(NO_REBOOT_REQ).show();
						} else {
							$(ACTIVATE_SELECTION).closest("li").show();
							$(NO_REBOOT_REQ).hide();
						}
						if(nodeItem.activate_sfw) {
							$(ACTIVATE_SELECTION).val('YES');
						} else {
							$(ACTIVATE_SELECTION).val('NO');
						}
					} else {
						if(nodeItem.type.match(/windows|linux|hpux|vmware/i)){
						$(COMMON_REBOOT).show();
						$(NO_REBOOT_REQ).hide();
						$('#hpsum-reboot-options-collapsible').css("display","block");
						$(REBOOT_ACTIVATE).hide();
						}
						else{
							$('#hpsum-reboot-options-collapsible').css("display","none");
						}
					}
                    showInstallationOptions(item);
					/*if(nodeItem.type.match(/Windows|Linux/i)) {
					   $('#hpsum-osmanagement-options-collapsible').css("display","block");
					   $('#hpsum-node-deploy-osmanagement-Options').css("display","block");
					   if(!$('#hpsum-node-deploy-osmanagement-Options-li').length)
					   {
						   $('#hpsum-node-reboot-options-li').closest('li').before('<li id="hpsum-node-deploy-osmanagement-Options-li"><a class="hp-anchor-uri" data-panel-id="hpsum-node-deploy-osmanagement-Options" href="#/node/edit/options">'+ localizer.getString("hpsum.node.osManagementOptions") +'</a></li>');
					   }
					}
					else {
						$('#hpsum-osmanagement-options-collapsible').css("display","none");
						$('#hpsum-node-deploy-osmanagement-Options').css("display","none");
						$('#hpsum-node-deploy-osmanagement-Options-li').remove();
					}*/
					if(nodeItem.type.match(/integrityilo|ipdu|virtual_connect/i)) {
					    $('#hpsum-installation-options-collapsible').css("display","none");
					    $("#hpsum-force-options-collapsible").css("display","none");

					}
					else
					{	
						$('#hpsum-force-options-collapsible').css("display","block");
						$('#hpsum-installation-options-collapsible').css("display","block");
					}
					if(nodeItem.type.match(/ipdu|virtual_connect/i))
					    {
					    	$('#hpsum-node-reboot-options').css("display","none");
							$('#hpsum-node-reboot-options-li').remove();
					    }
					    else{
					    	$('#hpsum-node-reboot-options').css("display","block");
							if(!$('#hpsum-node-reboot-options-li').length)
							{
								$('#hpsum-node-details-edit li:last').after('<li id="hpsum-node-reboot-options-li"><a class="hp-anchor-uri" data-panel-id="hpsum-node-reboot-options" href="#/node/edit/installationoptions">' + localizer.getString("hpsum.node.installationOptions") + '</a></li>');
							}
					    }
					if(nodeItem.type.match(/virtual_connect/i)) {
						$('#hpsum-vc-options-collapsible').css("display","block");
						$('#hpsum-node-deploy-vc-Options').css("display","block");	
						$('#hpsum-vc-options-collapsible').hpCollapsible('expand');
						$('#hpsum-vc-options-collapsible').show();
						if(!$('#hpsum-node-deploy-vc-Options-li').length)
						{
							$('#hpsum-node-details-edit li:last').after('<li id="hpsum-node-deploy-vc-Options-li"><a class="hp-anchor-uri" data-panel-id="hpsum-node-deploy-vc-Options" href="#/node/edit/vcoptions">' + localizer.getString("hpsum.node.vcOptionstitle") + '</a></li>');
						}
					}
					else
					{
						$('#hpsum-vc-options-collapsible').css("display","none");
						$('#hpsum-node-deploy-vc-Options').css("display","none");
						$('#hpsum-node-deploy-vc-Options').remove();
						$('#hpsum-vc-options-collapsible').hide();
					}
					
		            if(item.type.match(/ilo/i))
					{
						$(TYPE).selectBox('value', "ilo");
					}
					else
					{
						$(TYPE).selectBox('value', item.type.toLowerCase());
					}	

					
		            if(item.type.match(/integrityilo/i))
		              $(TYPE).selectBox('value', 'ilo');
		       showPartnerOptions();
                    if(item.baselines){
                        for (var i=0; i<item.baselines.length; i++ ){
                            var baseline = presenter.getBaselineDetailsforId(item.baselines[i]);
                            if(baseline){
                                if(baseline.name.match(/^Additional/i)){
                                    currenthotfixbaseline = baseline; 
                                    $(CURRENT_HOTFIX).text(baseline.name);
                                    $(HOTFIX).hpSearchCombo('set', {id: baseline.id, name: baseline.name});
                                }else{
                                    currentbaseline = baseline;
                                    $(CURRENT_BASELINE).text(baseline.name);
                                    $(BASELINES).hpSearchCombo('set', {id: baseline.id, name: baseline.name});
                                }
                            }
                        }
                     } else {
                         $(CURRENT_BASELINE).text('');
                         editOptions.hapi.baselines = {remove_existing_baselines:'true'};
                         $(CURRENT_HOTFIX).text('');
                     }
                } else {
                    $(TITLE).text('');
                }

                formStateView.reset();
            }
            
            function onItemError(errorMessage) {
                formStateView.noItem(errorMessage);
            }
			function validate()
			{
				var type = $(INSTALLATIONOPTION).val();
				var software = $(FIRMWARECHKBOXCOMP).is(':checked');
				var firmware = $(SOFTWARECHKBOXCOMP).is(':checked');
				if ( type !='None' )
				{
					if ( !(software || firmware ))
					return false;
				
				}
				return true;
			}
			function errormsg()
			{
				$(INSTALL_ERROR).hide();
			}
            
            function showInstallationOptions(item){
            	//send getattributes for this node
            	presenter.otheroption(item, {success:function(data){
            						if(data && data.hasOwnProperty("hapi")){
				
				
				if(data.hapi.hasOwnProperty("reboot_options") && data.hapi.reboot_options){
						 
						$('#hpsum-reboot-option option').filter(function() {
			             if(new RegExp(this.value, 'ig').test( data.hapi.reboot_options.action))
		    		            $(this).attr('selected', true);
		                  });
						if( -1 < data.hapi.reboot_options.delay){
							$(DELAYSEC).val(data.hapi.reboot_options.delay);				
						}
						else{
							$(DELAYSEC).val('3600');				
						}
						
						$(DELAYMSG).attr('value', data.hapi.reboot_options.message);				
					}
					/*if(data.hapi.hasOwnProperty("os_management_options") && data.hapi.os_management_options){
						$(USESNMPCHECKBOX).attr('checked', false);							
						$(USEAGENTLESSCHECKBOX).attr('checked', false);							
						$(USEWEBEMCHECKBOX).attr('checked', false);
						$(NONECHECKBOX).attr('checked', false);
						if( data.hapi.os_management_options.length > 0){
							if(data.hapi.os_management_options[0].match(/NONE/i))
								$(NONECHECKBOX).attr('checked', true);
							else{
								if (data.hapi.os_management_options[0].match(/AMS/i))
									$(USEAGENTLESSCHECKBOX).attr('checked', true);
								if (data.hapi.os_management_options[0].match(/SNMP/i))
									$(USESNMPCHECKBOX).attr('checked', true);
								if (data.hapi.os_management_options[0].match(/WBEM/i))
									$(USEWEBEMCHECKBOX).attr('checked', true);
									
							}
						}
					}*/
					if(data.hapi.hasOwnProperty("installation_option") && data.hapi.installation_option){
						if ( !data.hapi.installation_option.rewrite  && !data.hapi.installation_option.downgrade)
						{
							$(INSTALLATIONOPTION).val('None');
							$('#hp-force-downgrade-rewrite').hide();
							data.hapi.installation_option.firmware = false;
							data.hapi.installation_option.software = false;						
						}
						else if ( data.hapi.installation_option.rewrite  && data.hapi.installation_option.downgrade)
						{
							$(INSTALLATIONOPTION).val('Both');
							$('#hp-force-downgrade-rewrite').show();
						}
						else
						{
							if (data.hapi.installation_option.rewrite )
								$(INSTALLATIONOPTION).val('Rewrite');
					
							if (data.hapi.installation_option.downgrade )
								$(INSTALLATIONOPTION).val('Downgrade');
							$('#hp-force-downgrade-rewrite').show();
						}
						
						$(INSTALLATIONOPTION).selectBox('reset');
						$(FIRMWARECHKBOXCOMP).attr('checked', data.hapi.installation_option.firmware);							
						$(SOFTWARECHKBOXCOMP).attr('checked', data.hapi.installation_option.software);	
										
										
					}
					if(data.hapi.hasOwnProperty("vc_activation_options") && data.hapi.vc_activation_options){
						$('#hpsum-Enet-order option').filter(function() {
			             if(new RegExp(this.value, 'ig').test( data.hapi.vc_activation_options.eth_activation_order))
		    		            $(this).attr('selected', true);
		                  });
		                 $('#hpsum-fc-order option').filter(function() {
			             if(new RegExp(this.value, 'ig').test( data.hapi.vc_activation_options.fc_activation_order))
		    		            $(this).attr('selected', true);
		                  });
						$('#hpsum-Enet-delay').val(data.hapi.vc_activation_options.eth_activation_delay);
						$('#hpsum-FC-delay').val(data.hapi.vc_activation_options.fc_activation_delay);
					}
					if(data.hapi.hasOwnProperty("auto_add_assoc_nodes") && data.hapi.auto_add_assoc_nodes)
						$(ADD_ASSOC_NODES).attr('checked', true);
					else
						$(ADD_ASSOC_NODES).attr('checked', false);				
					if(data.hapi.hasOwnProperty("node_skip"))
						if(data.hapi.node_skip)
							$("input[name='hpsum-node-edit-active']")[0].checked = true;
					else
							$("input[name='hpsum-node-edit-active']")[1].checked = true;
				}
				},
            	error:function(){
            		
            	}
            		
            	});
            	
            	
            }

            function onItemUpdateSuccess(item) {
                updateInProgress = false;
                formStateView.reset();
                $(CANCEL).trigger('click');
            }
            function showPartnerOptions() {
                var nodeType = $(TYPE).val().toLowerCase();
				if (nodeType.match(/Windows/i) ||
					nodeType.match(/Linux/i) ||
					nodeType.match(/hpux/i))
					$('#hpsum-node-edit-alreadyExist').show();
				else
					$('#hpsum-node-edit-alreadyExist').hide();
				if(nodeType.match(/Linux|hpux/i)){
					$(LINUX_CRED_PANEL).css({"display":""});
					$(LINUX_ENTER_CRED).hide();
					//$('input[name="hpsum-linux-node-credential"]').click(linuxCredentialOptions);
					//linuxCredentialOptions("two");
				}
				else
					$(LINUX_CRED_PANEL).css({"display":"none"});
					
				if(nodeType.match(/sas_switch/i) || 
            		nodeType.match(/virtual_connect/i) ||
            		nodeType.match(/ipdu/i)) {
            			if(nodeType.match(/ipdu/i)){
            				$(PARTNER_TYPE).html(localizer.getString('hpsum.common.PartnerIpduCredentials'));
            				$(PARTNER_IP_LABEL).html(localizer.getString('hpsum.common.PartnerIpduIP'));
            				partnerType = 'ipdu';
            			}
            			else{
            				$(PARTNER_TYPE).html(localizer.getString('hpsum.common.associatedOACredentials'));
            				$(PARTNER_IP_LABEL).html(localizer.getString('hpsum.common.associatedOAIp'));
            				partnerType = 'oa';
            			}
            				
            			$(PARTNER_CRED_PANEL).css({"display":""});;
            			$('input[name="hpsum-node-partner-credential"]').click(partnerCredentialsOptions);
            			partnerCredentialsOptions("two");
            			
            		
            		}
            	else{
            		$(PARTNER_CRED_PANEL).css({"display":"none"});
            		partnerType ='';
            	}
				
				if($(TYPE).val().toLowerCase().match(/virtual_connect/i) ||
            			$(TYPE).val().toLowerCase().match(/sas_switch/i) ||
            			$(TYPE).val().toLowerCase().match(/oa/i) ||
						$(TYPE).val().toLowerCase().match(/fc_switch/i) ||
						$(TYPE).val().toLowerCase().match(/ilo/i)) {
            				$(ADD_ASSOC_NODES).show();
							$('#hpsum-node-addassoc-description').show();
				}
            	else {	
            			$(ADD_ASSOC_NODES).hide();
						$('#hpsum-node-addassoc-description').hide();
				}
				if($(TYPE).val().toLowerCase().match(/virtual_connect/i))
					$('#hpsum-node-deploy-vc-Options').show();
				else
					$('#hpsum-node-deploy-vc-Options').hide();
           	
				
				//Moonshot
				if(nodeType.match(/moonshot/i)) {
				    $('#hpsum-node-cred-details').hide();
				    $('#hpsum-moonshot-edit-credentials').show();
				} else {
				    $('#hpsum-node-cred-details').show();
                    $('#hpsum-moonshot-edit-credentials').hide();
				}
           }
		   function linuxCredentialOptions(value)
           {
           	    if(value.target)
            		value = value.target.value;
				if(checkedVal === value)
				{
					checkedVal = '';
					useSudoCredentials =false;
					if(value ==="one")
						$('#hpsum-linux-node-sudo').attr('checked',false);
					if(value == "two"){
						$(LINUX_ENTER_CRED).hide();
						$('#hpsum-linux-node-root').attr('checked',false);
					}
				}
				else{
					checkedVal = $('input[name="hpsum-linux-node-credential"]:checked').val();
					if(value == "one"){
						$(LINUX_ENTER_CRED).hide();
						useSudoCredentials =true;
					}
					if(value == "two"){
						$(LINUX_ENTER_CRED).show();
						useSudoCredentials = false;
					}
				}
           }
		   
           function partnerCredentialsOptions(value)
           {
           	    if(value.target)
            		value = value.target.value;
            	if(value == "one"){
            		$(PARTNER_ENTER_CRED).hide();
            		partnerUsername= $(USERNAME).val();
            		partnerPassword= $(PASSWORD).val();
            		//useCurrentCredentials =true;
            	}
            	if(value == "two"){
            		$(PARTNER_ENTER_CRED).show();
            	}
           	
           }
           

            /**
             * @private
             */
            function onItemUpdateError(errorMessage) {
                notifications.show(errorMessage);
                updateInProgress = false;
            }
            
            function onUpdateItem() {
					if(!validate())
				{
					$(INSTALL_ERROR).text(localizer.getString("hpsum.node.forceOptionSoftwareError"));
					$(INSTALL_ERROR).show();
					return false;
				}
                if (! updateInProgress) {
                    updateInProgress = true;
				
				if(!validateRebootDelay()){
					updateInProgress = false;
					return;
				}
				
				var baselineJson = [];
            	if(($(BASELINES).val() != '' ) && ($(HOTFIX).val() != '')){
					baselineJson.push($(BASELINES).val());
            		baselineJson.push($(HOTFIX).val());
            	}else if($(BASELINES).val() == ''){
            		baselineJson.push($(HOTFIX).val());
            	}else {
            		baselineJson.push($(BASELINES).val());
            	}
				
				var errorFound = false; 
				for (var tmp = 0; tmp < baselineJson.length; tmp++) {
					if(baselineJson[tmp]){
						var baselinedetails = presenter.getBaselineDetailsforId(baselineJson[tmp]);
						if(!baselinedetails) {
							errorFound = true;
							if(baselineJson[tmp] == $(BASELINES).val()){
								$(BASELINE_INPUT_ERR).text(localizer.getString('hpsum.node.invalidBaseline'));	
								$(BASELINE_INPUT).addClass("hp-error");
								$(BASELINE_INPUT_ERR).show();
							}
							if(baselineJson[tmp] == $(HOTFIX).val()){
								$('#hpsum-node-edit-msg-container').removeClass("hp-empty");
								$(HOTFIX_INPUT_ERR).text(localizer.getString('hpsum.node.invalidAdtPackage'));	
								$(HOTFIX_INPUT).addClass("hp-error");
								$(HOTFIX_INPUT_ERR).show();
							}
						}	
					}
				}
				// Return if the baseline or additional package is invalid
				if(errorFound){
					updateInProgress = false;
					return;
				}
				//var auto_add_assoc_nodes;
				var nodeType = $(TYPE).val().toLowerCase();
				if(nodeType.match(/virtual_connect|sas_switch|oa|switch|ilo/i)){
					if($(ADD_ASSOC_NODES).is(':checked'))
						auto_add_assoc_nodes = true;
					else
						auto_add_assoc_nodes = false;
				}
				//node_skip will keep a track of selected option set for HP SUM behaviour if active update process is detected on the remote node
				node_skip = $("input[name='hpsum-node-edit-active']:checked").val();
				if (node_skip == "one")
					node_skip = true;
				else
					node_skip = false;
                     editOptions =  {
                    	hapi: {
                    	username : $(USERNAME).val(),
                    	password : $(PASSWORD).val(),
                    	description : $(DESCRIPTION).val(),
						su_username : $(LINUXUSERNAME).val(),
						su_password : $(LINUXPASSWORD).val(),
						use_sudo : useSudoCredentials,
						auto_add_assoc_nodes : auto_add_assoc_nodes,
						node_skip : node_skip
                    	}
                    };
					
					if (newbaseline=='' && newhotfix=='')
					{
						editOptions.hapi.baselines = {remove_existing_baselines:'true'};
					}
                    
                    if( (currentbaseline != newbaseline) || (currenthotfixbaseline != newhotfix))  //something got changed
                    {
                        var baselinestosend = [];
                        if(newbaseline){
                            if(newbaseline.id != 'none') {
                                baselinestosend.push(newbaseline.id);
                            }
                        } else {
                                baselinestosend.push(currentbaseline.id); // This was not set so we will go back to the old baseline
                        }
                        if(newhotfix) { 
                            if(newhotfix.id != 'none') {
                                baselinestosend.push(newhotfix.id);
                            }
                        }
                        else{
                            baselinestosend.push(currenthotfixbaseline.id); // This was not set so we will go back to the old hotfix baseline
                        }
                        if(baselinestosend.length > 0 ){
                            editOptions.hapi.baselines = {remove_existing_baselines:'false'};
                            editOptions.hapi.baselines.baseline = baselinestosend;
                        } else {
                        	//editOptions.hapi.baselines = {remove_existing_baselines:'false'};
                            if(!nodeItem.node_state.match(/idle/i)) {
                                //If the node is not idle we need to have a valid baseline
                                $("<div></div>").dialog( {
                                buttons: { "Ok": function () {
                                    $(this).dialog("close");
                                    }
                                },
                                close: function (event, ui) { $(this).remove(); },
                                resizable: false,
                                title: "Edit",
                                modal: true
                                }).text("Please select a Baseline or Additional Package");
                                updateInProgress = false;
                                return;
                            }
                        }
                    } 
                    
                    //Moonshot
                    var switchAUser, switchAPassword, switchAEnablePwd;
                    var switchBUser, switchBPassword, switchBEnablePwd;
                    
                    if(nodeType.match(/moonshot/i)) {
                        editOptions.hapi.username = $('#hpsum-moonshot-admin-credentials-username').val();
                        editOptions.hapi.password = $('#hpsum-moonshot-admin-credentials-password').val();
                    
                        switchAUser = $('#hpsum-moonshot-switch-credentials-username').val();
                        switchAPassword = $('#hpsum-moonshot-switch-credentials-password').val();
                        switchAEnablePwd = $('#hpsum-moonshot-switch-credentials-enablePassword').val();
                        
                        if($('#hpsum-moonshot-switch-same-credentials').is(":checked")) {
                            switchBUser = switchAUser;
                            switchBPassword = switchAPassword;
                            switchBEnablePwd = switchAEnablePwd;
                        } else {
                            switchBUser = $('#hpsum-moonshot-switchB-credentials-username').val();
                            switchBPassword = $('#hpsum-moonshot-switchB-credentials-password').val();
                            switchBEnablePwd = $('#hpsum-moonshot-switchB-credentials-enablePassword').val();
                        }
                        
                        editOptions.hapi.moonshot_switch_credentials = {};
                        if(switchAUser)
                            editOptions.hapi.moonshot_switch_credentials.switch_username = switchAUser;
                        if(switchBUser)
                            editOptions.hapi.moonshot_switch_credentials.switchb_username = switchBUser;
                        if(switchAPassword)
                            editOptions.hapi.moonshot_switch_credentials.switch_password = switchAPassword;
                        if(switchBPassword)
                            editOptions.hapi.moonshot_switch_credentials.switchb_password = switchBPassword;
                        if(switchAEnablePwd)
                            editOptions.hapi.moonshot_switch_credentials.switch_enable = switchAEnablePwd;
                        if(switchBEnablePwd)
                            editOptions.hapi.moonshot_switch_credentials.switchb_enable = switchBEnablePwd;                                                
                    }
                    
                    
                    if(nodeItem.type.match(/virtual_connect|ipdu|sas_switch/i)){
                    	editOptions.hapi.associated_node ={};
                    	editOptions.hapi.associated_node.ip = $(PARTNER_IP_VALUE).val();
            			editOptions.hapi.associated_node.type = partnerType;
            			if(partnerUsername == '' ){
            				partnerUsername= $(PARTNER_USERNAME).val();
            				partnerPassword= $(PARTNER_PASSWORD).val();
            			}
            			editOptions.hapi.associated_node.username = partnerUsername;            		
            			editOptions.hapi.associated_node.password = partnerPassword;
                    	
                    }
                    
                    if(!nodeItem.type.match(/integrityilo|virtual_connect|ipdu/i)){
                   		editOptions.hapi.installation_option ={};
                    	var type = $(INSTALLATIONOPTION).val();
						editOptions.hapi.installation_option.downgrade = false;
                               	editOptions.hapi.installation_option.rewrite   = false;
								  
								  if ( type=="Downgrade") 
									editOptions.hapi.installation_option.downgrade = true;
								  if ( type=="Rewrite") 
									editOptions.hapi.installation_option.rewrite = true;
								  if ( type == "Both")
								  {
									editOptions.hapi.installation_option.downgrade = true;
									editOptions.hapi.installation_option.rewrite   = true;
								  }
						editOptions.hapi.installation_option.firmware = $(FIRMWARECHKBOXCOMP).is(':checked');
						editOptions.hapi.installation_option.software = $(SOFTWARECHKBOXCOMP).is(':checked');
					}
					/*if($(SOFTWARECHKBOXCOMP).is(':checked') || $(FIRMWARECHKBOXCOMP).is(':checked'))
					{
						editOptions.hapi.installation_option.force = true;
					}*/
					if((nodeItem.hasOwnProperty('activate_sfw')) || (nodeItem.type.match(/windows|linux|vmware|hpux/i))){
						editOptions.hapi.reboot_options ={};	
						editOptions.hapi.reboot_options.action = $(REBOOTOPTION).val();
						editOptions.hapi.reboot_options.delay = $(DELAYSEC).val();				
						editOptions.hapi.reboot_options.message = $(DELAYMSG).val();
					}
					/*if(nodeItem.type.match(/windows|linux|hpux/i)){
						editOptions.hapi.os_management_options='';
						if($(NONECHECKBOX).attr('checked'))
							editOptions.hapi.os_management_options = "None";
						else {
							if($(USESNMPCHECKBOX).attr('checked'))
								editOptions.hapi.os_management_options += "SNMP|";						
							if($(USEAGENTLESSCHECKBOX).attr('checked'))
								editOptions.hapi.os_management_options += "AMS|";													
							if($(USEWEBEMCHECKBOX).attr('checked'))
								editOptions.hapi.os_management_options += "WBEM|";
						}
					}*/
					if(nodeItem.type.match(/virtual_connect/i)) {
						editOptions.hapi.vc_activation_options ={};			
			            editOptions.hapi.vc_activation_options.eth_activation_order = $('#hpsum-Enet-order').val();
		    		    editOptions.hapi.vc_activation_options.fc_activation_order = $('#hpsum-fc-order').val();     
						editOptions.hapi.vc_activation_options.eth_activation_delay = $('#hpsum-Enet-delay').val();
						editOptions.hapi.vc_activation_options.fc_activation_delay= $('#hpsum-FC-delay').val();	
					
					}
					var tmp = $(ACTIVATE_SELECTION).val();
					if( tmp == 'NO') {
						editOptions.hapi.activate_sfw = false;
					} else {
						editOptions.hapi.activate_sfw = true;
					}
				
            
                    presenter.setattribute(nodeItem, editOptions, {
                        success : onItemUpdateSuccess,
                        error : onItemUpdateError
                    });
                }
            }
            
			function validateRebootDelay() {
				var rebootopt = $('#hpsum-reboot-option option:selected').val();
				var delaySec = $(DELAYSEC).val();
				var valid = true;
				
				if (rebootopt != "Never") {
					if((isNaN(delaySec) && !isFinite(delaySec)) || 
					  (delaySec < 60 || delaySec > 3600)) {
						$(DELAYSEC).addClass("hp-error");
						$(DELAYSECERR).text(localizer.getString("hpsum.node.rebootDelaySecondsErrMsg"));
						$(DELAYSECERR).show();
						valid = false;       
                    } 
					else {
						$(DELAYSEC).val(parseInt(delaySec));
						$(DELAYSEC).removeClass("hp-error");
						$(DELAYSECERR).hide();
					}
				}
				return valid;
            }
            
            function changeLocation(location) {
                if (location.length > ROUTE_PREFIX.length) {
                    $(PANELS).hpStackedPanels('setPanelByLocation', '#' + location);
                } else {
                    $(PANELS).hpStackedPanels('setFirstPanel');
                }
            }
            
            this.resume = function () {
            	presenter.on('itemChange', onItemChange);
				$(USERNAME).val('');
				$(PASSWORD).val('');
				$('.moonshot').val('');
            	$(TYPE).bind('change', showPartnerOptions);
				$(DELAYSECERR).hide();
				$(DELAYSEC).removeClass('hp-error');
               // presenter.on('searchSuggestionChange', baselinesAvailable);
                $(PANELS).hpStackedPanels('resume');
                presenter.getAllBaselines({
           					success:getBaselinesSuccess,
           					error: getBaselinesError
           			});
            };
            
            this.pause = function () {
            	presenter.off('itemChange', onItemChange);
                $(BASELINES).hpSearchCombo('set', {id:'', name: ''});
                $(HOTFIX).hpSearchCombo('set', {id:'', name: ''});
              	//presenter.off('searchSuggestionChange', baselinesAvailable);
                $(PANELS).hpStackedPanels('pause');
            };
          
          	function baselinesAvailable(data){
    			//data = {count: data.count, members: data};
            	//$(BASELINES).hpSearchCombo({getResults: presenter.getResults});
            }

            function getBaseline(string, handlers, count, start){
                var results=baselines;
                    if (string && string.length > 0) {
                         results =
                            $.grep(baselines, function(option, index) {
                                return (option.name.match(
                                         new RegExp(string, 'i')));
                          });   
                     }
                    handlers.success({count: results.length, members: results, start: 0, total: results.length});
            }
            function getHotfixes(string, handlers, count, start){
                    var results=hotfixes;
                    if (string && string.length > 0) {
                         results =
                            $.grep(hotfixes, function(option, index) {
                                return (option.name.match(
                                         new RegExp(string, 'i')));
                          });   
                     }
                    handlers.success({count: results.length, members: results, start: 0, total: results.length});
            }

            function getBaselinesSuccess(searchResults)
            {
                    baselines = $.grep(searchResults, function (option, index ) {
                        return !(option.name.match(new RegExp('^Additional', 'i')));
                    });
                    hotfixes = $.grep(searchResults, function (option, index) {
                        return (option.name.match(new RegExp('^Additional', 'i')));
                    });
                
            }
            
            function getBaselinesError(msg)
            {
                
            }
          
          
            /**
             * @public
             */
            this.init = function () {
              
				var resource = router.location().split('/');
                	resource = resource[1];
				$('#hpsum-node-edit-namehelp').attr('tooltip', localizer.getString('hpsum.common.ipDnshelpedit')).hpTooltip();
				$('#hpsum-node-edit-additionalpackagehelp').attr('tooltip', localizer.getString('hpsum.node.additionalPackageshelp')).hpTooltip();
				$('#hpsum-node-addassocnodes').attr('tooltip', localizer.getString('hpsum.common.typetoaddhelp')).hpTooltip();
				$('#hpsum-installation-options-collapsible').attr('tooltip', localizer.getString('hpsum.node.installationOptionshelp')).hpTooltip();
              	$('a[data-panel-id]').each(function(index) {
                		var currentLink = $(this).attr('href');
                		if(currentLink  == undefined)
                			return;
                		var current = currentLink.split('/');
                		current[1] = resource;
                		currentLink =current.join('/');
                		$(this).attr('href',currentLink);
  					});
  					ROUTE_PREFIX = '/'+ resource +'/edit';
               		$('#hpsum-node-edit-close').click(function () {
                    router.go(urlFragment.replaceView(router.location(), 'show'));
                });
                
				//By Default reboot-options value is Never so disable the Reboot delay and Reboot message.
				$(".hpsum-otu-node-edit-disable").find('input,textarea,select,button').prop("disabled", true);
				$('#hpsum-downgrade-rewrite-text').html(localizer.getString("hpsum.node.installationMessage"));
				$('#hpsum-downgrade-rewrite-text').removeClass('hp-collapsed');
				$(FIRMWARECHKBOXCOMP).bind('change', errormsg);
				$(INSTALL_ERROR).hide();
					$(SOFTWARECHKBOXCOMP).bind('change', errormsg);
				$("#hpsum-installation-option").change(function() {
					var type = $(INSTALLATIONOPTION).val();
					if (type == "None")
					{
						$('#hp-force-downgrade-rewrite').hide();
						$(FIRMWARECHKBOXCOMP).attr('checked', false);							
						$(SOFTWARECHKBOXCOMP).attr('checked', false);
					}
					else
						$('#hp-force-downgrade-rewrite').show();
						$(INSTALL_ERROR).hide();
					
				});
				$(INSTALLATIONOPTION).selectBox({autoWidth: false});
				
				$("#hpsum-reboot-option").change(function() {
					var type = $('#hpsum-reboot-option option:selected').val();
					if (type == "Never") {
					$(".hpsum-otu-node-edit-disable").find('input,textarea,select,button').prop("disabled", true);
					$(DELAYSEC).val('');
					$(DELAYSEC).removeClass("hp-error");
					$(DELAYSECERR).hide();
					}
					else
					{
					$(".hpsum-otu-node-edit-disable").find('input,textarea,select,button').prop("disabled", false);
					}
				});
				
				$(DELAYSEC).unbind('keyup').bind('keyup', function(){
					$(DELAYSECERR).hide();
					$(DELAYSEC).removeClass('hp-error');
				}); 
				
				$(DELAYSEC).bind('change', function(){
					$(DELAYSECERR).hide();
					$(DELAYSEC).removeClass('hp-error');
				}); 
				
                   $(PANELS).hpStackedPanels({
                    	panelSelector : PANEL_SELECTOR
                	});
					
				if ((navigator.appVersion.indexOf("X11")!=-1) ||
				   (navigator.appVersion.indexOf("Linux")!=-1)) { 
				        $('#hpsum-node-type option[value="windows"]').remove();
					    $(TYPE).selectBox('reset');
				    }	
					  
                $(TYPE).selectBox({autoWidth: false});
                formStateView.init({form: FORM,
                    routePattern: ROUTE_PREFIX + '.*',
                    autoTrack: true});

                $(BASELINES).hpSearchCombo({getResults: getBaseline});

                $(HOTFIX).hpSearchCombo({getResults: getHotfixes});

                $(BASELINES).change(function (ev, value) {
                    var item = presenter.getBaselineDetailsforId(value);
                    if(item){
                        newbaseline = item;
                        $(CURRENT_BASELINE).text(newbaseline.name);
                    } else {
                    	newbaseline='';                        
                        $(CURRENT_BASELINE).text('');                        
                    }
					if(!setOk){
						$(BASELINE_INPUT_ERR).hide();
						$(BASELINE_INPUT).removeClass('hp-error');
					}
					setOk = false;
                });

                $(HOTFIX).change(function (ev, value) {
                    var item = presenter.getBaselineDetailsforId(value);
                    if(item){
                        newhotfix = item;
                        $(CURRENT_HOTFIX).text(newhotfix.name);
                    } else {
                    	newhotfix='';
                        $(CURRENT_HOTFIX).text('');  
                    }
					if(!setOk){
						$(HOTFIX_INPUT_ERR).hide();
						$(HOTFIX_INPUT).removeClass('hp-error');
					}
					setOk = false;
                });
				
				$(BASELINE_INPUT).unbind('keyup').bind('keyup',function(){
					$(BASELINE_INPUT_ERR).hide();
					$(BASELINE_INPUT).removeClass('hp-error');
				});
				
				$(HOTFIX_INPUT).unbind('keyup').bind('keyup',function(){
					$(HOTFIX_INPUT_ERR).hide();
					$(HOTFIX_INPUT).removeClass('hp-error');
				});	

              	presenter.getAllBaselines({
           					success:getBaselinesSuccess,
           					error: getBaselinesError
           			});
                
                $(OK).on('click', function(ev) {
					setOk = true;
                    onUpdateItem();
                    ev.preventDefault();
                });
                
                //Moonshot
                $('#hpsum-moonshot-switch-same-credentials').click(function(){
                    $('#hpsum-moonshot-switchB-credentials').toggle();
                });
                
                $('.hp-collapsible').hpCollapsible();
				$('input[name="hpsum-linux-node-credential"]').click(linuxCredentialOptions);
                router.watch('node edit section', ROUTE_PREFIX + '.*',
                    {parent: ROUTE_PREFIX, change: changeLocation});
                showPartnerOptions();
                this.resume();
            };
       }
	
	return NodeEditView;

			
		}());

	return new NodeEditView();
	

});
